; $Id: cvtfromsec1996.pro,v 1.2 1998/05/04 19:34:30 rgr Exp $

; $RCSfile: cvtfromsec1996.pro,v $
; $Author: rgr $
; $Date: 1998/05/04 19:34:30 $
; $Revision: 1.2 $

; CvtFromSec1996
;
; This function takes a set of times expresed in seconds of year of
; 1996 and returns a set of AceTime structures.


; Arguments
;   time = set of times to be converted - input


; Procedures used
;   InitTabSec1996


function CvtFromSec1996, sec1996

   common SbCvtFromSec1996,  MonthTable, MonthTableSize, SecTypicalMonth

   ; If the month table that holds the number of seconds since 1996
   ; has not been initialized, then initialize it before proceeding.

   if (n_elements(MonthTable) eq 0) then begin
      inittabsec1996, MonthTable
      MonthTableSize = n_elements(MonthTable)
      SecTypicalMonth = ((4*365 + 366) * 86400)/(5*12)
   endif
   
   time = replicate({AceTime}, n_elements(sec1996))
   
   ; Find the months in which the time falls
   
   month = sec1996/SecTypicalMonth
   index = where((month lt 1), ncount)
   if (ncount gt 0) then month[index] = 1
   index = where((month gt (MonthTableSize-2)), ncount)
   if (ncount gt 0) then month[index] = MonthTableSize - 2
   index = where ((sec1996 lt MonthTable(month)), ncount)
   if (ncount gt 0) then month[index] = month[index] - 1
   index = where ((sec1996 ge MonthTable(month+1)), ncount)
   if (ncount gt 0) then month[index] = month[index] + 1
   
   ; Convert the time in seconds of 1996 to (yr,month,day,hr,min,sec)
   
   seconds = sec1996 - MonthTable(month)
   time.year =  month/12 + 1996L
   time.month = (month mod 12) + 1L
   time.day = seconds/86400L + 1L
   time.hour = (seconds/3600L) mod 24
   time.min = (seconds/60L) mod 60
   time.sec = seconds mod 60

   ; Adjustment for June leap seconds

   index = where ((time.month eq 6L) and (time.day eq 31L), ncount)
   if (ncount gt 0) then begin
      time[index].day = time[index].day - 1L
      time[index].hour = time[index].hour + 24L
   endif

   ; Adjustment for December leap seconds

   index = where ((time.month eq 12L) and (time.day eq 32L), ncount)
   if (ncount gt 0) then begin
      time[index].day = time[index].day - 1L
      time[index].hour = time[index].hour + 24L
   endif
   
   return, time
end
