; $Id: cvttosec1996_yd.pro,v 1.1 1998/01/26 17:51:07 rgr Exp $

; $RCSfile: cvttosec1996_yd.pro,v $
; $Author: rgr $
; $Date: 1998/01/26 17:51:07 $
; $Revision: 1.1 $

; CvtToSec1996_yd
;
; This function takes a set of times stored in the AceTime_yd data
; structures and returns a set of times expressed in seconds since
; 00:00:00 of January 1, 1996.


; Arguments
;   time = set of time structures to be converted - input


; Procedures used
;    CvtFromSec1996
;    CvtToSec1996


function CvtToSec1996_yd, time

   fraction = time.day - long(time.day)
   t = replicate({AceTime}, n_elements(time))
   t.year = time.year
   t.month = 1L
   t.day = 1L
   t.hour = 0L
   t.min = 0L
   t.sec = 0L
   sec = CvtToSec1996(t) + 86400*long(time.day) - 43200
   t = CvtFromSec1996(sec)
   t.hour = 0L
   t.min = 0L
   t.sec = 0L
   sec1996 = CvtToSec1996(t) + long(86400.0D0*fraction + 0.5D0) 

   return, sec1996
end
