; $Id: compressdumpsegment.pro,v 1.1 1998/07/27 13:30:48 rgr Exp $

; $RCSfile: compressdumpsegment.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 13:30:48 $
; $Revision: 1.1 $

; This function returns the compressed name of the segment.  The
; compressed name of the segment is generated from the segment by
; replacing any macro values with blanks and then removing all 
; blanks from the segment.
;
;
;  Arguments
;     segment = segment to be compressed-(input)
;     macroDelimiters = macro delimiters used in the segment-(input)

 
function compressDumpSegment, segment, macroDelimiter

   blankArray = bytarr(strlen(segment), /nozero)
   blankArray[*] = '20'XB
   blankString = string(blankArray)

   seg = segment
   mark0 = strpos(seg, macroDelimiter[0], 0)
   while (mark0 ge 0) do begin
      mark1 = strpos(seg, macroDelimiter[1], mark0)
      blanks = strmid(blankString, mark0 + 1, (mark1 - mark0) -1)
      strput, seg, blanks, mark0 + 1
      mark0 = strpos(seg, macroDelimiter[0], mark1)
   endwhile
   seg = strcompress(seg, /remove_all)

   return, seg
end
