; $Id: fetchcristimehistory.pro,v 1.2 1998/05/04 19:56:52 rgr Exp $

; $RCSfile: fetchcristimehistory.pro,v $
; $Author: rgr $
; $Date: 1998/05/04 19:56:52 $
; $Revision: 1.2 $

pro FetchCrisTimeHistory, request,                 $
                          sec1996_0,               $
                          sec1996_1,               $
                          sec1996,                 $
                          value,                   $
                          quality,                 $
                          title,                   $
                          units,                   $
                          ndata

   ndata = 0
   case strupcase(request.structure) of

     'L1CRISLOWPRIORITYRATE' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1CrisLowPriorityRateUnits, field, units
            FetchL1CrisLowPriorityRateField, field, sec1996_0,         $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'NUMBEREVENTS') eq 0) then    $
               field = 'NumberEvents'
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1CrisLowPriorityRateField, field, sec1996_0,   $
                                             sec1996_1, quality, dummy
            endif
            FetchL1CrisLowPriorityRateField, 'Second1996', sec1996_0,  $
                                            sec1996_1, sec1996, dummy
         end

     'L1_1CRISLOWPRIORITYRATE' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1_1CrisLowPriorityRateUnits, field, units
            FetchL1_1CrisLowPriorityRateField, field, sec1996_0,       $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1_1CrisLowPriorityRateField, field, sec1996_0, $
                                             sec1996_1, quality, dummy
            endif
            FetchL1_1CrisLowPriorityRateField, 'Second1996',           $
                                  sec1996_0, sec1996_1, sec1996, dummy
         end

     'L1CRISHSKP' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1CrisHskpUnits, field, units
            FetchL1CrisHskpField, field, sec1996_0,                    $
                                               sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1CrisHskpField, field, sec1996_0,              $
                                             sec1996_1, quality, dummy
            endif
            FetchL1CrisHskpField, 'Second1996', sec1996_0, $
                                            sec1996_1, sec1996, dummy
         end

     'L1_1CRISHSKP' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1_1CrisHskpUnits, field, units
            FetchL1_1CrisHskpField, field, sec1996_0,                  $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1_1CrisHskpField, field, sec1996_0,            $
                                             sec1996_1, quality, dummy
            endif
            FetchL1_1CrisHskpField, 'Second1996', sec1996_0,           $
                                            sec1996_1, sec1996, dummy
         end

     'L1CRISSUMMARY' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1CrisSummaryUnits, field, units
            FetchL1CrisSummaryField, field, sec1996_0,                 $
                                                sec1996_1, value, ndata
            if (ndata eq 0) then return
            FetchL1CrisSummaryField, 'quality', sec1996_0,             $
                                             sec1996_1, quality, dummy
            FetchL1CrisSummaryField, 'Second1996', sec1996_0,          $
                                            sec1996_1, sec1996, dummy
            fieldname = strupcase(request.field)
            if ((fieldname eq 'MAINBUSVOLTAGE')           or $
                (fieldname eq 'CRISCURRENT')              or $
                (fieldname eq 'CRISINTERNALTEMPERATURE1') or $
                (fieldname eq 'CRISINTERNALTEMPERATURE2') or $
                (fieldname eq 'CRISINTERFACETEMPERATURE')) then begin
               index = where(value ne 'ff'XB, ndata)
               if (ndata eq 0) then return
               value = value(index)
               quality = quality(index)
               sec1996 = sec1996(index)
            endif
         end

     'L1_1CRISSUMMARY' : Begin
            field = request.field
            title= 'CRIS ' + field
            FetchL1_1CrisSummaryUnits, field, units
            FetchL1_1CrisSummaryField, field, sec1996_0,               $
                                                sec1996_1, value, ndata
            if (ndata eq 0) then return
            FetchL1_1CrisSummaryField, 'quality', sec1996_0,           $
                                             sec1996_1, quality, dummy
            FetchL1_1CrisSummaryField, 'Second1996', sec1996_0,        $
                                            sec1996_1, sec1996, dummy
            fieldname = strupcase(request.field)
            if ((fieldname eq 'MAINBUSVOLTAGE')           or $
                (fieldname eq 'CRISCURRENT')              or $
                (fieldname eq 'CRISINTERNALTEMPERATURE1') or $
                (fieldname eq 'CRISINTERNALTEMPERATURE2') or $
                (fieldname eq 'CRISINTERFACETEMPERATURE')) then begin
               index = where(finite(value), ndata)
               if (ndata eq 0) then return
               value = value(index)
               quality = quality(index)
               sec1996 = sec1996(index)
            endif
         end

      else: print, 'Unrecognized structure: ', request.structure
   endcase

end    
