; $Id: checkcriscompressedevents.pro,v 1.1 1998/01/26 17:54:57 rgr Exp $

; $RCSfile: checkcriscompressedevents.pro,v $
; $Author: rgr $
; $Date: 1998/01/26 17:54:57 $
; $Revision: 1.1 $

function CheckCrisCompressedEvents, telemetry, index

   common CrisSymbols

   nevent = n_elements(index)
   event = replicate({ce_crisEvt}, nevent)

   ; Unpack the compressed event header
   
   event.nbytes        = telemetry(index + 0)
   event.stim          = ishft(telemetry(index + 1) , -7)
   event.G1            = ishft(telemetry(index + 2), -3) and '07'XB
   event.R1            = (telemetry(index + 2) and '07'XB) + 2B
   event.got_2nd_tel   = ishft(telemetry(index + 3), -7)
   event.got_guard     = ishft(telemetry(index + 3), -6) and '01'XB
   event.nblobs        = telemetry(index + 3) and '1f'XB
   
   ; Unpack the second telescope header

   event.G2 = 0B
   event.R2 = 0B

   ; Get the length of the headers

   length = bytarr(nevent, /nozero)
   length(*) = 6B
   set = where(event.got_2nd_tel ne 0B, ncount)
   if (ncount gt 0) then begin
      if (ncount eq 1) then set = set(0)
      event(set).G2 = ishft(telemetry(index(set) + 6), -3) and '07'XB
      event(set).R2 = (telemetry(index(set) + 6) and '07'XB) + 2B
      length(set) = length(set) + 1B
   endif

   ; Add the length of the components

   length = length + 3B*event.nblobs
   length = length + 2B
   length = length + (12B*(event.R1 + 1B) + 4B)/8B 
   set = where(event.got_guard ne 0B, ncount)
   if (ncount ne 0) then begin
      if (ncount eq 1) then set = set(0)
      length(set) = length(set) + 2B*event(set).G1 + $
                                  2B*event(set).G2
   endif
   set = where(event.got_2nd_tel ne 0B, ncount)
   if (ncount ne 0) then begin
      if (ncount eq 1) then set =set(0)
      length(set) = length(set) + 2B
      length(set) = length(set) + (12B*(event(set).R2 + 1B) + 4B)/8B
   endif
   set = where(event.stim ne 0B, ncount)
   if (ncount ne 0) then length(set) = length(set) + 4B

   ; Check the events for self-consistency in length

   valid = bytarr(nevent)
   set = where(event.nbytes ne length, ncount)
   if (ncount gt 0) then valid(set) = 1B
   set = where(event.G1 gt G$_Cris.CeNGuards, ncount)
   if (ncount gt 0) then valid(set) = 1B
   set = where(event.G2 gt G$_Cris.CeNGuards, ncount)
   if (ncount gt 0) then valid(set) = 1B

   return, valid
end
