;  $Id: computecrissinglerates.pro,v 1.3 1998/07/27 13:56:27 rgr Exp $

;  $RCSfile: computecrissinglerates.pro,v $
;  $Author: rgr $
;  $Date: 1998/07/27 13:56:27 $
;  $Revision: 1.3 $

pro computeCrisSingleRates, lp, engr

   common CrisSymbols

   livetim = double(engr.livetim) > 1.0d-6
   nrtproc = double(engr.nrtproc) > (1.0D / G$_Cris.NumMnfsPerCycle)

   factor = double(engr.nhdwrej) / (nrtproc * livetim)

   engr.stmco    = float(factor * lp.stmco)
   engr.stmoff   = float(factor * lp.stmoff)
   engr.z1ab     = float(factor * lp.z1ab)
   engr.z2ab     = float(factor * lp.z2ab)
   engr.z_gt_2ab = float(factor * lp.z_gt_2ab)
   engr.z1cd     = float(factor * lp.z1cd)
   engr.z2cd     = float(factor * lp.z2cd)
   engr.z_gt_2cd = float(factor * lp.z_gt_2cd)
   engr.hazard   = float(factor * lp.hazard)
   engr.gh       = float(factor * lp.gh)
   engr.mor      = float(factor * lp.mor)
   engr.hor      = float(factor * lp.hor)
   engr.adc2ab   = float(factor * lp.adc2ab)
   engr.mnrgab   = float(factor * lp.mnrgab)
   engr.adc2cd   = float(factor * lp.adc2cd)
   engr.mnrgcd   = float(factor * lp.mnrgcd)
   engr.e1a      = float(factor * lp.e1a)
   engr.e1b      = float(factor * lp.e1b)
   engr.e2ab     = float(factor * lp.e2ab)
   engr.e3ab     = float(factor * lp.e3ab)
   engr.e4ab     = float(factor * lp.e4ab)
   engr.e5ab     = float(factor * lp.e5ab)
   engr.e6ab     = float(factor * lp.e6ab)
   engr.e7ab     = float(factor * lp.e7ab)
   engr.e8ab     = float(factor * lp.e8ab)
   engr.e9ab     = float(factor * lp.e9ab)
   engr.g2ab     = float(factor * lp.g2ab)
   engr.g3ab     = float(factor * lp.g3ab)
   engr.g4ab     = float(factor * lp.g4ab)
   engr.g5ab     = float(factor * lp.g5ab)
   engr.g6ab     = float(factor * lp.g6ab)
   engr.g7ab     = float(factor * lp.g7ab)
   engr.e1c      = float(factor * lp.e1c)
   engr.e1d      = float(factor * lp.e1d)
   engr.e2cd     = float(factor * lp.e2cd)
   engr.e3cd     = float(factor * lp.e3cd)
   engr.e4cd     = float(factor * lp.e4cd)
   engr.e5cd     = float(factor * lp.e5cd)
   engr.e6cd     = float(factor * lp.e6cd)
   engr.e7cd     = float(factor * lp.e7cd)
   engr.e8cd     = float(factor * lp.e8cd)
   engr.e9cd     = float(factor * lp.e9cd)
   engr.g2cd     = float(factor * lp.g2cd)
   engr.g3cd     = float(factor * lp.g3cd)
   engr.g4cd     = float(factor * lp.g4cd)
   engr.g5cd     = float(factor * lp.g5cd)
   engr.g6cd     = float(factor * lp.g6cd)
   engr.g7cd     = float(factor * lp.g7cd)

   quality = engr.QualityNhdwrej or engr.QualityNrtproc  $
                                 or engr.QualityLivetim

   engr.QualityStmco    = quality or lp.QualityStmco
   engr.QualityStmoff   = quality or lp.QualityStmoff
   engr.QualityZ1ab     = quality or lp.QualityZ1ab
   engr.QualityZ2ab     = quality or lp.QualityZ2ab
   engr.QualityZ_gt_2ab = quality or lp.QualityZ_gt_2ab
   engr.QualityZ1cd     = quality or lp.QualityZ1cd
   engr.QualityZ2cd     = quality or lp.QualityZ2cd
   engr.QualityZ_gt_2cd = quality or lp.QualityZ_gt_2cd
   engr.QualityHazard   = quality or lp.QualityHazard
   engr.QualityGh       = quality or lp.QualityGh
   engr.QualityMor      = quality or lp.QualityMor
   engr.QualityHor      = quality or lp.QualityHor
   engr.QualityAdc2ab   = quality or lp.QualityAdc2ab
   engr.QualityMnrgab   = quality or lp.QualityMnrgab
   engr.QualityAdc2cd   = quality or lp.QualityAdc2cd
   engr.QualityMnrgcd   = quality or lp.QualityMnrgcd
   engr.QualityE1a      = quality or lp.QualityE1a
   engr.QualityE1b      = quality or lp.QualityE1b
   engr.QualityE2ab     = quality or lp.QualityE2ab
   engr.QualityE3ab     = quality or lp.QualityE3ab
   engr.QualityE4ab     = quality or lp.QualityE4ab
   engr.QualityE5ab     = quality or lp.QualityE5ab
   engr.QualityE6ab     = quality or lp.QualityE6ab
   engr.QualityE7ab     = quality or lp.QualityE7ab
   engr.QualityE8ab     = quality or lp.QualityE8ab
   engr.QualityE9ab     = quality or lp.QualityE9ab
   engr.QualityG2ab     = quality or lp.QualityG2ab
   engr.QualityG3ab     = quality or lp.QualityG3ab
   engr.QualityG4ab     = quality or lp.QualityG4ab
   engr.QualityG5ab     = quality or lp.QualityG5ab
   engr.QualityG6ab     = quality or lp.QualityG6ab
   engr.QualityG7ab     = quality or lp.QualityG7ab
   engr.QualityE1c      = quality or lp.QualityE1c
   engr.QualityE1d      = quality or lp.QualityE1d
   engr.QualityE2cd     = quality or lp.QualityE2cd
   engr.QualityE3cd     = quality or lp.QualityE3cd
   engr.QualityE4cd     = quality or lp.QualityE4cd
   engr.QualityE5cd     = quality or lp.QualityE5cd
   engr.QualityE6cd     = quality or lp.QualityE6cd
   engr.QualityE7cd     = quality or lp.QualityE7cd
   engr.QualityE8cd     = quality or lp.QualityE8cd
   engr.QualityE9cd     = quality or lp.QualityE9cd
   engr.QualityG2cd     = quality or lp.QualityG2cd
   engr.QualityG3cd     = quality or lp.QualityG3cd
   engr.QualityG4cd     = quality or lp.QualityG4cd
   engr.QualityG5cd     = quality or lp.QualityG5cd
   engr.QualityG6cd     = quality or lp.QualityG6cd
   engr.QualityG7cd     = quality or lp.QualityG7cd
end
