; $Id: cvtcrisadctoleakagecurrent.pro,v 1.2 1998/07/27 13:57:12 rgr Exp $

; $RCSfile: cvtcrisadctoleakagecurrent.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 13:57:12 $
; $Revision: 1.2 $

function cvtCrisAdcToLeakageCurrent, AdcNumber, adc, dac

   common CrisSymbols
   common SbCvtCrisAdcToLeakageCurrent, slope, offset, CtlVolt, $
          ScaleFactor

   if (n_elements(slope) eq 0) then begin

      slope = dblarr(G$_Cris.adc.number)
      offset = dblarr(G$_Cris.adc.number)
      CtlVolt = dblarr(G$_Cris.adc.number)
      ScaleFactor = dblarr(G$_Cris.adc.number)

      E1A  = G$_Cris.adc.PostDcE1a   &  E1C  = G$_Cris.adc.PostDcE1c
      E1B  = G$_Cris.adc.PostDcE1b   &  E1D  = G$_Cris.adc.PostDcE1d
      E2AB = G$_Cris.adc.PostDcE2ab  &  E2CD = G$_Cris.adc.PostDcE2cd
      E3AB = G$_Cris.adc.PostDcE3ab  &  E3CD = G$_Cris.adc.PostDcE3cd
      E4AB = G$_Cris.adc.PostDcE4ab  &  E4CD = G$_Cris.adc.PostDcE4cd
      E5AB = G$_Cris.adc.PostDcE5ab  &  E5CD = G$_Cris.adc.PostDcE5cd
      E6AB = G$_Cris.adc.PostDcE6ab  &  E6CD = G$_Cris.adc.PostDcE6cd
      E7AB = G$_Cris.adc.PostDcE7ab  &  E7CD = G$_Cris.adc.PostDcE7cd
      E8AB = G$_Cris.adc.PostDcE8ab  &  E8CD = G$_Cris.adc.PostDcE8cd
      E9AB = G$_Cris.adc.PostDcE9ab  &  E9CD = G$_Cris.adc.PostDcE9cd
      G2AB = G$_Cris.adc.PostDcG2ab  &  G2CD = G$_Cris.adc.PostDcG2cd
      G3AB = G$_Cris.adc.PostDcG3ab  &  G3CD = G$_Cris.adc.PostDcG3cd
      G4AB = G$_Cris.adc.PostDcG4ab  &  G4CD = G$_Cris.adc.PostDcG4cd
      G5AB = G$_Cris.adc.PostDcG5ab  &  G5CD = G$_Cris.adc.PostDcG5cd
      G6AB = G$_Cris.adc.PostDcG6ab  &  G6CD = G$_Cris.adc.PostDcG6cd
      G7AB = G$_Cris.adc.PostDcG7ab  &  G7CD = G$_Cris.adc.PostDcG7cd

      slope[E1A ]=0.0923D & offset[E1A ]=-0.4604D & CtlVolt[E1A ]= 6.0D
      slope[E1B ]=0.0922D & offset[E1B ]=-0.4507D & CtlVolt[E1B ]= 6.0D
      slope[E1C ]=0.0921D & offset[E1C ]=-0.4659D & CtlVolt[E1C ]= 6.0D
      slope[E1D ]=0.0926D & offset[E1D ]=-0.4656D & CtlVolt[E1D ]= 6.0D
      slope[E2AB]=0.0917D & offset[E2AB]=-0.4535D & CtlVolt[E2AB]=12.0D
      slope[E2CD]=0.0923D & offset[E2CD]=-0.4664D & CtlVolt[E2CD]=12.0D
      slope[E3AB]=0.2325D & offset[E3AB]=-0.5217D & CtlVolt[E3AB]=12.0D
      slope[E3CD]=0.2311D & offset[E3CD]=-0.5213D & CtlVolt[E3CD]=12.0D
      slope[E4AB]=0.2343D & offset[E4AB]=-0.5195D & CtlVolt[E4AB]=12.0D
      slope[E4CD]=0.2342D & offset[E4CD]=-0.5319D & CtlVolt[E4CD]=12.0D
      slope[E5AB]=0.2349D & offset[E5AB]=-0.5252D & CtlVolt[E5AB]=12.0D
      slope[E5CD]=0.2331D & offset[E5CD]=-0.5313D & CtlVolt[E5CD]=12.0D
      slope[E6AB]=0.2335D & offset[E6AB]=-0.5294D & CtlVolt[E6AB]=12.0D
      slope[E6CD]=0.2341D & offset[E6CD]=-0.5400D & CtlVolt[E6CD]=12.0D
      slope[E7AB]=0.2334D & offset[E7AB]=-0.5381D & CtlVolt[E7AB]=12.0D
      slope[E7CD]=0.2350D & offset[E7CD]=-0.5166D & CtlVolt[E7CD]=12.0D
      slope[E8AB]=0.2351D & offset[E8AB]=-0.5251D & CtlVolt[E8AB]=12.0D
      slope[E8CD]=0.2342D & offset[E8CD]=-0.5156D & CtlVolt[E8CD]=12.0D
      slope[E9AB]=5.2911D & offset[E9AB]= 1.0582D & CtlVolt[E9AB]= 0.0D
      slope[E9CD]=5.2911D & offset[E9CD]= 1.0692D & CtlVolt[E9CD]= 0.0D
      slope[G2AB]=5.2911D & offset[G2AB]= 0.8908D & CtlVolt[G2AB]= 0.0D
      slope[G2CD]=5.2911D & offset[G2CD]= 0.8427D & CtlVolt[G2CD]= 0.0D
      slope[G3AB]=5.2911D & offset[G3AB]= 2.2739D & CtlVolt[G3AB]= 0.0D
      slope[G3CD]=5.2911D & offset[G3CD]= 2.3594D & CtlVolt[G3CD]= 0.0D
      slope[G4AB]=5.2911D & offset[G4AB]= 2.4014D & CtlVolt[G4AB]= 0.0D
      slope[G4CD]=5.2911D & offset[G4CD]= 2.4213D & CtlVolt[G4CD]= 0.0D
      slope[G5AB]=5.2911D & offset[G5AB]= 2.3127D & CtlVolt[G5AB]= 0.0D
      slope[G5CD]=5.2911D & offset[G5CD]= 2.3309D & CtlVolt[G5CD]= 0.0D
      slope[G6AB]=5.2911D & offset[G6AB]= 2.2971D & CtlVolt[G6AB]= 0.0D
      slope[G6CD]=5.2911D & offset[G6CD]= 2.3396D & CtlVolt[G6CD]= 0.0D
      slope[G7AB]=5.2911D & offset[G7AB]= 2.3363D & CtlVolt[G7AB]= 0.0D
      slope[G7CD]=5.2911D & offset[G7CD]= 2.2620D & CtlVolt[G7CD]= 0.0D

      Rf308 =  2000.0D  &  Rpostin308 = 2550.0D
      Rf309 =  1330.0D  &  Rpostin309 = 2550.0D
      Rf310 = 29400.0D  &  Rpostin310 = 2490.0D
      Rf311 = 29400.0D  &  Rpostin311 = 2490.0D
      Rf312 = 29400.0D  &  Rpostin312 = 2490.0D

      ScaleFactor[E1A ] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E1B ] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E1C ] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E1D ] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E2AB] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E2CD] = ((Rpostin308 / Rf308) / 20300.0D) * (-1.0d6)
      ScaleFactor[E3AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E3CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E4AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E4CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E5AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E5CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E6AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E6CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E7AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E7CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E8AB] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E8CD] = ((Rpostin309 / Rf309) / 20300.0D) * (-1.0d6)
      ScaleFactor[E9AB] = ((Rpostin310 / Rf310) / 20300.0D) * (-1.0d6)
      ScaleFactor[E9CD] = ((Rpostin310 / Rf310) / 20300.0D) * (-1.0d6)
      ScaleFactor[G2AB] = ((Rpostin311 / Rf311) / 20300.0D) * (-1.0d6)
      ScaleFactor[G2CD] = ((Rpostin311 / Rf311) / 20300.0D) * (-1.0d6)
      ScaleFactor[G3AB] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G3CD] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G4AB] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G4CD] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G5AB] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G5CD] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G6AB] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G6CD] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G7AB] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
      ScaleFactor[G7CD] = ((Rpostin312 / Rf312) / 20300.0D) * (-1.0d6)
   endif

   if (n_elements(dac) eq 0) then                              $
      ControlVoltage = CtlVolt[AdcNumber]                      $
   else                                                        $
      ControlVoltage = double(cvtCrisDacToControlVoltage(dac))

   ScaledVoltage = cvtCrisAdcToScaledVoltage(adc)
   PostdcBaseline = (ControlVoltage * slope[AdcNumber]) +              $
                                                      offset[AdcNumber]
   return, float((ScaledVoltage - PostdcBaseline) *                    $
                                                ScaleFactor[AdcNumber])
end
