function FindCrisBufferType, BufferNumber

   common CrisSymbols
   common SbFindCrisBufferType, BufferType

   if (n_elements(BufferType) eq 0) then begin
      Z1  = G$_Cris.Z1Buffer
      Z2  = G$_Cris.Z2Buffer
      CNO = G$_Cris.CnoBuffer
      HIZ = G$_Cris.HizBuffer
      STM = G$_Cris.StimBuffer
      UND = G$_Cris.UndefinedBuffer

      ;          0    1    2    3    4    5    6    7    8    9
      BufferType =                                               $
              [UND, UND, UND,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2, $ ;  0
               HIZ, HIZ,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2,  Z2, $ ; 10
                Z2, CNO, HIZ, CNO, CNO, CNO, HIZ, HIZ, HIZ,  Z1, $ ; 20
                Z2, HIZ,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2,  Z2, $ ; 30
                Z2,  Z1,  Z1,  Z2,  Z2,  Z2,  Z2, CNO, CNO, CNO, $ ; 40
               CNO, HIZ, HIZ, HIZ, HIZ, CNO, CNO, CNO, CNO, HIZ, $ ; 50
               HIZ, HIZ, HIZ, STM]                                 ; 60

   endif

   number = BufferNumber > G$_Cris.BufferIdOffset
   number = (number - G$_Cris.BufferIdOffset) < G$_Cris.NumEvtBuffers
   number = number mod G$_Cris.NumEvtBuffers
   
   return, BufferType[number]
end
