; $Id: get_group_diagnostic_events_ce.pro,v 1.2 1998/08/03 13:29:01 rgr Exp $

; $RCSfile: get_group_diagnostic_events_ce.pro,v $
; $Author: rgr $
; $Date: 1998/08/03 13:29:01 $
; $Revision: 1.2 $

function get_group_diagnostic_events_ce, sec0_1996, sec1_1996

   Common CrisSymbols

   NWORD = G$_Cris.SoftMaxNumDiagWords
   NBYTE = G$_Cris.NumRawSoftEvtBytes

   de = get_group_diagnostic_events_c(sec0_1996, sec1_1996)
   nrec = n_elements(de)
   if (nrec gt 1) then begin
      ii = indgen(nrec-1)
      set = where(de[ii].Second1996MinorFrame0 ne                     $
                                 de[ii+1].Second1996MinorFrame0, nset)
      nrec = nset + 1;
   endif
   DiagEvt = replicate({L1_1CrisDiagnosticEvent}, nrec)
   DiagEvt[0].ClockMinorFrame0 = de[0].ClockMinorFrame0
   DiagEvt[0].ClockMinorFrame1 = de[0].ClockMinorFrame1
   DiagEvt[0].Second1996MinorFrame0 = de[0].Second1996MinorFrame0
   DiagEvt[0].Second1996MinorFrame1 = de[0].Second1996MinorFrame1
   DiagEvt[0].MicrosecondMinorFrame0 = de[0].MicrosecondMinorFrame0
   DiagEvt[0].MicrosecondMinorFrame1 = de[0].MicrosecondMinorFrame1
   ii = 0
   irec = 0
   offset = 0
   while (irec lt (nrec-1)) do begin
      if (de[ii].Second1996MinorFrame0 eq                             $
                       DiagEvt[irec].Second1996MinorFrame0) then begin
         nsoft = (NWORD - offset) < (NBYTE/2)
         DiagEvt[irec].soft[offset : offset + nsoft - 1] =            $
                                        de[ii].SoftEvent[0: nsoft - 1]
         ii = ii + 1
         offset = offset + nsoft
      endif else begin

         tagword = de[ii-1].RawStack[0]
         DiagEvt[irec].raw.tag.stim_puls_tag =                        $
                                             byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.stim_off_tag = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.z1 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.z2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.z_gt_2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.z1 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.z2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.z_gt_2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.hazard = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.ghor = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.mor = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.adc2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.min_range = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.adc2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.min_range = byte(tagword and '0001'X)

         tagword = de[ii-1].RawStack[1]
         DiagEvt[irec].raw.ab.tag.e1_0 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e1_1 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e3 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e4 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e5 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e6 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e7 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e8 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.e9 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g3 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g4 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g5 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g6 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.ab.tag.g7 = byte(tagword and '0001'X)

         tagword = de[ii-1].RawStack[2]
         DiagEvt[irec].raw.cd.tag.e1_0 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e1_1 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e3 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e4 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e5 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e6 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e7 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e8 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.e9 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g2 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g3 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g4 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g5 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g6 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.cd.tag.g7 = byte(tagword and '0001'X)

         tagword = de[ii-1].RawStack[3]
         DiagEvt[irec].raw.tag.soft_trig0 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.soft_trig1 = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.hy_en = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.tag.he_en = byte(tagword and '0001'X)
         tagword = ishft(tagword, -1)
         DiagEvt[irec].raw.CycleCount = byte(tagword and '00ff'X)

         DiagEvt[irec].raw.ab.e1_0 = de[ii-1].RawStack[4]
         DiagEvt[irec].raw.ab.e1_1 = de[ii-1].RawStack[5]
         DiagEvt[irec].raw.ab.e2   = de[ii-1].RawStack[6]
         DiagEvt[irec].raw.ab.e3   = de[ii-1].RawStack[7]
         DiagEvt[irec].raw.ab.e4   = de[ii-1].RawStack[8]
         DiagEvt[irec].raw.ab.e5   = de[ii-1].RawStack[9]
         DiagEvt[irec].raw.ab.e6   = de[ii-1].RawStack[10]
         DiagEvt[irec].raw.ab.e7   = de[ii-1].RawStack[11]
         DiagEvt[irec].raw.ab.e8   = de[ii-1].RawStack[12]
         DiagEvt[irec].raw.ab.e9   = de[ii-1].RawStack[13]
         DiagEvt[irec].raw.ab.g2   = de[ii-1].RawStack[14]
         DiagEvt[irec].raw.ab.g3   = de[ii-1].RawStack[15]
         DiagEvt[irec].raw.ab.g4   = de[ii-1].RawStack[16]
         DiagEvt[irec].raw.ab.g5   = de[ii-1].RawStack[17]
         DiagEvt[irec].raw.ab.g6   = de[ii-1].RawStack[18]
         DiagEvt[irec].raw.ab.g7   = de[ii-1].RawStack[19]

         DiagEvt[irec].raw.cd.e1_0 = de[ii-1].RawStack[20]
         DiagEvt[irec].raw.cd.e1_1 = de[ii-1].RawStack[21]
         DiagEvt[irec].raw.cd.e2   = de[ii-1].RawStack[22]
         DiagEvt[irec].raw.cd.e3   = de[ii-1].RawStack[23]
         DiagEvt[irec].raw.cd.e4   = de[ii-1].RawStack[24]
         DiagEvt[irec].raw.cd.e5   = de[ii-1].RawStack[25]
         DiagEvt[irec].raw.cd.e6   = de[ii-1].RawStack[26]
         DiagEvt[irec].raw.cd.e7   = de[ii-1].RawStack[27]
         DiagEvt[irec].raw.cd.e8   = de[ii-1].RawStack[28]
         DiagEvt[irec].raw.cd.e9   = de[ii-1].RawStack[29]
         DiagEvt[irec].raw.cd.g2   = de[ii-1].RawStack[30]
         DiagEvt[irec].raw.cd.g3   = de[ii-1].RawStack[31]
         DiagEvt[irec].raw.cd.g4   = de[ii-1].RawStack[32]
         DiagEvt[irec].raw.cd.g5   = de[ii-1].RawStack[33]
         DiagEvt[irec].raw.cd.g6   = de[ii-1].RawStack[34]
         DiagEvt[irec].raw.cd.g7   = de[ii-1].RawStack[35]

         DiagEvt[irec].normal = {ce_crisEvt}
         if (de[ii-1].ContinuationFlag) then begin
            DiagEvt[irec].Second1996 = 0L
         endif else begin
            EventCycle = {L1CrisEventCycle}
            EventCycle.NumberEvents = 1
            length = de[ii-1].NormalEvent[0]
            EventCycle.EventBuffer[0 : length-1] =                    $
                                    de[ii-1].NormalEvent[0 : length-1]
            EventCycle.EventBuffer[length : length+2] = 0B
            EventCycle.Second1996 = de[ii-1].Second1996MinorFrame0
            EventCycle.microsecond = de[ii-1].MicrosecondMinorFrame0
            event = unpackCrisEventCycle(EventCycle)
            DiagEvt[irec].normal = event[0]
         endelse

         irec = irec + 1
         offset = 0
         DiagEvt[irec].ClockMinorFrame0 = de[ii].ClockMinorFrame0
         DiagEvt[irec].ClockMinorFrame1 = de[ii].ClockMinorFrame1
         DiagEvt[irec].Second1996MinorFrame0 =                        $
                                          de[ii].Second1996MinorFrame0
         DiagEvt[irec].Second1996MinorFrame1 =                        $
                                          de[ii].Second1996MinorFrame1
         DiagEvt[irec].MicrosecondMinorFrame0 =                       $
                                         de[ii].MicrosecondMinorFrame0
         DiagEvt[irec].MicrosecondMinorFrame1 =                       $
                                         de[ii].MicrosecondMinorFrame1
      endelse
   endwhile
      
   return,DiagEvt 
end
