; $Id: dumpl1_1crishskp.pro,v 1.2 1998/07/31 00:33:08 rgr Exp $

; $RCSfile: dumpl1_1crishskp.pro,v $
; $Author: rgr $
; $Date: 1998/07/31 00:33:08 $
; $Revision: 1.2 $


pro dumpL1_1CrisHskp, hskp, LUN=lun

   lunit = -1
   if (keyword_set(lun)) then lunit = lun

   template = strarr(31)

   template[00] = "CRIS Housekeeping - <start time               >   <S/C Clock: xxxxxxxxxx>"
   template[01] = ""
   template[02] = "Temperature(DegC):               Voltage(V):         Leakage Current(microA):"
   template[03] = "<Motherboard Elect: xxx.xx xx>     <+5V: xxx.xx xx>   <E1A: xxx.xx xx>  <E1C: xxx.xx xx>"
   template[04] = "  <Motherboard Det: xxx.xx xx>     <+6V: xxx.xx xx>   <E1B: xxx.xx xx>  <E1D: xxx.xx xx>"
   template[05] = "    <Motherboard C: xxx.xx xx>     <-6V: xxx.xx xx>  <E2AB: xxx.xx xx> <E2CD: xxx.xx xx>"
   template[06] = "     <Analog Board: xxx.xx xx>   <+7.3V: xxx.xx xx>  <E3AB: xxx.xx xx> <E3CD: xxx.xx xx>"
   template[07] = "    <PostReg Board: xxx.xx xx>   <-7.3V: xxx.xx xx>  <E4AB: xxx.xx xx> <E4CD: xxx.xx xx>"
   template[08] = "      <Logic Board: xxx.xx xx>    <+12V: xxx.xx xx>  <E5AB: xxx.xx xx> <E5CD: xxx.xx xx>"
   template[09] = "        <E12 Elect: xxx.xx xx>    <-12V: xxx.xx xx>  <E6AB: xxx.xx xx> <E6CD: xxx.xx xx>"
   template[10] = "          <E12 Det: xxx.xx xx>  <+13.4V: xxx.xx xx>  <E7AB: xxx.xx xx> <E7CD: xxx.xx xx>"
   template[11] = "        <E34 Elect: xxx.xx xx>  <-13.4V: xxx.xx xx>  <E8AB: xxx.xx xx> <E8CD: xxx.xx xx>"
   template[12] = "          <E34 Det: xxx.xx xx>    <+15V: xxx.xx xx>  <E9AB: xxx.xx xx> <E9CD: xxx.xx xx>"
   template[13] = "        <E56 Elect: xxx.xx xx>    <+19V: xxx.xx xx>  <G2AB: xxx.xx xx> <G2CD: xxx.xx xx>"
   template[14] = "          <E56 Det: xxx.xx xx><MCP1(kV): xxx.xx xx>  <G3AB: xxx.xx xx> <G3CD: xxx.xx xx>"
   template[15] = "       <E789 Elect: xxx.xx xx><MCP2(kV): xxx.xx xx>  <G4AB: xxx.xx xx> <G4CD: xxx.xx xx>"
   template[16] = "         <E789 Det: xxx.xx xx>                       <G5AB: xxx.xx xx> <G5CD: xxx.xx xx>"
   template[17] = "             <LVPS: xxx.xx xx> Current(Scaled V):    <G6AB: xxx.xx xx> <G6CD: xxx.xx xx>"
   template[18] = "             <HVPS: xxx.xx xx>  <HVPS 1: xxx.xx xx>  <G7AB: xxx.xx xx> <G7CD: xxx.xx xx>"
   template[19] = " <Fiber Plane Top0: xxx.xx xx>  <HVPS 2: xxx.xx xx>"
   template[20] = " <Fiber Plane Top1: xxx.xx xx>  <HVPS 3: xxx.xx xx> DAC(V):"
   template[21] = "  <Fiber Plane Mid: xxx.xx xx>  <HVPS 4: xxx.xx xx>  <G2AB: yyy.yy yy> <G2CD: yyy.yy yy>"
   template[22] = "  <Fiber Plane Bot: xxx.xx xx>                       <G3AB: yyy.yy yy> <G3CD: yyy.yy yy>"
   template[23] = "<Image Int. 1 Side: xxx.xx xx> Current(microA):      <G4AB: yyy.yy yy> <G4CD: yyy.yy yy>"
   template[24] = "<Image Int. 1 Rear: xxx.xx xx><SoftPS A: xxx.xx xx>  <G5AB: yyy.yy yy> <G5CD: yyy.yy yy>"
   template[25] = "   <Camera 1 Elect: xxx.xx xx><SoftPS B: xxx.xx xx>  <G6AB: yyy.yy yy> <G6CD: yyy.yy yy>"
   template[26] = "           <HVPS 1: yyy.yy yy>                       <G7AB: yyy.yy yy> <G7CD: yyy.yy yy>"
   template[27] = "<Image Int. 2 Side: xxx.xx xx>                       <E9AB: yyy.yy yy> <E9CD: yyy.yy yy>"
   template[28] = "<Image Int. 2 Rear: xxx.xx xx>                  "
   template[29] = "   <Camera 2 Elect: xxx.xx xx>                  "
   template[30] = "           <HVPS 2: yyy.yy yy>                  "

   line = template[0]
      strput, line, "                           ", 20
      segmentValue = string(stringDate1996(hskp.Second1996), hskp.microsecond, FORMAT="(a, '.', i6.6)")
      strput, line, segmentValue, 20
      strput, line, "                       ", 50
      segmentValue = string(hskp.ClockCycle, FORMAT="(' S/C Clock: ', i10.10, ' ')")
      strput, line, segmentValue, 50
      printf, lunit, line
   line = template[1]
      printf, lunit, line
   line = template[2]
      printf, lunit, line
   line = template[3]
      strput, line, "                              ", 0
      segmentValue = string(hskp.TemperatureMotherBoardElect, hskp.QualityTemperatureMotherBoardElect, FORMAT="(' Motherboard Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                ", 35
      segmentValue = string(hskp.MonitorP5V, hskp.QualityMonitorP5V, FORMAT="(' +5V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 35
      strput, line, "                ", 54
      segmentValue = string(hskp.LeakageCurrentE1a, hskp.QualityLeakageCurrentE1a, FORMAT="(' E1A:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 54
      strput, line, "                ", 72
      segmentValue = string(hskp.LeakageCurrentE1c, hskp.QualityLeakageCurrentE1c, FORMAT="(' E1C:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 72
      printf, lunit, line
   line = template[4]
      strput, line, "                            ", 2
      segmentValue = string(hskp.TemperatureMotherBoardDet, hskp.QualityTemperatureMotherBoardDet, FORMAT="(' Motherboard Det:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "                ", 35
      segmentValue = string(hskp.MonitorP6V, hskp.QualityMonitorP6V, FORMAT="(' +6V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 35
      strput, line, "                ", 54
      segmentValue = string(hskp.LeakageCurrentE1b, hskp.QualityLeakageCurrentE1b, FORMAT="(' E1B:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 54
      strput, line, "                ", 72
      segmentValue = string(hskp.LeakageCurrentE1d, hskp.QualityLeakageCurrentE1d, FORMAT="(' E1D:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 72
      printf, lunit, line
   line = template[5]
      strput, line, "                          ", 4
      segmentValue = string(hskp.TemperatureMotherBoardC, hskp.QualityTemperatureMotherBoardC, FORMAT="(' Motherboard C:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 4
      strput, line, "                ", 35
      segmentValue = string(hskp.MonitorM6V, hskp.QualityMonitorM6V, FORMAT="(' -6V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 35
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE2ab, hskp.QualityLeakageCurrentE2ab, FORMAT="(' E2AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE2cd, hskp.QualityLeakageCurrentE2cd, FORMAT="(' E2CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[6]
      strput, line, "                         ", 5
      segmentValue = string(hskp.TemperatureAnalogBoard, hskp.QualityTemperatureAnalogBoard, FORMAT="(' Analog Board:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 5
      strput, line, "                  ", 33
      segmentValue = string(hskp.MonitorP7V, hskp.QualityMonitorP7V, FORMAT="(' +7.3V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 33
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE3ab, hskp.QualityLeakageCurrentE3ab, FORMAT="(' E3AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE3cd, hskp.QualityLeakageCurrentE3cd, FORMAT="(' E3CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[7]
      strput, line, "                          ", 4
      segmentValue = string(hskp.TemperaturePostRegBoard, hskp.QualityTemperaturePostRegBoard, FORMAT="(' PostReg Board:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 4
      strput, line, "                  ", 33
      segmentValue = string(hskp.MonitorM7V, hskp.QualityMonitorM7V, FORMAT="(' -7.3V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 33
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE4ab, hskp.QualityLeakageCurrentE4ab, FORMAT="(' E4AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE4cd, hskp.QualityLeakageCurrentE4cd, FORMAT="(' E4CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[8]
      strput, line, "                        ", 6
      segmentValue = string(hskp.TemperatureLogicBoard, hskp.QualityTemperatureLogicBoard, FORMAT="(' Logic Board:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 6
      strput, line, "                 ", 34
      segmentValue = string(hskp.MonitorP12V, hskp.QualityMonitorP12V, FORMAT="(' +12V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 34
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE5ab, hskp.QualityLeakageCurrentE5ab, FORMAT="(' E5AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE5cd, hskp.QualityLeakageCurrentE5cd, FORMAT="(' E5CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[9]
      strput, line, "                      ", 8
      segmentValue = string(hskp.TemperatureE12Elect, hskp.QualityTemperatureE12Elect, FORMAT="(' E12 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "                 ", 34
      segmentValue = string(hskp.MonitorM12V, hskp.QualityMonitorM12V, FORMAT="(' -12V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 34
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE6ab, hskp.QualityLeakageCurrentE6ab, FORMAT="(' E6AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE6cd, hskp.QualityLeakageCurrentE6cd, FORMAT="(' E6CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[10]
      strput, line, "                    ", 10
      segmentValue = string(hskp.TemperatureE12Det, hskp.QualityTemperatureE12Det, FORMAT="(' E12 Det:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorP13V, hskp.QualityMonitorP13V, FORMAT="(' +13.4V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE7ab, hskp.QualityLeakageCurrentE7ab, FORMAT="(' E7AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE7cd, hskp.QualityLeakageCurrentE7cd, FORMAT="(' E7CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[11]
      strput, line, "                      ", 8
      segmentValue = string(hskp.TemperatureE34Elect, hskp.QualityTemperatureE34Elect, FORMAT="(' E34 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorM13V, hskp.QualityMonitorM13V, FORMAT="(' -13.4V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE8ab, hskp.QualityLeakageCurrentE8ab, FORMAT="(' E8AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE8cd, hskp.QualityLeakageCurrentE8cd, FORMAT="(' E8CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[12]
      strput, line, "                    ", 10
      segmentValue = string(hskp.TemperatureE34Det, hskp.QualityTemperatureE34Det, FORMAT="(' E34 Det:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "                 ", 34
      segmentValue = string(hskp.MonitorP15V, hskp.QualityMonitorP15V, FORMAT="(' +15V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 34
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentE9ab, hskp.QualityLeakageCurrentE9ab, FORMAT="(' E9AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentE9cd, hskp.QualityLeakageCurrentE9cd, FORMAT="(' E9CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[13]
      strput, line, "                      ", 8
      segmentValue = string(hskp.TemperatureE56Elect, hskp.QualityTemperatureE56Elect, FORMAT="(' E56 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "                 ", 34
      segmentValue = string(hskp.MonitorP19V, hskp.QualityMonitorP19V, FORMAT="(' +19V:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 34
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG2ab, hskp.QualityLeakageCurrentG2ab, FORMAT="(' G2AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG2cd, hskp.QualityLeakageCurrentG2cd, FORMAT="(' G2CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[14]
      strput, line, "                    ", 10
      segmentValue = string(hskp.TemperatureE56Det, hskp.QualityTemperatureE56Det, FORMAT="(' E56 Det:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "                     ", 30
      segmentValue = string(hskp.MonitorMcp1, hskp.QualityMonitorMcp1, FORMAT="(' MCP1(kV):', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG3ab, hskp.QualityLeakageCurrentG3ab, FORMAT="(' G3AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG3cd, hskp.QualityLeakageCurrentG3cd, FORMAT="(' G3CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[15]
      strput, line, "                       ", 7
      segmentValue = string(hskp.TemperatureE789Elect, hskp.QualityTemperatureE789Elect, FORMAT="(' E789 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 7
      strput, line, "                     ", 30
      segmentValue = string(hskp.MonitorMcp2, hskp.QualityMonitorMcp2, FORMAT="(' MCP2(kV):', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG4ab, hskp.QualityLeakageCurrentG4ab, FORMAT="(' G4AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG4cd, hskp.QualityLeakageCurrentG4cd, FORMAT="(' G4CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[16]
      strput, line, "                     ", 9
      segmentValue = string(hskp.TemperatureE789Det, hskp.QualityTemperatureE789Det, FORMAT="(' E789 Det:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 9
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG5ab, hskp.QualityLeakageCurrentG5ab, FORMAT="(' G5AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG5cd, hskp.QualityLeakageCurrentG5cd, FORMAT="(' G5CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[17]
      strput, line, "                 ", 13
      segmentValue = string(hskp.TemperatureLvps, hskp.QualityTemperatureLvps, FORMAT="(' LVPS:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 13
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG6ab, hskp.QualityLeakageCurrentG6ab, FORMAT="(' G6AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG6cd, hskp.QualityLeakageCurrentG6cd, FORMAT="(' G6CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[18]
      strput, line, "                 ", 13
      segmentValue = string(hskp.TemperatureHvps, hskp.QualityTemperatureHvps, FORMAT="(' HVPS:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 13
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorHvps1I, hskp.QualityMonitorHvps1I, FORMAT="(' HVPS 1:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "                 ", 53
      segmentValue = string(hskp.LeakageCurrentG7ab, hskp.QualityLeakageCurrentG7ab, FORMAT="(' G7AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.LeakageCurrentG7cd, hskp.QualityLeakageCurrentG7cd, FORMAT="(' G7CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[19]
      strput, line, "                             ", 1
      segmentValue = string(hskp.TemperatureFiberPlaneTop0, hskp.QualityTemperatureFiberPlaneTop0, FORMAT="(' Fiber Plane Top0:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 1
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorHvps2I, hskp.QualityMonitorHvps2I, FORMAT="(' HVPS 2:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      printf, lunit, line
   line = template[20]
      strput, line, "                             ", 1
      segmentValue = string(hskp.TemperatureFiberPlaneTop1, hskp.QualityTemperatureFiberPlaneTop1, FORMAT="(' Fiber Plane Top1:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 1
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorHvps3I, hskp.QualityMonitorHvps3I, FORMAT="(' HVPS 3:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      printf, lunit, line
   line = template[21]
      strput, line, "                            ", 2
      segmentValue = string(hskp.TemperatureFiberPlaneMid, hskp.QualityTemperatureFiberPlaneMid, FORMAT="(' Fiber Plane Mid:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "                   ", 32
      segmentValue = string(hskp.MonitorHvps4I, hskp.QualityMonitorHvps4I, FORMAT="(' HVPS 4:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG2ab, hskp.QualityDacG2ab, FORMAT="(' G2AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG2cd, hskp.QualityDacG2cd, FORMAT="(' G2CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[22]
      strput, line, "                            ", 2
      segmentValue = string(hskp.TemperatureFiberPlaneBot, hskp.QualityTemperatureFiberPlaneBot, FORMAT="(' Fiber Plane Bot:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG3ab, hskp.QualityDacG3ab, FORMAT="(' G3AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG3cd, hskp.QualityDacG3cd, FORMAT="(' G3CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[23]
      strput, line, "                              ", 0
      segmentValue = string(hskp.TemperatureImageInt1Side, hskp.QualityTemperatureImageInt1Side, FORMAT="(' Image Int. 1 Side:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG4ab, hskp.QualityDacG4ab, FORMAT="(' G4AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG4cd, hskp.QualityDacG4cd, FORMAT="(' G4CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[24]
      strput, line, "                              ", 0
      segmentValue = string(hskp.TemperatureImageInt1Rear, hskp.QualityTemperatureImageInt1Rear, FORMAT="(' Image Int. 1 Rear:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                     ", 30
      segmentValue = string(hskp.MonitorSoftPsaI, hskp.QualityMonitorSoftPsaI, FORMAT="(' SoftPS A:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG5ab, hskp.QualityDacG5ab, FORMAT="(' G5AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG5cd, hskp.QualityDacG5cd, FORMAT="(' G5CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[25]
      strput, line, "                           ", 3
      segmentValue = string(hskp.TemperatureCamera1Elect, hskp.QualityTemperatureCamera1Elect, FORMAT="(' Camera 1 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 3
      strput, line, "                     ", 30
      segmentValue = string(hskp.MonitorSoftPsbI, hskp.QualityMonitorSoftPsbI, FORMAT="(' SoftPS B:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG6ab, hskp.QualityDacG6ab, FORMAT="(' G6AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG6cd, hskp.QualityDacG6cd, FORMAT="(' G6CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[26]
      strput, line, "                   ", 11
      segmentValue = string(hskp.TemperatureHvps1, hskp.QualityTemperatureHvps1, FORMAT="(' HVPS 1:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 11
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacG7ab, hskp.QualityDacG7ab, FORMAT="(' G7AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacG7cd, hskp.QualityDacG7cd, FORMAT="(' G7CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[27]
      strput, line, "                              ", 0
      segmentValue = string(hskp.TemperatureImageInt2Side, hskp.QualityTemperatureImageInt2Side, FORMAT="(' Image Int. 2 Side:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                 ", 53
      segmentValue = string(hskp.DacE9ab, hskp.QualityDacE9ab, FORMAT="(' E9AB:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 53
      strput, line, "                 ", 71
      segmentValue = string(hskp.DacE9cd, hskp.QualityDacE9cd, FORMAT="(' E9CD:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 71
      printf, lunit, line
   line = template[28]
      strput, line, "                              ", 0
      segmentValue = string(hskp.TemperatureImageInt2Rear, hskp.QualityTemperatureImageInt2Rear, FORMAT="(' Image Int. 2 Rear:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      printf, lunit, line
   line = template[29]
      strput, line, "                           ", 3
      segmentValue = string(hskp.TemperatureCamera2Elect, hskp.QualityTemperatureCamera2Elect, FORMAT="(' Camera 2 Elect:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 3
      printf, lunit, line
   line = template[30]
      strput, line, "                   ", 11
      segmentValue = string(hskp.TemperatureHvps2, hskp.QualityTemperatureHvps2, FORMAT="(' HVPS 2:', f6.2, ' ', z2.2, ' ')")
      strput, line, segmentValue, 11
      printf, lunit, line

end
