; $Id: dumpl1crishskp.pro,v 1.2 1998/07/27 13:35:13 rgr Exp $

; $RCSfile: dumpl1crishskp.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 13:35:13 $
; $Revision: 1.2 $


pro dumpL1CrisHskp, hskp, LUN=lun

   lunit = -1
   if (keyword_set(lun)) then lunit = lun

   template = strarr(32)

   template[00] = "CRIS Housekeeping - <start time               >   <S/C Clock: xxxxxxxxxx>"
   template[01] = "<Status TmSide: x xx>    <Status Refresh: x xx>   <Command Table Index: xxx xx>"
   template[02] = ""
   template[03] = "Temperature(ADC):             Voltage(ADC):     PostDC(ADC):"
   template[04] = "<Motherboard Elect: xxxx xx>     <+5V: xxxx xx>   <E1A: xxxx xx>  <E1C: xxxx xx>"
   template[05] = "  <Motherboard Det: xxxx xx>     <+6V: xxxx xx>   <E1B: xxxx xx>  <E1D: xxxx xx>"
   template[06] = "    <Motherboard C: xxxx xx>     <-6V: xxxx xx>  <E2AB: xxxx xx> <E2CD: xxxx xx>"
   template[07] = "     <Analog Board: xxxx xx>   <+7.3V: xxxx xx>  <E3AB: xxxx xx> <E3CD: xxxx xx>"
   template[08] = "    <PostReg Board: xxxx xx>   <-7.3V: xxxx xx>  <E4AB: xxxx xx> <E4CD: xxxx xx>"
   template[09] = "      <Logic Board: xxxx xx>    <+12V: xxxx xx>  <E5AB: xxxx xx> <E5CD: xxxx xx>"
   template[10] = "        <E12 Elect: xxxx xx>    <-12V: xxxx xx>  <E6AB: xxxx xx> <E6CD: xxxx xx>"
   template[11] = "          <E12 Det: xxxx xx>  <+13.4V: xxxx xx>  <E7AB: xxxx xx> <E7CD: xxxx xx>"
   template[12] = "        <E34 Elect: xxxx xx>  <-13.4V: xxxx xx>  <E8AB: xxxx xx> <E8CD: xxxx xx>"
   template[13] = "          <E34 Det: xxxx xx>    <+15V: xxxx xx>  <E9AB: xxxx xx> <E9CD: xxxx xx>"
   template[14] = "        <E56 Elect: xxxx xx>    <+19V: xxxx xx>  <G2AB: xxxx xx> <G2CD: xxxx xx>"
   template[15] = "          <E56 Det: xxxx xx>    <MCP1: xxxx xx>  <G3AB: xxxx xx> <G3CD: xxxx xx>"
   template[16] = "       <E789 Elect: xxxx xx>    <MCP2: xxxx xx>  <G4AB: xxxx xx> <G4CD: xxxx xx>"
   template[17] = "         <E789 Det: xxxx xx>                     <G5AB: xxxx xx> <G5CD: xxxx xx>"
   template[18] = "             <LVPS: xxxx xx> Current(ADC):       <G6AB: xxxx xx> <G6CD: xxxx xx>"
   template[19] = "             <HVPS: xxxx xx>  <HVPS 1: xxxx xx>  <G7AB: xxxx xx> <G7CD: xxxx xx>"
   template[20] = " <Fiber Plane Top0: xxxx xx>  <HVPS 2: xxxx xx>"
   template[21] = " <Fiber Plane Top1: xxxx xx>  <HVPS 3: xxxx xx> DAC:"
   template[22] = "  <Fiber Plane Mid: xxxx xx>  <HVPS 4: xxxx xx>  <G2AB: yyyy yy> <G2CD: yyyy yy>"
   template[23] = "  <Fiber Plane Bot: xxxx xx><SoftPS A: xxxx xx>  <G3AB: yyyy yy> <G3CD: yyyy yy>"
   template[24] = "<Image Int. 1 Side: xxxx xx><SoftPS B: xxxx xx>  <G4AB: yyyy yy> <G4CD: yyyy yy>"
   template[25] = "<Image Int. 1 Rear: xxxx xx>                     <G5AB: yyyy yy> <G5CD: yyyy yy>"
   template[26] = "   <Camera 1 Elect: xxxx xx>  Heater:            <G6AB: yyyy yy> <G6CD: yyyy yy>"
   template[27] = "           <HVPS 1: yyyy yy>   <CCD A: xxx xx>   <G7AB: yyyy yy> <G7CD: yyyy yy>"
   template[28] = "<Image Int. 2 Side: xxxx xx>   <CCD B: xxx xx>   <E9AB: yyyy yy> <E9CD: yyyy yy>"
   template[29] = "<Image Int. 2 Rear: xxxx xx>    <CRIS: xxx xx>"
   template[30] = "   <Camera 2 Elect: xxxx xx>"
   template[31] = "           <HVPS 2: yyyy yy>"

   line = template[0]
      strput, line, "                           ", 20
      segmentValue = string(stringDate1996(hskp.Second1996), hskp.microsecond, FORMAT="(a, '.', i6.6)")
      strput, line, segmentValue, 20
      strput, line, "                       ", 50
      segmentValue = string(hskp.ClockCycle, FORMAT="(' S/C Clock: ', i10.10, ' ')")
      strput, line, segmentValue, 50
      printf, lunit, line
   line = template[1]
      strput, line, "                     ", 0
      segmentValue = string(hskp.StatusTmSide, hskp.QualityStatusTmSide, FORMAT="(' Status TmSide: ', i1, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                      ", 25
      segmentValue = string(hskp.StatusRefresh, hskp.QualityStatusRefresh, FORMAT="(' Status Refresh: ', i1, ' ', z2.2, ' ')")
      strput, line, segmentValue, 25
      strput, line, "                             ", 50
      segmentValue = string(hskp.CommandTableIndex, hskp.QualityCommandTableIndex, FORMAT="(' Command Table Index: ', i3, ' ', z2.2, ' ')")
      strput, line, segmentValue, 50
      printf, lunit, line
   line = template[2]
      printf, lunit, line
   line = template[3]
      printf, lunit, line
   line = template[4]
      strput, line, "                            ", 0
      segmentValue = string(hskp.TemperatureMotherBoardElect, hskp.QualityTemperatureMotherBoardElect, FORMAT="(' Motherboard Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "              ", 33
      segmentValue = string(hskp.MonitorP5V, hskp.QualityMonitorP5V, FORMAT="(' +5V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 33
      strput, line, "              ", 50
      segmentValue = string(hskp.PostDcE1a, hskp.QualityPostDcE1a, FORMAT="(' E1A: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 50
      strput, line, "              ", 66
      segmentValue = string(hskp.PostDcE1c, hskp.QualityPostDcE1c, FORMAT="(' E1C: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 66
      printf, lunit, line
   line = template[5]
      strput, line, "                          ", 2
      segmentValue = string(hskp.TemperatureMotherBoardDet, hskp.QualityTemperatureMotherBoardDet, FORMAT="(' Motherboard Det: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "              ", 33
      segmentValue = string(hskp.MonitorP6V, hskp.QualityMonitorP6V, FORMAT="(' +6V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 33
      strput, line, "              ", 50
      segmentValue = string(hskp.PostDcE1b, hskp.QualityPostDcE1b, FORMAT="(' E1B: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 50
      strput, line, "              ", 66
      segmentValue = string(hskp.PostDcE1d, hskp.QualityPostDcE1d, FORMAT="(' E1D: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 66
      printf, lunit, line
   line = template[6]
      strput, line, "                        ", 4
      segmentValue = string(hskp.TemperatureMotherBoardC, hskp.QualityTemperatureMotherBoardC, FORMAT="(' Motherboard C: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 4
      strput, line, "              ", 33
      segmentValue = string(hskp.MonitorM6V, hskp.QualityMonitorM6V, FORMAT="(' -6V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 33
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE2ab, hskp.QualityPostDcE2ab, FORMAT="(' E2Ab: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE2cd, hskp.QualityPostDcE2cd, FORMAT="(' E2CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[7]
      strput, line, "                       ", 5
      segmentValue = string(hskp.TemperatureAnalogBoard, hskp.QualityTemperatureAnalogBoard, FORMAT="(' Analog Board: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 5
      strput, line, "                ", 31
      segmentValue = string(hskp.MonitorP7V, hskp.QualityMonitorP7V, FORMAT="(' +7.3V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 31
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE3ab, hskp.QualityPostDcE3ab, FORMAT="(' E3AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE3cd, hskp.QualityPostDcE3cd, FORMAT="(' E3CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[8]
      strput, line, "                        ", 4
      segmentValue = string(hskp.TemperaturePostRegBoard, hskp.QualityTemperaturePostRegBoard, FORMAT="(' PostReg Board: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 4
      strput, line, "                ", 31
      segmentValue = string(hskp.MonitorM7V, hskp.QualityMonitorM7V, FORMAT="(' -7.3V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 31
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE4ab, hskp.QualityPostDcE4ab, FORMAT="(' E4AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE4cd, hskp.QualityPostDcE4cd, FORMAT="(' E4CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[9]
      strput, line, "                      ", 6
      segmentValue = string(hskp.TemperatureLogicBoard, hskp.QualityTemperatureLogicBoard, FORMAT="(' Logic Board: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 6
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorP12V, hskp.QualityMonitorP12V, FORMAT="(' +12V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE5ab, hskp.QualityPostDcE5ab, FORMAT="(' E5AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE5cd, hskp.QualityPostDcE5cd, FORMAT="(' E5CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[10]
      strput, line, "                    ", 8
      segmentValue = string(hskp.TemperatureE12Elect, hskp.QualityTemperatureE12Elect, FORMAT="(' E12 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorM12V, hskp.QualityMonitorM12V, FORMAT="(' -12V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE6ab, hskp.QualityPostDcE6ab, FORMAT="(' E6AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE6cd, hskp.QualityPostDcE6cd, FORMAT="(' E6CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[11]
      strput, line, "                  ", 10
      segmentValue = string(hskp.TemperatureE12Det, hskp.QualityTemperatureE12Det, FORMAT="(' E12 Det: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorP13V, hskp.QualityMonitorP13V, FORMAT="(' +13.4V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE7ab, hskp.QualityPostDcE7ab, FORMAT="(' E7AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE7cd, hskp.QualityPostDcE7cd, FORMAT="(' E7CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[12]
      strput, line, "                    ", 8
      segmentValue = string(hskp.TemperatureE34Elect, hskp.QualityTemperatureE34Elect, FORMAT="(' E34 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorM13V, hskp.QualityMonitorM13V, FORMAT="(' -13.4V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE8ab, hskp.QualityPostDcE8ab, FORMAT="(' E8AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE8cd, hskp.QualityPostDcE8cd, FORMAT="(' E8CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[13]
      strput, line, "                  ", 10
      segmentValue = string(hskp.TemperatureE34Det, hskp.QualityTemperatureE34Det, FORMAT="(' E34 Det: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorP15V, hskp.QualityMonitorP15V, FORMAT="(' +15V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcE9ab, hskp.QualityPostDcE9ab, FORMAT="(' E9AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcE9cd, hskp.QualityPostDcE9cd, FORMAT="(' E9CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[14]
      strput, line, "                    ", 8
      segmentValue = string(hskp.TemperatureE56Elect, hskp.QualityTemperatureE56Elect, FORMAT="(' E56 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 8
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorP19V, hskp.QualityMonitorP19V, FORMAT="(' +19V: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG2ab, hskp.QualityPostDcG2ab, FORMAT="(' G2AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG2cd, hskp.QualityPostDcG2cd, FORMAT="(' G2CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[15]
      strput, line, "                  ", 10
      segmentValue = string(hskp.TemperatureE56Det, hskp.QualityTemperatureE56Det, FORMAT="(' E56 Det: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 10
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorMcp1, hskp.QualityMonitorMcp1, FORMAT="(' MCP1: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG3ab, hskp.QualityPostDcG3ab, FORMAT="(' G3AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG3cd, hskp.QualityPostDcG3cd, FORMAT="(' G3CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[16]
      strput, line, "                     ", 7
      segmentValue = string(hskp.TemperatureE789Elect, hskp.QualityTemperatureE789Elect, FORMAT="(' E789 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 7
      strput, line, "               ", 32
      segmentValue = string(hskp.MonitorMcp2, hskp.QualityMonitorMcp2, FORMAT="(' MCP2: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG4ab, hskp.QualityPostDcG4ab, FORMAT="(' G4AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG4cd, hskp.QualityPostDcG4cd, FORMAT="(' G4CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[17]
      strput, line, "                   ", 9
      segmentValue = string(hskp.TemperatureE789Det, hskp.QualityTemperatureE789Det, FORMAT="(' E789 Det: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 9
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG5ab, hskp.QualityPostDcG5ab, FORMAT="(' G5AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG5cd, hskp.QualityPostDcG5cd, FORMAT="(' G5CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[18]
      strput, line, "               ", 13
      segmentValue = string(hskp.TemperatureLvps, hskp.QualityTemperatureLvps, FORMAT="(' LVPS: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 13
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG6ab, hskp.QualityPostDcG6ab, FORMAT="(' G6AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG6cd, hskp.QualityPostDcG6cd, FORMAT="(' G6CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[19]
      strput, line, "               ", 13
      segmentValue = string(hskp.TemperatureHvps, hskp.QualityTemperatureHvps, FORMAT="(' HVPS: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 13
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorHvps1I, hskp.QualityMonitorHvps1I, FORMAT="(' HVPS 1: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "               ", 49
      segmentValue = string(hskp.PostDcG7ab, hskp.QualityPostDcG7ab, FORMAT="(' G7AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.PostDcG7cd, hskp.QualityPostDcG7cd, FORMAT="(' G7CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[20]
      strput, line, "                           ", 1
      segmentValue = string(hskp.TemperatureFiberPlaneTop0, hskp.QualityTemperatureFiberPlaneTop0, FORMAT="(' Fiber Plane Top0: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 1
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorHvps2I, hskp.QualityMonitorHvps2I, FORMAT="(' HVPS 2: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      printf, lunit, line
   line = template[21]
      strput, line, "                           ", 1
      segmentValue = string(hskp.TemperatureFiberPlaneTop1, hskp.QualityTemperatureFiberPlaneTop1, FORMAT="(' Fiber Plane Top1: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 1
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorHvps3I, hskp.QualityMonitorHvps3I, FORMAT="(' HVPS 3: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      printf, lunit, line
   line = template[22]
      strput, line, "                          ", 2
      segmentValue = string(hskp.TemperatureFiberPlaneMid, hskp.QualityTemperatureFiberPlaneMid, FORMAT="(' Fiber Plane Mid: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "                 ", 30
      segmentValue = string(hskp.MonitorHvps4I, hskp.QualityMonitorHvps4I, FORMAT="(' HVPS 4: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 30
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG2ab, hskp.QualityDacG2ab, FORMAT="(' G2AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG2cd, hskp.QualityDacG2cd, FORMAT="(' G2CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[23]
      strput, line, "                          ", 2
      segmentValue = string(hskp.TemperatureFiberPlaneBot, hskp.QualityTemperatureFiberPlaneBot, FORMAT="(' Fiber Plane Bot: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 2
      strput, line, "                   ", 28
      segmentValue = string(hskp.MonitorSoftPsaI, hskp.QualityMonitorSoftPsaI, FORMAT="(' SoftPS A: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 28
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG3ab, hskp.QualityDacG3ab, FORMAT="(' G3AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG3cd, hskp.QualityDacG3cd, FORMAT="(' G3CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[24]
      strput, line, "                            ", 0
      segmentValue = string(hskp.TemperatureImageInt1Side, hskp.QualityTemperatureImageInt1Side, FORMAT="(' Image Int. 1 Side: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "                   ", 28
      segmentValue = string(hskp.MonitorSoftPsbI, hskp.QualityMonitorSoftPsbI, FORMAT="(' SoftPS B: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 28
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG4ab, hskp.QualityDacG4ab, FORMAT="(' G4AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG4cd, hskp.QualityDacG4cd, FORMAT="(' G4CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[25]
      strput, line, "                            ", 0
      segmentValue = string(hskp.TemperatureImageInt1Rear, hskp.QualityTemperatureImageInt1Rear, FORMAT="(' Image Int. 1 Rear: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG5ab, hskp.QualityDacG5ab, FORMAT="(' G5AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG5cd, hskp.QualityDacG5cd, FORMAT="(' G5CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[26]
      strput, line, "                         ", 3
      segmentValue = string(hskp.TemperatureCamera1Elect, hskp.QualityTemperatureCamera1Elect, FORMAT="(' Camera 1 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 3
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG6ab, hskp.QualityDacG6ab, FORMAT="(' G6AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG6cd, hskp.QualityDacG6cd, FORMAT="(' G6CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[27]
      strput, line, "                 ", 11
      segmentValue = string(hskp.TemperatureHvps1, hskp.QualityTemperatureHvps1, FORMAT="(' HVPS 1: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 11
      strput, line, "               ", 31
      segmentValue = string(hskp.HeaterCcdA, hskp.QualityHeaterCcdA, FORMAT="(' CCD A: ', i3, ' ', z2.2, ' ')")
      strput, line, segmentValue, 31
      strput, line, "               ", 49
      segmentValue = string(hskp.DacG7ab, hskp.QualityDacG7ab, FORMAT="(' G7AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacG7cd, hskp.QualityDacG7cd, FORMAT="(' G7CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[28]
      strput, line, "                            ", 0
      segmentValue = string(hskp.TemperatureImageInt2Side, hskp.QualityTemperatureImageInt2Side, FORMAT="(' Image Int. 2 Side: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "               ", 31
      segmentValue = string(hskp.HeaterCcdB, hskp.QualityHeaterCcdB, FORMAT="(' CCD B: ', i3, ' ', z2.2, ' ')")
      strput, line, segmentValue, 31
      strput, line, "               ", 49
      segmentValue = string(hskp.DacE9ab, hskp.QualityDacE9ab, FORMAT="(' E9AB: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 49
      strput, line, "               ", 65
      segmentValue = string(hskp.DacE9cd, hskp.QualityDacE9cd, FORMAT="(' E9CD: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 65
      printf, lunit, line
   line = template[29]
      strput, line, "                            ", 0
      segmentValue = string(hskp.TemperatureImageInt2Rear, hskp.QualityTemperatureImageInt2Rear, FORMAT="(' Image Int. 2 Rear: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 0
      strput, line, "              ", 32
      segmentValue = string(hskp.HeaterCris, hskp.QualityHeaterCris, FORMAT="(' CRIS: ', i3, ' ', z2.2, ' ')")
      strput, line, segmentValue, 32
      printf, lunit, line
   line = template[30]
      strput, line, "                         ", 3
      segmentValue = string(hskp.TemperatureCamera2Elect, hskp.QualityTemperatureCamera2Elect, FORMAT="(' Camera 2 Elect: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 3
      printf, lunit, line
   line = template[31]
      strput, line, "                 ", 11
      segmentValue = string(hskp.TemperatureHvps2, hskp.QualityTemperatureHvps2, FORMAT="(' HVPS 2: ', i4, ' ', z2.2, ' ')")
      strput, line, segmentValue, 11
      printf, lunit, line

end
