; $Id: printce_crisevt.pro,v 1.1 1998/05/04 20:09:49 rgr Exp $

; $RCSfile: printce_crisevt.pro,v $
; $Author: rgr $
; $Date: 1998/05/04 20:09:49 $
; $Revision: 1.1 $


; This procedures prints dumps of the events whose cycles cover the
; interval speicifed by the start and stop times.
;
; Arguments
;    t0 = start time in seconds of 1996-(input)
;    t1 = stop time in seconds of 1996-(input)
;
; Keywords
;    file = name of file to send output (default is standard out)
;
;
; Procedures and functions used
;    dumpce_crisEvt
;    get_events_c

pro printce_crisEvt, t0, t1, FILE=file

   common CrisSymbols

   step = G$_Cris.NumMnfsPerCycle

   ; Get the first cycle of events that belongs to the time interval.
   ; If there are no events in the interval, then return.

   time = t0
   nevt = 0
   while (nevt eq 0) do begin
      if (time ge (t1 + step)) then return
      evt = get_events_c(time)
      time = time + step
      nevt = n_elements(evt) - 1
   endwhile

   ; Open the output file.

   lun = -1
   if (keyword_set(file)) then begin
      get_lun, lun
      openw, lun, file
   endif

   ; Process each cycle of events until a cycle is found that is past
   ; the end of the interval or the candidate time for the interval is
   ; well past the end of the time interval.

   while ( ((nevt gt 0) and (evt[0].secs1996 le t1)) or     $
           ((nevt eq 0) and (time lt (t1 + step))) ) do begin
      for j=0, nevt - 1 do begin
         dumpce_crisEvt, evt[j], LUN=lun
         printf, lun
         printf, lun
      endfor
      if (nevt gt 0) then begin
         time = evt[0].secs1996
         evt = get_events_c(time + (3L * step)/2L)
      endif else begin
         time = time + step
         evt = get_events_c(time + step)
      endelse
      stop
   endwhile

   ; Close the output file.
      
   if (lun ne (-1)) then begin
      close, lun
      free_lun, lun
   endif
end
