; $Id: printl1criscommandtable.pro,v 1.2 1998/07/27 13:43:41 rgr Exp $

; $RCSfile: printl1criscommandtable.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 13:43:41 $
; $Revision: 1.2 $


; This procedures prints dumps of the L1CrisCommandTable structures
; found between the start and stop times.
;
; Arguments
;    t0 = start time in seconds of 1996-(input)
;    t1 = stop time in seconds of 1996-(input)
;
; Keywords
;    file = name of file to send output (default is standard out)
;
;
; Procedures and functions used
;    dumpL1CrisCommandTable
;    get_group_cmd_tables_c

pro printL1CrisCommandTable, t0, t1, FILE=file

   lun = -1
   if (keyword_set(file)) then begin
      get_lun, lun
      openw, lun, file
   endif

   ct = get_group_cmd_tables_c(t0, t1)
   number = n_elements(ct) - 1
   for i=0L, number-1 do begin
      dumpL1CrisCommandTable, ct[i], LUN=lun
      printf, lun
      printf, lun
   endfor

   if (lun ne (-1)) then begin
      close, lun
      free_lun, lun
   endif
end
