; $Id: fetchsistimehistory.pro,v 1.2 1998/05/04 20:27:59 rgr Exp $

; $RCSfile: fetchsistimehistory.pro,v $
; $Author: rgr $
; $Date: 1998/05/04 20:27:59 $
; $Revision: 1.2 $

pro FetchSisTimeHistory, request,                 $
                         sec1996_0,               $
                         sec1996_1,               $
                         sec1996,                 $
                         value,                   $
                         quality,                 $
                         title,                   $
                         units,                   $
                         ndata

   ndata = 0
   case strupcase(request.structure) of

     'L1SISLOWPRIORITYRATE' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1SisLowPriorityRateUnits, field, units
            FetchL1SisLowPriorityRateField, field, sec1996_0,          $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'NUMBEREVENTS') eq 0) then    $
               field = 'NumberEvents'
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1SisLowPriorityRateField, field, sec1996_0,    $
                                             sec1996_1, quality, dummy
            endif
            FetchL1SisLowPriorityRateField, 'Second1996', sec1996_0,   $
                                            sec1996_1, sec1996, dummy
         end

     'L1_1SISLOWPRIORITYRATE' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1_1SisLowPriorityRateUnits, field, units
            FetchL1_1SisLowPriorityRateField, field, sec1996_0,        $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1_1SisLowPriorityRateField, field, sec1996_0,  $
                                             sec1996_1, quality, dummy
            endif
            FetchL1_1SisLowPriorityRateField, 'Second1996', sec1996_0, $
                                            sec1996_1, sec1996, dummy
         end

     'L1SISHSKP' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1SisHskpUnits, field, units
            FetchL1SisHskpField, field, sec1996_0,                     $
                                                 sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1SisHskpField, field, sec1996_0,               $
                                             sec1996_1, quality, dummy
            endif
            FetchL1SisHskpField, 'Second1996', sec1996_0, $
                                            sec1996_1, sec1996, dummy
         end

     'L1_1SISHSKP' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1_1SisHskpUnits, field, units
            FetchL1_1SisHskpField, field, sec1996_0,                   $
                                            sec1996_1, value, ndata
            if (ndata eq 0) then return

            quality = bytarr(ndata)          
            if (strpos(strupcase(field), 'QUALITY') lt 0) then begin
               field = 'Quality' + field 
               if ((strupcase(field) ne 'QUALITYCLOCKCYCLE') and       $
                   (strupcase(field) ne 'QUALITYSECOND1996') and       $
                   (strupcase(field) ne 'QUALITYMICROSECOND')) then    $
                  FetchL1_1SisHskpField, field, sec1996_0,             $
                                             sec1996_1, quality, dummy
            endif
            FetchL1_1SisHskpField, 'Second1996', sec1996_0,            $
                                            sec1996_1, sec1996, dummy
         end

     'L1SISSUMMARY' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1SisSummaryUnits, field, units
            FetchL1SisSummaryField, field, sec1996_0,                  $
                                                sec1996_1, value, ndata
            if (ndata eq 0) then return
            FetchL1SisSummaryField, 'quality', sec1996_0,              $
                                             sec1996_1, quality, dummy
            FetchL1SisSummaryField, 'Second1996', sec1996_0,           $
                                            sec1996_1, sec1996, dummy
            fieldname = strupcase(request.field)
            if ((fieldname eq 'MAINBUSVOLTAGE')          or $
                (fieldname eq 'SISCURRENT')              or $
                (fieldname eq 'SISINTERNALTEMPERATURE1') or $
                (fieldname eq 'SISINTERNALTEMPERATURE2') or $
                (fieldname eq 'SISINTERFACETEMPERATURE') or $
                (fieldname eq 'SISCOVERTELLTALE')       ) then begin
               index = where(value ne 'ff'XB, ndata)
               if (ndata eq 0) then return
               value = value(index)
               quality = quality(index)
               sec1996 = sec1996(index)
            endif
         end

     'L1_1SISSUMMARY' : Begin
            field = request.field
            title= 'SIS ' + field
            FetchL1_1SisSummaryUnits, field, units
            FetchL1_1SisSummaryField, field, sec1996_0,                $
                                                sec1996_1, value, ndata
            if (ndata eq 0) then return
            FetchL1_1SisSummaryField, 'quality', sec1996_0,            $
                                             sec1996_1, quality, dummy
            FetchL1_1SisSummaryField, 'Second1996', sec1996_0,         $
                                            sec1996_1, sec1996, dummy
            fieldname = strupcase(request.field)
            if ((fieldname eq 'MAINBUSVOLTAGE')          or $
                (fieldname eq 'SISCURRENT')              or $
                (fieldname eq 'SISINTERNALTEMPERATURE1') or $
                (fieldname eq 'SISINTERNALTEMPERATURE2') or $
                (fieldname eq 'SISINTERFACETEMPERATURE')) then begin
               index = where(finite(value), ndata)
               if (ndata eq 0) then return
               value = value(index)
               quality = quality(index)
               sec1996 = sec1996(index)
            endif
            if (fieldname eq 'SISCOVERTELLTALE') then begin
               index = where(value ne 'ff'XB, ndata)
               if (ndata eq 0) then return
               value = value(index)
               quality = quality(index)
               sec1996 = sec1996(index)
            endif
         end

      else: print, 'Unrecognized structure: ', request.structure
   endcase

end
