; $Id: printl1_1sisdiagnosticevent.pro,v 1.2 1998/07/27 14:15:08 rgr Exp $

; $RCSfile: printl1_1sisdiagnosticevent.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:15:08 $
; $Revision: 1.2 $


; This procedures prints dumps of the L1_1SisDiagnosticEvent
; structures found between the start and stop times.
;
; Arguments
;    t0 = start time in seconds of 1996-(input)
;    t1 = stop time in seconds of 1996-(input)
;
; Keywords
;    file = name of file to send output (default is standard out)
;
;
; Procedures and functions used
;    dumpL1_1SisDiagnosticEvent
;    get_group_diagnostic_events_se

pro printL1_1SisDiagnosticEvent, t0, t1, FILE=file

   lun = -1
   if (keyword_set(file)) then begin
      get_lun, lun
      openw, lun, file
   endif

   diag = get_group_diagnostic_events_se(t0, t1)
   number = n_elements(diag) - 1
   for i=0L, number-1 do begin
      dumpL1_1SisDiagnosticEvent, diag[i], LUN=lun
      printf, lun
      printf, lun
   endfor

   if (lun ne (-1)) then begin
      close, lun
      free_lun, lun
   endif
end
