; $Id: printl1_1sissubsethskp.pro,v 1.2 1998/07/27 14:17:38 rgr Exp $

; $RCSfile: printl1_1sissubsethskp.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:17:38 $
; $Revision: 1.2 $


; This procedures prints dumps of the housekeeping portion of the
; L1_1SisSubset structures found between the start and stop times.
;
; Arguments
;    t0 = start time in seconds of 1996-(input)
;    t1 = stop time in seconds of 1996-(input)
;
; Keywords
;    file = name of file to send output (default is standard out)
;
;
; Procedures and functions used
;    dumpL1_1SisSubsetHskp
;    get_group_subsets_se

pro printL1_1SisSubsetHskp, t0, t1, FILE=file

   lun = -1
   if (keyword_set(file)) then begin
      get_lun, lun
      openw, lun, file
   endif

   sub = get_group_subsets_se(t0, t1)
   number = n_elements(sub) - 1
   for i=0L, number-1 do begin
      dumpL1_1SisSubsetHskp, sub[i], LUN=lun
   endfor

   if (lun ne (-1)) then begin
      close, lun
      free_lun, lun
   endif
end
