; $Id: printl1sisdacoffset1.pro,v 1.2 1998/07/27 14:19:33 rgr Exp $

; $RCSfile: printl1sisdacoffset1.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:19:33 $
; $Revision: 1.2 $


; This procedures prints dumps of the L1SisDacOffset1 structures found
; between the start and stop times.
;
; Arguments
;    t0 = start time in seconds of 1996-(input)
;    t1 = stop time in seconds of 1996-(input)
;
; Keywords
;    file = name of file to send output (default is standard out)
;
;
; Procedures and functions used
;    dumpL1SisDacOffset1
;    get_group_dac_offset1s_s

pro printL1SisDacOffset1, t0, t1, FILE=file

   lun = -1
   if (keyword_set(file)) then begin
      get_lun, lun
      openw, lun, file
   endif

   dac = get_group_dac_offset1s_s(t0, t1)
   number = n_elements(dac) - 1
   for i=0L, number-1 do begin
      dumpL1SisDacOffset1, dac[i], LUN=lun
      printf, lun
      printf, lun
   endfor

   if (lun ne (-1)) then begin
      close, lun
      free_lun, lun
   endif
end
