; $Id: computesisdataclassrates.pro,v 1.2 1998/07/27 14:28:13 rgr Exp $

; $RCSfile: computesisdataclassrates.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:28:13 $
; $Revision: 1.2 $

pro computeSisDataClassRates, lp, engr

   common SisSymbols

   NBUF = G$_SIS.NumEvtBuffers
   NCLASS = G$_SIS.NumEvtClasses
   OFFSET = G$_SIS.BufferIdOffset
   Z1 = G$_Sis.Z1Buffer
   Z2 = G$_Sis.Z2Buffer

   livetim = (double(engr.livetim) > 1.0d-6)
   helivet = (double(engr.helivet) > 1.0d-6)
   hylivet = (double(engr.hylivet) > 1.0d-6)

   clasacc = double(uncompressSisValue(lp.clasacc))
   clastot = double(uncompressSisValue(lp.clastot))

   EfficiencyInverse = dblarr(n_elements(lp), NCLASS)
   for i=0, NCLASS-1 do begin
      set = where (clasacc eq 0.0D, nset)
      if (nset gt 0) then clasacc[set] = (clastot[set] > 1.0D)
      EfficiencyInverse[*,i] = clastot[i,*] / clasacc[i,*]
   endfor

   for i=0, NBUF-1 do begin
      type = findSisBufferType(i + OFFSET)
      case type of
         Z1 : for j=0, NCLASS-1 do begin 
                 factor = EfficiencyInverse[*,j] / hylivet
                 engr.DataClassRate[j,i] = factor*lp.NumberEvents[j,i]
                 engr.QualityDataClassRate[j,i] =                     $
                                             engr.QualityHylivet or   $
                                             lp.QualityClasacc[j] or  $
                                             lp.QualityClastot[j] or  $
                                             lp.QualityNumberEvents
              endfor
         Z2 : for j=0, NCLASS-1 do begin 
                 factor = EfficiencyInverse[*,j] / helivet
                 engr.DataClassRate[j,i] = factor*lp.NumberEvents[j,i]
                 engr.QualityDataClassRate[j,i] =                     $
                                             engr.QualityHelivet or   $
                                             lp.QualityClasacc[j] or  $
                                             lp.QualityClastot[j] or  $
                                             lp.QualityNumberEvents
              endfor
       ELSE : for j=0, NCLASS-1 do begin 
                 factor = EfficiencyInverse[*,j] / livetim
                 engr.DataClassRate[j,i] = factor*lp.NumberEvents[j,i]
                 engr.QualityDataClassRate[j,i] =                     $
                                             engr.QualityLivetim or   $
                                             lp.QualityClasacc[j] or  $
                                             lp.QualityClastot[j] or  $
                                             lp.QualityNumberEvents
              endfor
      endcase
   endfor

end
