; $Id: cvtsisadctoleakagecurrent.pro,v 1.2 1998/07/27 14:30:25 rgr Exp $

; $RCSfile: cvtsisadctoleakagecurrent.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:30:25 $
; $Revision: 1.2 $

function cvtSisAdcToLeakageCurrent, AdcNumber, adc

   common SisSymbols
   common SbCvtSisAdcToLeakageCurrent, slope, offset

   if (n_elements(slope) eq 0) then begin

      Reff = dblarr(G$_Sis.adc.number, /nozero)
      Reff[*] = 1.0D
      baseline = intarr(G$_Sis.adc.number, /nozero)
      baseline[*] = 600

      T1A = G$_Sis.adc.PostDcT1a   &   T1B = G$_Sis.adc.PostDcT1b
      T2A = G$_Sis.adc.PostDcT2a   &   T2B = G$_Sis.adc.PostDcT2b
      T3A = G$_Sis.adc.PostDcT3a   &   T3B = G$_Sis.adc.PostDcT3b
      T4A = G$_Sis.adc.PostDcT4a   &   T4B = G$_Sis.adc.PostDcT4b
      T5A = G$_Sis.adc.PostDcT5a   &   T5B = G$_Sis.adc.PostDcT5b
      T6A = G$_Sis.adc.PostDcT6a   &   T6B = G$_Sis.adc.PostDcT6b
      T7A = G$_Sis.adc.PostDcT7a   &   T7B = G$_Sis.adc.PostDcT7b
      T8A = G$_Sis.adc.PostDcT8a   &   T8B = G$_Sis.adc.PostDcT8b

      Reff[T1A] = 140.2D     &     Reff[T1B] = 140.2D
      Reff[T2A] = 140.2D     &     Reff[T2B] = 140.2D
      Reff[T3A] = 69.84D     &     Reff[T3B] = 69.84D
      Reff[T4A] = 45.86D     &     Reff[T4B] = 45.86D
      Reff[T5A] = 29.82D     &     Reff[T5B] = 29.82D
      Reff[T6A] = 15.95D     &     Reff[T6B] = 15.95D
      Reff[T7A] = 10.60D     &     Reff[T7B] = 10.60D
      Reff[T8A] = 239.7D     &     Reff[T8B] = 239.7D

      baseline[T1A] = 603   &    baseline[T1B] = 640
      baseline[T2A] = 632   &    baseline[T2B] = 638
      baseline[T3A] = 569   &    baseline[T3B] = 570
      baseline[T4A] = 601   &    baseline[T4B] = 601
      baseline[T5A] = 593   &    baseline[T5B] = 594
      baseline[T6A] = 602   &    baseline[T6B] = 601
      baseline[T7A] = 605   &    baseline[T7B] = 604
      baseline[T8A] = 733   &    baseline[T8B] = 729

      slope = 1.0D/(Reff*0.001D)
      offset = -(double(cvtSisAdcToScaledVoltage(baseline)) /         $
                                                        (Reff*0.001D))
   endif

   return, float(slope[AdcNumber]*cvtSisAdcToScaledVoltage(adc) +     $
                                                    offset[AdcNumber])
end
