function FindSisBufferType, BufferNumber

   common SisSymbols
   common SbFindSisBufferType, BufferType

   if (n_elements(BufferType) eq 0) then begin
      Z1  = G$_Sis.Z1Buffer
      Z2  = G$_Sis.Z2Buffer
      CNO = G$_Sis.CnoBuffer
      HIZ = G$_Sis.HizBuffer
      STM = G$_Sis.StimBuffer
      UND = G$_Sis.UndefinedBuffer

      ;         0    1    2    3    4    5    6    7    8    9

      t = [             UND,  Z1,  Z2,  Z1,  Z1,  Z1,  Z2,  Z2, $ ;  30
               Z2,  Z2,  Z1,  Z1,  Z2,  Z2,  Z1,  Z1,  Z2,  Z2, $ ;  40
               Z1,  Z1,  Z2,  Z2,  Z2,  Z1,  Z1,  Z2,  Z2,  Z2, $ ;  50
              HIZ, HIZ, HIZ, CNO, CNO, CNO, CNO, CNO, CNO, CNO, $ ;  60
              CNO, HIZ, HIZ, HIZ, HIZ, CNO, CNO, CNO, CNO, CNO, $ ;  70
              CNO, CNO, CNO, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, $ ;  80
              HIZ, HIZ, HIZ, HIZ, HIZ, CNO, CNO, CNO, CNO, CNO]   ;  90
      t = [t, CNO, CNO, CNO, CNO, CNO, CNO, CNO, CNO, CNO, CNO, $ ; 100
              CNO, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, $ ; 110
              HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, HIZ, STM]             ; 120
      BufferType = t
   endif

   number = BufferNumber > G$_Sis.BufferIdOffset
   number = (number - G$_Sis.BufferIdOffset) < G$_Sis.NumEvtBuffers
   number = number mod G$_Sis.NumEvtBuffers
   
   return, BufferType[number]
end
