; $Id: get_group_subsets_se.pro,v 1.2 1998/07/27 14:31:59 rgr Exp $

; $RCSfile: get_group_subsets_se.pro,v $
; $Author: rgr $
; $Date: 1998/07/27 14:31:59 $
; $Revision: 1.2 $

; This function generates and returns the L1_1SisSubset structures
; between a start and stop time.
;
; Arguments
;    sec0_1996 - start time in seconds of 1996-(input)
;    sec1_1996 - stop time in seconds of 1996-(input)
;
;
; Procedures and functions used
;    get_group_subsets_s

function get_group_subsets_se, sec0_1996, sec1_1996

   sub = get_group_subsets_s(sec0_1996, sec1_1996)
   nrec = n_elements(sub)
   engr = replicate({L1_1SisSubset}, nrec)

   engr.ClockMinorFrame = sub.ClockMinorFrame
   engr.Second1996 = sub.Second1996
   engr.microsecond = sub.microsecond
   engr.FormatId = sub.FormatId
   engr.MajorFrameCount = sub.MajorFrameCount
   engr.MinorFrameCount = sub.MinorFrameCount
   engr.quality = sub.quality

   ; Convert the ADC's for voltage, currents, and temperatures.

   engr.MainBusVoltage = float(0.15054D * double(sub.MainBusVoltage))
   index = where(sub.MainBusVoltage eq 255B, nindex)
   if (nindex gt 0) then begin
      if (nindex eq 1) then index = index[0]
      engr[index].MainBusVoltage = !values.F_NaN
   endif
   engr.SisCurrent = float(0.005942D * double(sub.SisCurrent))
   index = where(sub.SisCurrent eq 255B, nindex)
   if (nindex gt 0) then begin
      if (nindex eq 1) then index = index[0]
      engr[index].SisCurrent = !values.F_NaN
   endif
   engr.SisInternalTemperature1 =                                     $
       float(-0.62745D * double(sub.SisInternalTemperature1) + 100.0D) 
   index = where(sub.SisInternalTemperature1 eq 255B, nindex)
   if (nindex gt 0) then begin
      if (nindex eq 1) then index = index[0]
      engr[index].SisInternalTemperature1 = !values.F_NaN
   endif
   engr.SisInternalTemperature2 =                                     $
       float(-0.62745D * double(sub.SisInternalTemperature2) + 100.0D) 
   index = where(sub.SisInternalTemperature2 eq 255B, nindex)
   if (nindex gt 0) then begin
      if (nindex eq 1) then index = index[0]
      engr[index].SisInternalTemperature2 = !values.F_NaN
   endif
   engr.SisInterfaceTemperature =                                     $
       float(-0.62745D * double(sub.SisInterfaceTemperature) + 100.0D) 
   index = where(sub.SisInterfaceTemperature eq 255B, nindex)
   if (nindex gt 0) then begin
      if (nindex eq 1) then index = index[0]
      engr[index].SisInterfaceTemperature = !values.F_NaN
   endif

   engr.SisCoverTelltale = sub.SisCoverTelltale
   engr.SisData = sub.SisData

   return, engr

end
