; $Id: scalesishighpriorityrate.pro,v 1.2 1998/08/03 13:37:50 rgr Exp $

; $RCSfile: scalesishighpriorityrate.pro,v $
; $Author: rgr $
; $Date: 1998/08/03 13:37:50 $
; $Revision: 1.2 $


; This function generates and returns the scaling factor necessary to
; convert a SIS high priority rate to seconds (if a live time) or
; counts/second.
;
; Arguments
;   def = definition of the high priority rate-(input)
;
;
; Procedures and functions used
;    expandSisHighPriorityRateDefinition

function scaleSisHighPriorityRate, def

   common SisSymbols
   
   expandSisHighPriorityRateDefinition, def, definition
   factor = ishft(1L, definition.ScaleExp)

   if ((definition.Count1Index eq G$_Sis.rate.livetim) or       $
       (definition.Count1Index eq G$_Sis.rate.helivet) or       $
       (definition.Count1Index eq G$_Sis.rate.hylivet)) then    $
      return, (G$_Sis.LivetimeUnitMicrosecond * 1.0d-6)/factor

   return, 1.0D / (G$_SIS.HighPrioritySampleTime * factor)

end
