/* $Id: computeCrisMiscRates.c,v 1.1 1998/07/27 11:58:11 rgr Exp $ */

/* $RCSfile: computeCrisMiscRates.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 11:58:11 $ */
/* $Revision: 1.1 $ */

#include "hdfi.h"
#include "CrisConstants.h"

#include "cris/L1CrisLowPriorityRate.h"
#include "cris/L1_1CrisLowPriorityRate.h"

#include "cris/uncompressCrisRate.h"


void computeCrisMiscRates(struct L1CrisLowPriorityRate *lp,
                        struct L1_1CrisLowPriorityRate *engr)
{
   float64 unit;
   float64 time;

   unit = (float64) CRIS_LIVETIME_UNIT_MICROSECOND;
   time = (float64) NUM_CRIS_MNFS_PER_CYCLE;

   engr->livetim = (float32) ((unit * lp->livetim) * 1.0e-6);
   engr->helivet = (float32) ((unit * lp->helivet) * 2.0e-6);
   engr->hylivet = (float32) ((unit * lp->hylivet) * 2.0e-6);
   engr->trg0rat =
            (float32) (uncompressCrisRate(lp->trg0rat) / (time/4.0));
   engr->trg1rat =
            (float32) (uncompressCrisRate(lp->trg1rat) / (time/4.0));
   engr->trg01   =
            (float32) (uncompressCrisRate(lp->trg01) / (time/4.0));
   engr->ntagint = (float32) (lp->ntagint / time);
   engr->nvldint = (float32) (lp->nvldint / time);
   engr->nevproc = (float32) (lp->nevproc / time);
   engr->nrtproc = (float32) (lp->nrtproc / time);
   engr->nsfterr = (float32) (lp->nsfterr / time);
   engr->nbadid  = (float32) (lp->nbadid / time);
   engr->ncebful = (float32) (lp->ncebful / time);
   engr->nrebful = (float32) (lp->nrebful / time);
   engr->nmacsys = (float32) (lp->nmacsys / time);
   engr->nhdwrej = (float32) (uncompressCrisRate(lp->nhdwrej) / time);

   engr->QualityLivetim = lp->QualityLivetim;
   engr->QualityHelivet = lp->QualityHelivet;
   engr->QualityHylivet = lp->QualityHylivet;
   engr->QualityTrg0rat = lp->QualityTrg0rat;
   engr->QualityTrg1rat = lp->QualityTrg1rat;
   engr->QualityTrg01   = lp->QualityTrg01;
   engr->QualityNtagint = lp->QualityNtagint;
   engr->QualityNvldint = lp->QualityNvldint;
   engr->QualityNevproc = lp->QualityNevproc;
   engr->QualityNrtproc = lp->QualityNrtproc;
   engr->QualityNsfterr = lp->QualityNsfterr;
   engr->QualityNbadid  = lp->QualityNbadid;
   engr->QualityNcebful = lp->QualityNcebful;
   engr->QualityNrebful = lp->QualityNrebful;
   engr->QualityNhdwrej = lp->QualityNhdwrej;

}
