/* $Id: findCrisBufferType.c,v 1.1 1998/07/27 11:58:28 rgr Exp $ */

/* $RCSfile: findCrisBufferType.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 11:58:28 $ */
/* $Revision: 1.1 $ */

#include "CrisConstants.h"

#define NBUF    NUM_CRIS_EVT_BUFFERS
#define OFFSET  CRIS_BUFFER_ID_OFFSET
#define Z1      CRIS_Z1_BUFFER
#define Z2      CRIS_Z2_BUFFER
#define CNO     CRIS_CNO_BUFFER
#define HIZ     CRIS_HIZ_BUFFER
#define STM     CRIS_STIM_BUFFER
#define UND     CRIS_UNDEFINED_BUFFER


int findCrisBufferType(int BufferNumber)
{
   static int BufferType[] = { 
            UND, UND, UND,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2, /*  0 */
            HIZ, HIZ,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2,  Z2, /* 10 */
             Z2, CNO, HIZ, CNO, CNO, CNO, HIZ, HIZ, HIZ,  Z1, /* 20 */
             Z2, HIZ,  Z1,  Z2, HIZ,  Z1,  Z1,  Z2,  Z2,  Z2, /* 30 */
             Z2,  Z1,  Z1,  Z2,  Z2,  Z2,  Z2, CNO, CNO, CNO, /* 40 */
            CNO, HIZ, HIZ, HIZ, HIZ, CNO, CNO, CNO, CNO, HIZ, /* 50 */
            HIZ, HIZ, HIZ, STM};                              /* 60 */
                                                              /*    */
   /*         0    1    2    3    4    5    6    7    8    9        */

   int number;

   number = (BufferNumber < OFFSET) ? 0 : BufferNumber - OFFSET;
   if (number > NBUF) number = NBUF;
   number %= NBUF;
   
   return BufferType[number];
}

#undef NBUF
#undef OFFSET
#undef Z1
#undef Z2
#undef CNO
#undef HIZ
#undef STM
#undef UND
