#ifndef DUMPL1CRISHIGHPRIORITYRATE_C
   #define DUMPL1CRISHIGHPRIORITYRATE_C

   /* $Id: dumpL1CrisHighPriorityRate.c,v 1.1 1998/07/27 11:53:08 rgr Exp $ */

   /* $RCSfile: dumpL1CrisHighPriorityRate.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:08 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1CrisHighPriorityRate.h"
   #include "utilities/stringDate1996.h"

   void dumpL1CrisHighPriorityRate(struct L1CrisHighPriorityRate hp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS High Priority Rates",
                          "<start time               >      <S/C Clock: xxxxxxxxxx>",
                          "",
                          "Quality         Rate",
                          "<q{0} >  0. <rate{0}>",
                          "<q{1} >  1. <rate{1}>"};

      strcpy(line, template[0]);
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 0, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(hp.Second1996), hp.microsecond);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 33, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", hp.ClockMinorFrame);
         memcpy(line + 33, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, "  %2.2x   ", hp.QualityHp[0]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %7lu ", hp.hp[0]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, "  %2.2x   ", hp.QualityHp[1]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %7lu ", hp.hp[1]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
