#ifndef DUMPL1CRISLOWPRIORITYRATEBUFFER_C
   #define DUMPL1CRISLOWPRIORITYRATEBUFFER_C

   /* $Id: dumpL1CrisLowPriorityRateBuffer.c,v 1.1 1998/07/27 11:53:12 rgr Exp $ */

   /* $RCSfile: dumpL1CrisLowPriorityRateBuffer.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:12 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1CrisLowPriorityRate.h"
   #include "utilities/stringDate1996.h"

   void dumpL1CrisLowPriorityRateBuffer(struct L1CrisLowPriorityRate lp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Low Priority Rates - <start time               >   <S/C Clock: xx.xxxxxxx>",
                          "<QualityNumberEvents: xx>",
                          "",
                          "     Evt Buf  Q           Evt Buf  Q           Evt Buf  Q           Evt Buf  Q",
                          "  0 <buffer{0} >      16 <buffer{16}>      32 <buffer{32}>      48 <buffer{48}>",
                          "  1 <buffer{1} >      17 <buffer{17}>      33 <buffer{33}>      49 <buffer{49}>",
                          "  2 <buffer{2} >      18 <buffer{18}>      34 <buffer{34}>      50 <buffer{50}>",
                          "  3 <buffer{3} >      19 <buffer{19}>      35 <buffer{35}>      51 <buffer{51}>",
                          "  4 <buffer{4} >      20 <buffer{20}>      36 <buffer{36}>      52 <buffer{52}>",
                          "  5 <buffer{5} >      21 <buffer{21}>      37 <buffer{37}>      53 <buffer{53}>",
                          "  6 <buffer{6} >      22 <buffer{22}>      38 <buffer{38}>      54 <buffer{54}>",
                          "  7 <buffer{7} >      23 <buffer{23}>      39 <buffer{39}>      55 <buffer{55}>",
                          "  8 <buffer{8} >      24 <buffer{24}>      40 <buffer{40}>      56 <buffer{56}>",
                          "  9 <buffer{9} >      25 <buffer{25}>      41 <buffer{41}>      57 <buffer{57}>",
                          " 10 <buffer{10}>      26 <buffer{26}>      42 <buffer{42}>      58 <buffer{58}>",
                          " 11 <buffer{11}>      27 <buffer{27}>      43 <buffer{43}>      59 <buffer{59}>",
                          " 12 <buffer{12}>      28 <buffer{28}>      44 <buffer{44}>      60 <buffer{60}>",
                          " 13 <buffer{13}>      29 <buffer{29}>      45 <buffer{45}>      61 <buffer{61}>",
                          " 14 <buffer{14}>      30 <buffer{30}>      46 <buffer{46}>      62 <buffer{62}>",
                          " 15 <buffer{15}>      31 <buffer{31}>      47 <buffer{47}>      63 <buffer{63}>"};

      strcpy(line, template[0]);
         memset(line + 26, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(lp.Second1996), lp.microsecond);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", lp.ClockCycle);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 0, (int) ' ', 25);
         sprintf(segmentValue, " QualityNumberEvents: %2.2x ", lp.QualityNumberEvents);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[0], lp.EventBuffer[0], lp.QualityEventBuffer[0]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[16], lp.EventBuffer[16], lp.QualityEventBuffer[16]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[32], lp.EventBuffer[32], lp.QualityEventBuffer[32]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[48], lp.EventBuffer[48], lp.QualityEventBuffer[48]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[1], lp.EventBuffer[1], lp.QualityEventBuffer[1]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[17], lp.EventBuffer[17], lp.QualityEventBuffer[17]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[33], lp.EventBuffer[33], lp.QualityEventBuffer[33]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[49], lp.EventBuffer[49], lp.QualityEventBuffer[49]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[2], lp.EventBuffer[2], lp.QualityEventBuffer[2]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[18], lp.EventBuffer[18], lp.QualityEventBuffer[18]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[34], lp.EventBuffer[34], lp.QualityEventBuffer[34]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[50], lp.EventBuffer[50], lp.QualityEventBuffer[50]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[3], lp.EventBuffer[3], lp.QualityEventBuffer[3]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[19], lp.EventBuffer[19], lp.QualityEventBuffer[19]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[35], lp.EventBuffer[35], lp.QualityEventBuffer[35]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[51], lp.EventBuffer[51], lp.QualityEventBuffer[51]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[4], lp.EventBuffer[4], lp.QualityEventBuffer[4]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[20], lp.EventBuffer[20], lp.QualityEventBuffer[20]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[36], lp.EventBuffer[36], lp.QualityEventBuffer[36]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[52], lp.EventBuffer[52], lp.QualityEventBuffer[52]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[5], lp.EventBuffer[5], lp.QualityEventBuffer[5]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[21], lp.EventBuffer[21], lp.QualityEventBuffer[21]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[37], lp.EventBuffer[37], lp.QualityEventBuffer[37]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[53], lp.EventBuffer[53], lp.QualityEventBuffer[53]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[6], lp.EventBuffer[6], lp.QualityEventBuffer[6]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[22], lp.EventBuffer[22], lp.QualityEventBuffer[22]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[38], lp.EventBuffer[38], lp.QualityEventBuffer[38]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[54], lp.EventBuffer[54], lp.QualityEventBuffer[54]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[7], lp.EventBuffer[7], lp.QualityEventBuffer[7]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[23], lp.EventBuffer[23], lp.QualityEventBuffer[23]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[39], lp.EventBuffer[39], lp.QualityEventBuffer[39]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[55], lp.EventBuffer[55], lp.QualityEventBuffer[55]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[8], lp.EventBuffer[8], lp.QualityEventBuffer[8]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[24], lp.EventBuffer[24], lp.QualityEventBuffer[24]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[40], lp.EventBuffer[40], lp.QualityEventBuffer[40]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[56], lp.EventBuffer[56], lp.QualityEventBuffer[56]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[9], lp.EventBuffer[9], lp.QualityEventBuffer[9]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[25], lp.EventBuffer[25], lp.QualityEventBuffer[25]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[41], lp.EventBuffer[41], lp.QualityEventBuffer[41]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[57], lp.EventBuffer[57], lp.QualityEventBuffer[57]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[10], lp.EventBuffer[10], lp.QualityEventBuffer[10]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[26], lp.EventBuffer[26], lp.QualityEventBuffer[26]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[42], lp.EventBuffer[42], lp.QualityEventBuffer[42]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[58], lp.EventBuffer[58], lp.QualityEventBuffer[58]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[11], lp.EventBuffer[11], lp.QualityEventBuffer[11]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[27], lp.EventBuffer[27], lp.QualityEventBuffer[27]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[43], lp.EventBuffer[43], lp.QualityEventBuffer[43]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[59], lp.EventBuffer[59], lp.QualityEventBuffer[59]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[12], lp.EventBuffer[12], lp.QualityEventBuffer[12]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[28], lp.EventBuffer[28], lp.QualityEventBuffer[28]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[44], lp.EventBuffer[44], lp.QualityEventBuffer[44]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[60], lp.EventBuffer[60], lp.QualityEventBuffer[60]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[13], lp.EventBuffer[13], lp.QualityEventBuffer[13]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[29], lp.EventBuffer[29], lp.QualityEventBuffer[29]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[45], lp.EventBuffer[45], lp.QualityEventBuffer[45]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[61], lp.EventBuffer[61], lp.QualityEventBuffer[61]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[14], lp.EventBuffer[14], lp.QualityEventBuffer[14]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[30], lp.EventBuffer[30], lp.QualityEventBuffer[30]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[46], lp.EventBuffer[46], lp.QualityEventBuffer[46]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[62], lp.EventBuffer[62], lp.QualityEventBuffer[62]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[15], lp.EventBuffer[15], lp.QualityEventBuffer[15]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[31], lp.EventBuffer[31], lp.QualityEventBuffer[31]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[47], lp.EventBuffer[47], lp.QualityEventBuffer[47]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %3u %3lu %2.2x ", lp.NumberEvents[63], lp.EventBuffer[63], lp.QualityEventBuffer[63]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
