#ifndef DUMPL1CRISLOWPRIORITYRATESINGLE_C
   #define DUMPL1CRISLOWPRIORITYRATESINGLE_C

   /* $Id: dumpL1CrisLowPriorityRateSingle.c,v 1.1 1998/07/27 11:53:13 rgr Exp $ */

   /* $RCSfile: dumpL1CrisLowPriorityRateSingle.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:13 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1CrisLowPriorityRate.h"
   #include "cris/uncompressCrisRate.h"
   #include "utilities/stringDate1996.h"

   void dumpL1CrisLowPriorityRateSingle(struct L1CrisLowPriorityRate lp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Low Priority Rates - <start time               >   <S/C Clock: xxxxxxxxxx>",
                          "",
                          "<livetim: xxxxxxx xx>   <ntagint: xxxxxx xx>   <nmacsys: xxxxxx xx>",
                          "<helivet: xxxxxxx xx>   <nvldint: xxxxxx xx>     <stmco: xxxxxx xx>",
                          "<hylivet: xxxxxxx xx>   <nevproc: xxxxxx xx>    <stmoff: xxxxxx xx>",
                          "<trg0rat: xxxxxxx xx>   <nrtproc: xxxxxx xx>    <hazard: xxxxxx xx>",
                          "<trg1rat: xxxxxxx xx>   <nsfterr: xxxxxx xx>        <gh: xxxxxx xx>",
                          "  <trg01: xxxxxxx xx>    <nbadid: xxxxxx xx>       <mor: xxxxxx xx>",
                          "<nhdwrej: xxxxxxx xx>   <ncebful: xxxxxx xx>       <hor: xxxxxx xx>",
                          "                        <nrebful: xxxxxx xx>",
                          "",
                          "  <e1a: xxxxxx xx>   <g2ab: xxxxxx xx>      <e1c: xxxxxx xx>   <g2cd: xxxxxx xx>",
                          "  <e1b: xxxxxx xx>   <g3ab: xxxxxx xx>      <e1d: xxxxxx xx>   <g3cd: xxxxxx xx>",
                          " <e2ab: xxxxxx xx>   <g4ab: xxxxxx xx>     <e2cd: xxxxxx xx>   <g4cd: xxxxxx xx>",
                          " <e3ab: xxxxxx xx>   <g5ab: xxxxxx xx>     <e3cd: xxxxxx xx>   <g5cd: xxxxxx xx>",
                          " <e4ab: xxxxxx xx>   <g6ab: xxxxxx xx>     <e4cd: xxxxxx xx>   <g6cd: xxxxxx xx>",
                          " <e5ab: xxxxxx xx>   <g7ab: xxxxxx xx>     <e5cd: xxxxxx xx>   <g7cd: xxxxxx xx>",
                          " <e6ab: xxxxxx xx> <adc2ab: xxxxxx xx>     <e6cd: xxxxxx xx> <adc2cd: xxxxxx xx>",
                          " <e7ab: xxxxxx xx> <mnrgab: xxxxxx xx>     <e7cd: xxxxxx xx> <mnrgcd: xxxxxx xx>",
                          " <e8ab: xxxxxx xx>   <z1ab: xxxxxx xx>     <e8cd: xxxxxx xx>   <z1cd: xxxxxx xx>",
                          " <e9ab: xxxxxx xx>   <z2ab: xxxxxx xx>     <e9cd: xxxxxx xx>   <z2cd: xxxxxx xx>",
                          "                 <z_gt_2ab: xxxxxx xx>                     <z_gt_2cd: xxxxxx xx>"};

      strcpy(line, template[0]);
         memset(line + 26, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(lp.Second1996), lp.microsecond);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", lp.ClockCycle);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " livetim: %7lu %2.2x ", lp.livetim, lp.QualityLivetim);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " ntagint: %6lu %2.2x ", lp.ntagint, lp.QualityNtagint);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 47, (int) ' ', 20);
         sprintf(segmentValue, " nmacsys: %6lu %2.2x ", lp.nmacsys, lp.QualityNmacsys);
         memcpy(line + 47, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " helivet: %7lu %2.2x ", lp.helivet, lp.QualityHelivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nvldint: %6lu %2.2x ", lp.nvldint, lp.QualityNvldint);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 49, (int) ' ', 18);
         sprintf(segmentValue, " stmco: %6lu %2.2x ", lp.stmco, lp.QualityStmco);
         memcpy(line + 49, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " hylivet: %7lu %2.2x ", lp.hylivet, lp.QualityHylivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nevproc: %6lu %2.2x ", lp.nevproc, lp.QualityNevproc);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 19);
         sprintf(segmentValue, " stmoff: %6lu %2.2x ", lp.stmoff, lp.QualityStmoff);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " trg0rat: %7lu %2.2x ", uncompressCrisRate(lp.trg0rat), lp.QualityTrg0rat);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nrtproc: %6lu %2.2x ", lp.nrtproc, lp.QualityNrtproc);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 19);
         sprintf(segmentValue, " hazard: %6lu %2.2x ", lp.hazard, lp.QualityHazard);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " trg1rat: %7lu %2.2x ", uncompressCrisRate(lp.trg1rat), lp.QualityTrg1rat);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nsfterr: %6lu %2.2x ", lp.nsfterr, lp.QualityNsfterr);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 15);
         sprintf(segmentValue, " gh: %6lu %2.2x ", lp.gh, lp.QualityGh);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 2, (int) ' ', 19);
         sprintf(segmentValue, " trg01: %7lu %2.2x ", uncompressCrisRate(lp.trg01), lp.QualityTrg01);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 19);
         sprintf(segmentValue, " nbadid: %6lu %2.2x ", lp.nbadid, lp.QualityNbadid);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 16);
         sprintf(segmentValue, " mor: %6lu %2.2x ", lp.mor, lp.QualityMor);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " nhdwrej: %7lu %2.2x ", uncompressCrisRate(lp.nhdwrej), lp.QualityNhdwrej);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " ncebful: %6lu %2.2x ", lp.ncebful, lp.QualityNcebful);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 16);
         sprintf(segmentValue, " hor: %6lu %2.2x ", lp.hor, lp.QualityHor);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nrebful: %6lu %2.2x ", lp.nrebful, lp.QualityNrebful);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 2, (int) ' ', 16);
         sprintf(segmentValue, " e1a: %6lu %2.2x ", lp.e1a, lp.QualityE1a);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g2ab: %6lu %2.2x ", lp.g2ab, lp.QualityG2ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 16);
         sprintf(segmentValue, " e1c: %6lu %2.2x ", lp.e1c, lp.QualityE1c);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g2cd: %6lu %2.2x ", lp.g2cd, lp.QualityG2cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 2, (int) ' ', 16);
         sprintf(segmentValue, " e1b: %6lu %2.2x ", lp.e1b, lp.QualityE1b);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g3ab: %6lu %2.2x ", lp.g3ab, lp.QualityG3ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 16);
         sprintf(segmentValue, " e1d: %6lu %2.2x ", lp.e1d, lp.QualityE1d);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g3cd: %6lu %2.2x ", lp.g3cd, lp.QualityG3cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e2ab: %6lu %2.2x ", lp.e2ab, lp.QualityE2ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g4ab: %6lu %2.2x ", lp.g4ab, lp.QualityG4ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e2cd: %6lu %2.2x ", lp.e2cd, lp.QualityE2cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g4cd: %6lu %2.2x ", lp.g4cd, lp.QualityG4cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e3ab: %6lu %2.2x ", lp.e3ab, lp.QualityE3ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g5ab: %6lu %2.2x ", lp.g5ab, lp.QualityG5ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e3cd: %6lu %2.2x ", lp.e3cd, lp.QualityE3cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g5cd: %6lu %2.2x ", lp.g5cd, lp.QualityG5cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e4ab: %6lu %2.2x ", lp.e4ab, lp.QualityE4ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g6ab: %6lu %2.2x ", lp.g6ab, lp.QualityG6ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e4cd: %6lu %2.2x ", lp.e4cd, lp.QualityE4cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g6cd: %6lu %2.2x ", lp.g6cd, lp.QualityG6cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e5ab: %6lu %2.2x ", lp.e5ab, lp.QualityE5ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g7ab: %6lu %2.2x ", lp.g7ab, lp.QualityG7ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e5cd: %6lu %2.2x ", lp.e5cd, lp.QualityE5cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g7cd: %6lu %2.2x ", lp.g7cd, lp.QualityG7cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e6ab: %6lu %2.2x ", lp.e6ab, lp.QualityE6ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 19);
         sprintf(segmentValue, " adc2ab: %6lu %2.2x ", lp.adc2ab, lp.QualityAdc2ab);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e6cd: %6lu %2.2x ", lp.e6cd, lp.QualityE6cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 19);
         sprintf(segmentValue, " adc2cd: %6lu %2.2x ", lp.adc2cd, lp.QualityAdc2cd);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e7ab: %6lu %2.2x ", lp.e7ab, lp.QualityE7ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 19);
         sprintf(segmentValue, " mnrgab: %6lu %2.2x ", lp.mnrgab, lp.QualityMnrgab);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e7cd: %6lu %2.2x ", lp.e7cd, lp.QualityE7cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 19);
         sprintf(segmentValue, " mnrgcd: %6lu %2.2x ", lp.mnrgcd, lp.QualityMnrgcd);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e8ab: %6lu %2.2x ", lp.e8ab, lp.QualityE8ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " z1ab: %6lu %2.2x ", lp.z1ab, lp.QualityZ1ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e8cd: %6lu %2.2x ", lp.e8cd, lp.QualityE8cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " z1cd: %6lu %2.2x ", lp.z1cd, lp.QualityZ1cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e9ab: %6lu %2.2x ", lp.e9ab, lp.QualityE9ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " z2ab: %6lu %2.2x ", lp.z2ab, lp.QualityZ2ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e9cd: %6lu %2.2x ", lp.e9cd, lp.QualityE9cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " z2cd: %6lu %2.2x ", lp.z2cd, lp.QualityZ2cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 17, (int) ' ', 21);
         sprintf(segmentValue, " z_gt_2ab: %6lu %2.2x ", lp.z_gt_2ab, lp.QualityZ_gt_2ab);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 21);
         sprintf(segmentValue, " z_gt_2cd: %6lu %2.2x ", lp.z_gt_2cd, lp.QualityZ_gt_2cd);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
