#ifndef DUMPL1CRISSUBSETTELEMETRY_C
   #define DUMPL1CRISSUBSETTELEMETRY_C

   /* $Id: dumpL1CrisSubsetTelemetry.c,v 1.1 1998/07/27 11:53:15 rgr Exp $ */

   /* $RCSfile: dumpL1CrisSubsetTelemetry.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:15 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1CrisSubset.h"
   #include "utilities/stringDate1996.h"

   void dumpL1CrisSubsetTelemetry(struct L1CrisSubset sub)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"<start time               >   <S/C Clock: xxxxxxxxxx>  <MJF: x xx>",
                          "   <dt{0}  ><dt{4}  ><dt{8}  ><dt{12} >  <dt{16} ><dt{20} ><dt{24} ><dt{28} >",
                          "   <dt{32} ><dt{36} ><dt{40} ><dt{44} >  <dt{48} ><dt{52} ><data56 >"};

      strcpy(line, template[0]);
         memset(line + 0, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(sub.Second1996), sub.microsecond);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", sub.ClockMinorFrame);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 55, (int) ' ', 11);
         sprintf(segmentValue, " MJF: %1d %2.2d ", sub.MajorFrameCount, sub.MinorFrameCount);
         memcpy(line + 55, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[0], sub.CrisData[0+1], sub.CrisData[0+2], sub.CrisData[0+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[4], sub.CrisData[4+1], sub.CrisData[4+2], sub.CrisData[4+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[8], sub.CrisData[8+1], sub.CrisData[8+2], sub.CrisData[8+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[12], sub.CrisData[12+1], sub.CrisData[12+2], sub.CrisData[12+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[16], sub.CrisData[16+1], sub.CrisData[16+2], sub.CrisData[16+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[20], sub.CrisData[20+1], sub.CrisData[20+2], sub.CrisData[20+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[24], sub.CrisData[24+1], sub.CrisData[24+2], sub.CrisData[24+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[28], sub.CrisData[28+1], sub.CrisData[28+2], sub.CrisData[28+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[32], sub.CrisData[32+1], sub.CrisData[32+2], sub.CrisData[32+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[36], sub.CrisData[36+1], sub.CrisData[36+2], sub.CrisData[36+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[40], sub.CrisData[40+1], sub.CrisData[40+2], sub.CrisData[40+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[44], sub.CrisData[44+1], sub.CrisData[44+2], sub.CrisData[44+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[48], sub.CrisData[48+1], sub.CrisData[48+2], sub.CrisData[48+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.CrisData[52], sub.CrisData[52+1], sub.CrisData[52+2], sub.CrisData[52+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x    ", sub.CrisData[56], sub.CrisData[57]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
