#ifndef DUMPL1_1CRISHSKP_C
   #define DUMPL1_1CRISHSKP_C

   /* $Id: dumpL1_1CrisHskp.c,v 1.1 1998/07/27 11:53:18 rgr Exp $ */

   /* $RCSfile: dumpL1_1CrisHskp.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:18 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1_1CrisHskp.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1CrisHskp(struct L1_1CrisHskp hskp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Housekeeping - <start time               >   <S/C Clock: xxxxxxxxxx>",
                          "",
                          "Temperature(DegC):               Voltage(V):         Leakage Current(microA):",
                          "<Motherboard Elect: xxx.xx xx>     <+5V: xxx.xx xx>   <E1A: xxx.xx xx>  <E1C: xxx.xx xx>",
                          "  <Motherboard Det: xxx.xx xx>     <+6V: xxx.xx xx>   <E1B: xxx.xx xx>  <E1D: xxx.xx xx>",
                          "    <Motherboard C: xxx.xx xx>     <-6V: xxx.xx xx>  <E2AB: xxx.xx xx> <E2CD: xxx.xx xx>",
                          "     <Analog Board: xxx.xx xx>   <+7.3V: xxx.xx xx>  <E3AB: xxx.xx xx> <E3CD: xxx.xx xx>",
                          "    <PostReg Board: xxx.xx xx>   <-7.3V: xxx.xx xx>  <E4AB: xxx.xx xx> <E4CD: xxx.xx xx>",
                          "      <Logic Board: xxx.xx xx>    <+12V: xxx.xx xx>  <E5AB: xxx.xx xx> <E5CD: xxx.xx xx>",
                          "        <E12 Elect: xxx.xx xx>    <-12V: xxx.xx xx>  <E6AB: xxx.xx xx> <E6CD: xxx.xx xx>",
                          "          <E12 Det: xxx.xx xx>  <+13.4V: xxx.xx xx>  <E7AB: xxx.xx xx> <E7CD: xxx.xx xx>",
                          "        <E34 Elect: xxx.xx xx>  <-13.4V: xxx.xx xx>  <E8AB: xxx.xx xx> <E8CD: xxx.xx xx>",
                          "          <E34 Det: xxx.xx xx>    <+15V: xxx.xx xx>  <E9AB: xxx.xx xx> <E9CD: xxx.xx xx>",
                          "        <E56 Elect: xxx.xx xx>    <+19V: xxx.xx xx>  <G2AB: xxx.xx xx> <G2CD: xxx.xx xx>",
                          "          <E56 Det: xxx.xx xx><MCP1(kV): xxx.xx xx>  <G3AB: xxx.xx xx> <G3CD: xxx.xx xx>",
                          "       <E789 Elect: xxx.xx xx><MCP2(kV): xxx.xx xx>  <G4AB: xxx.xx xx> <G4CD: xxx.xx xx>",
                          "         <E789 Det: xxx.xx xx>                       <G5AB: xxx.xx xx> <G5CD: xxx.xx xx>",
                          "             <LVPS: xxx.xx xx> Current(Scaled V):    <G6AB: xxx.xx xx> <G6CD: xxx.xx xx>",
                          "             <HVPS: xxx.xx xx>  <HVPS 1: xxx.xx xx>  <G7AB: xxx.xx xx> <G7CD: xxx.xx xx>",
                          " <Fiber Plane Top0: xxx.xx xx>  <HVPS 2: xxx.xx xx>",
                          " <Fiber Plane Top1: xxx.xx xx>  <HVPS 3: xxx.xx xx> DAC(V):",
                          "  <Fiber Plane Mid: xxx.xx xx>  <HVPS 4: xxx.xx xx>  <G2AB: yyy.yy yy> <G2CD: yyy.yy yy>",
                          "  <Fiber Plane Bot: xxx.xx xx>                       <G3AB: yyy.yy yy> <G3CD: yyy.yy yy>",
                          "<Image Int. 1 Side: xxx.xx xx> Current(microA):      <G4AB: yyy.yy yy> <G4CD: yyy.yy yy>",
                          "<Image Int. 1 Rear: xxx.xx xx><SoftPS A: xxx.xx xx>  <G5AB: yyy.yy yy> <G5CD: yyy.yy yy>",
                          "   <Camera 1 Elect: xxx.xx xx><SoftPS B: xxx.xx xx>  <G6AB: yyy.yy yy> <G6CD: yyy.yy yy>",
                          "           <HVPS 1: yyy.yy yy>                       <G7AB: yyy.yy yy> <G7CD: yyy.yy yy>",
                          "<Image Int. 2 Side: xxx.xx xx>                       <E9AB: yyy.yy yy> <E9CD: yyy.yy yy>",
                          "<Image Int. 2 Rear: xxx.xx xx>                  ",
                          "   <Camera 2 Elect: xxx.xx xx>                  ",
                          "           <HVPS 2: yyy.yy yy>                  "};

      strcpy(line, template[0]);
         memset(line + 20, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(hskp.Second1996), hskp.microsecond);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", hskp.ClockCycle);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 30);
         sprintf(segmentValue, " Motherboard Elect:%6.2f %2.2x ", hskp.TemperatureMotherBoardElect, hskp.QualityTemperatureMotherBoardElect);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 16);
         sprintf(segmentValue, " +5V:%6.2f %2.2x ", hskp.MonitorP5V, hskp.QualityMonitorP5V);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 16);
         sprintf(segmentValue, " E1A:%6.2f %2.2x ", hskp.LeakageCurrentE1a, hskp.QualityLeakageCurrentE1a);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 72, (int) ' ', 16);
         sprintf(segmentValue, " E1C:%6.2f %2.2x ", hskp.LeakageCurrentE1c, hskp.QualityLeakageCurrentE1c);
         memcpy(line + 72, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 2, (int) ' ', 28);
         sprintf(segmentValue, " Motherboard Det:%6.2f %2.2x ", hskp.TemperatureMotherBoardDet, hskp.QualityTemperatureMotherBoardDet);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 16);
         sprintf(segmentValue, " +6V:%6.2f %2.2x ", hskp.MonitorP6V, hskp.QualityMonitorP6V);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 16);
         sprintf(segmentValue, " E1B:%6.2f %2.2x ", hskp.LeakageCurrentE1b, hskp.QualityLeakageCurrentE1b);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 72, (int) ' ', 16);
         sprintf(segmentValue, " E1D:%6.2f %2.2x ", hskp.LeakageCurrentE1d, hskp.QualityLeakageCurrentE1d);
         memcpy(line + 72, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 4, (int) ' ', 26);
         sprintf(segmentValue, " Motherboard C:%6.2f %2.2x ", hskp.TemperatureMotherBoardC, hskp.QualityTemperatureMotherBoardC);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 16);
         sprintf(segmentValue, " -6V:%6.2f %2.2x ", hskp.MonitorM6V, hskp.QualityMonitorM6V);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E2AB:%6.2f %2.2x ", hskp.LeakageCurrentE2ab, hskp.QualityLeakageCurrentE2ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E2CD:%6.2f %2.2x ", hskp.LeakageCurrentE2cd, hskp.QualityLeakageCurrentE2cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 5, (int) ' ', 25);
         sprintf(segmentValue, " Analog Board:%6.2f %2.2x ", hskp.TemperatureAnalogBoard, hskp.QualityTemperatureAnalogBoard);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 33, (int) ' ', 18);
         sprintf(segmentValue, " +7.3V:%6.2f %2.2x ", hskp.MonitorP7V, hskp.QualityMonitorP7V);
         memcpy(line + 33, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E3AB:%6.2f %2.2x ", hskp.LeakageCurrentE3ab, hskp.QualityLeakageCurrentE3ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E3CD:%6.2f %2.2x ", hskp.LeakageCurrentE3cd, hskp.QualityLeakageCurrentE3cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 4, (int) ' ', 26);
         sprintf(segmentValue, " PostReg Board:%6.2f %2.2x ", hskp.TemperaturePostRegBoard, hskp.QualityTemperaturePostRegBoard);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 33, (int) ' ', 18);
         sprintf(segmentValue, " -7.3V:%6.2f %2.2x ", hskp.MonitorM7V, hskp.QualityMonitorM7V);
         memcpy(line + 33, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E4AB:%6.2f %2.2x ", hskp.LeakageCurrentE4ab, hskp.QualityLeakageCurrentE4ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E4CD:%6.2f %2.2x ", hskp.LeakageCurrentE4cd, hskp.QualityLeakageCurrentE4cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 6, (int) ' ', 24);
         sprintf(segmentValue, " Logic Board:%6.2f %2.2x ", hskp.TemperatureLogicBoard, hskp.QualityTemperatureLogicBoard);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 17);
         sprintf(segmentValue, " +12V:%6.2f %2.2x ", hskp.MonitorP12V, hskp.QualityMonitorP12V);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E5AB:%6.2f %2.2x ", hskp.LeakageCurrentE5ab, hskp.QualityLeakageCurrentE5ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E5CD:%6.2f %2.2x ", hskp.LeakageCurrentE5cd, hskp.QualityLeakageCurrentE5cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 8, (int) ' ', 22);
         sprintf(segmentValue, " E12 Elect:%6.2f %2.2x ", hskp.TemperatureE12Elect, hskp.QualityTemperatureE12Elect);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 17);
         sprintf(segmentValue, " -12V:%6.2f %2.2x ", hskp.MonitorM12V, hskp.QualityMonitorM12V);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E6AB:%6.2f %2.2x ", hskp.LeakageCurrentE6ab, hskp.QualityLeakageCurrentE6ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E6CD:%6.2f %2.2x ", hskp.LeakageCurrentE6cd, hskp.QualityLeakageCurrentE6cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 10, (int) ' ', 20);
         sprintf(segmentValue, " E12 Det:%6.2f %2.2x ", hskp.TemperatureE12Det, hskp.QualityTemperatureE12Det);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " +13.4V:%6.2f %2.2x ", hskp.MonitorP13V, hskp.QualityMonitorP13V);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E7AB:%6.2f %2.2x ", hskp.LeakageCurrentE7ab, hskp.QualityLeakageCurrentE7ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E7CD:%6.2f %2.2x ", hskp.LeakageCurrentE7cd, hskp.QualityLeakageCurrentE7cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 8, (int) ' ', 22);
         sprintf(segmentValue, " E34 Elect:%6.2f %2.2x ", hskp.TemperatureE34Elect, hskp.QualityTemperatureE34Elect);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " -13.4V:%6.2f %2.2x ", hskp.MonitorM13V, hskp.QualityMonitorM13V);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E8AB:%6.2f %2.2x ", hskp.LeakageCurrentE8ab, hskp.QualityLeakageCurrentE8ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E8CD:%6.2f %2.2x ", hskp.LeakageCurrentE8cd, hskp.QualityLeakageCurrentE8cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 10, (int) ' ', 20);
         sprintf(segmentValue, " E34 Det:%6.2f %2.2x ", hskp.TemperatureE34Det, hskp.QualityTemperatureE34Det);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 17);
         sprintf(segmentValue, " +15V:%6.2f %2.2x ", hskp.MonitorP15V, hskp.QualityMonitorP15V);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E9AB:%6.2f %2.2x ", hskp.LeakageCurrentE9ab, hskp.QualityLeakageCurrentE9ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E9CD:%6.2f %2.2x ", hskp.LeakageCurrentE9cd, hskp.QualityLeakageCurrentE9cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 8, (int) ' ', 22);
         sprintf(segmentValue, " E56 Elect:%6.2f %2.2x ", hskp.TemperatureE56Elect, hskp.QualityTemperatureE56Elect);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 17);
         sprintf(segmentValue, " +19V:%6.2f %2.2x ", hskp.MonitorP19V, hskp.QualityMonitorP19V);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G2AB:%6.2f %2.2x ", hskp.LeakageCurrentG2ab, hskp.QualityLeakageCurrentG2ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G2CD:%6.2f %2.2x ", hskp.LeakageCurrentG2cd, hskp.QualityLeakageCurrentG2cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 10, (int) ' ', 20);
         sprintf(segmentValue, " E56 Det:%6.2f %2.2x ", hskp.TemperatureE56Det, hskp.QualityTemperatureE56Det);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 21);
         sprintf(segmentValue, " MCP1(kV):%6.2f %2.2x ", hskp.MonitorMcp1, hskp.QualityMonitorMcp1);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G3AB:%6.2f %2.2x ", hskp.LeakageCurrentG3ab, hskp.QualityLeakageCurrentG3ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G3CD:%6.2f %2.2x ", hskp.LeakageCurrentG3cd, hskp.QualityLeakageCurrentG3cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 7, (int) ' ', 23);
         sprintf(segmentValue, " E789 Elect:%6.2f %2.2x ", hskp.TemperatureE789Elect, hskp.QualityTemperatureE789Elect);
         memcpy(line + 7, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 21);
         sprintf(segmentValue, " MCP2(kV):%6.2f %2.2x ", hskp.MonitorMcp2, hskp.QualityMonitorMcp2);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G4AB:%6.2f %2.2x ", hskp.LeakageCurrentG4ab, hskp.QualityLeakageCurrentG4ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G4CD:%6.2f %2.2x ", hskp.LeakageCurrentG4cd, hskp.QualityLeakageCurrentG4cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 9, (int) ' ', 21);
         sprintf(segmentValue, " E789 Det:%6.2f %2.2x ", hskp.TemperatureE789Det, hskp.QualityTemperatureE789Det);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G5AB:%6.2f %2.2x ", hskp.LeakageCurrentG5ab, hskp.QualityLeakageCurrentG5ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G5CD:%6.2f %2.2x ", hskp.LeakageCurrentG5cd, hskp.QualityLeakageCurrentG5cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 13, (int) ' ', 17);
         sprintf(segmentValue, " LVPS:%6.2f %2.2x ", hskp.TemperatureLvps, hskp.QualityTemperatureLvps);
         memcpy(line + 13, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G6AB:%6.2f %2.2x ", hskp.LeakageCurrentG6ab, hskp.QualityLeakageCurrentG6ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G6CD:%6.2f %2.2x ", hskp.LeakageCurrentG6cd, hskp.QualityLeakageCurrentG6cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 13, (int) ' ', 17);
         sprintf(segmentValue, " HVPS:%6.2f %2.2x ", hskp.TemperatureHvps, hskp.QualityTemperatureHvps);
         memcpy(line + 13, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 1:%6.2f %2.2x ", hskp.MonitorHvps1I, hskp.QualityMonitorHvps1I);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G7AB:%6.2f %2.2x ", hskp.LeakageCurrentG7ab, hskp.QualityLeakageCurrentG7ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G7CD:%6.2f %2.2x ", hskp.LeakageCurrentG7cd, hskp.QualityLeakageCurrentG7cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 1, (int) ' ', 29);
         sprintf(segmentValue, " Fiber Plane Top0:%6.2f %2.2x ", hskp.TemperatureFiberPlaneTop0, hskp.QualityTemperatureFiberPlaneTop0);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 2:%6.2f %2.2x ", hskp.MonitorHvps2I, hskp.QualityMonitorHvps2I);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 1, (int) ' ', 29);
         sprintf(segmentValue, " Fiber Plane Top1:%6.2f %2.2x ", hskp.TemperatureFiberPlaneTop1, hskp.QualityTemperatureFiberPlaneTop1);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 3:%6.2f %2.2x ", hskp.MonitorHvps3I, hskp.QualityMonitorHvps3I);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 2, (int) ' ', 28);
         sprintf(segmentValue, " Fiber Plane Mid:%6.2f %2.2x ", hskp.TemperatureFiberPlaneMid, hskp.QualityTemperatureFiberPlaneMid);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 32, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 4:%6.2f %2.2x ", hskp.MonitorHvps4I, hskp.QualityMonitorHvps4I);
         memcpy(line + 32, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G2AB:%6.2f %2.2x ", hskp.DacG2ab, hskp.QualityDacG2ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G2CD:%6.2f %2.2x ", hskp.DacG2cd, hskp.QualityDacG2cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 2, (int) ' ', 28);
         sprintf(segmentValue, " Fiber Plane Bot:%6.2f %2.2x ", hskp.TemperatureFiberPlaneBot, hskp.QualityTemperatureFiberPlaneBot);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G3AB:%6.2f %2.2x ", hskp.DacG3ab, hskp.QualityDacG3ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G3CD:%6.2f %2.2x ", hskp.DacG3cd, hskp.QualityDacG3cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 0, (int) ' ', 30);
         sprintf(segmentValue, " Image Int. 1 Side:%6.2f %2.2x ", hskp.TemperatureImageInt1Side, hskp.QualityTemperatureImageInt1Side);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G4AB:%6.2f %2.2x ", hskp.DacG4ab, hskp.QualityDacG4ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G4CD:%6.2f %2.2x ", hskp.DacG4cd, hskp.QualityDacG4cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 0, (int) ' ', 30);
         sprintf(segmentValue, " Image Int. 1 Rear:%6.2f %2.2x ", hskp.TemperatureImageInt1Rear, hskp.QualityTemperatureImageInt1Rear);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 21);
         sprintf(segmentValue, " SoftPS A:%6.2f %2.2x ", hskp.MonitorSoftPsaI, hskp.QualityMonitorSoftPsaI);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G5AB:%6.2f %2.2x ", hskp.DacG5ab, hskp.QualityDacG5ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G5CD:%6.2f %2.2x ", hskp.DacG5cd, hskp.QualityDacG5cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 3, (int) ' ', 27);
         sprintf(segmentValue, " Camera 1 Elect:%6.2f %2.2x ", hskp.TemperatureCamera1Elect, hskp.QualityTemperatureCamera1Elect);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 21);
         sprintf(segmentValue, " SoftPS B:%6.2f %2.2x ", hskp.MonitorSoftPsbI, hskp.QualityMonitorSoftPsbI);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G6AB:%6.2f %2.2x ", hskp.DacG6ab, hskp.QualityDacG6ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G6CD:%6.2f %2.2x ", hskp.DacG6cd, hskp.QualityDacG6cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 11, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 1:%6.2f %2.2x ", hskp.TemperatureHvps1, hskp.QualityTemperatureHvps1);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " G7AB:%6.2f %2.2x ", hskp.DacG7ab, hskp.QualityDacG7ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " G7CD:%6.2f %2.2x ", hskp.DacG7cd, hskp.QualityDacG7cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 0, (int) ' ', 30);
         sprintf(segmentValue, " Image Int. 2 Side:%6.2f %2.2x ", hskp.TemperatureImageInt2Side, hskp.QualityTemperatureImageInt2Side);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 17);
         sprintf(segmentValue, " E9AB:%6.2f %2.2x ", hskp.DacE9ab, hskp.QualityDacE9ab);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 17);
         sprintf(segmentValue, " E9CD:%6.2f %2.2x ", hskp.DacE9cd, hskp.QualityDacE9cd);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 0, (int) ' ', 30);
         sprintf(segmentValue, " Image Int. 2 Rear:%6.2f %2.2x ", hskp.TemperatureImageInt2Rear, hskp.QualityTemperatureImageInt2Rear);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 3, (int) ' ', 27);
         sprintf(segmentValue, " Camera 2 Elect:%6.2f %2.2x ", hskp.TemperatureCamera2Elect, hskp.QualityTemperatureCamera2Elect);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 11, (int) ' ', 19);
         sprintf(segmentValue, " HVPS 2:%6.2f %2.2x ", hskp.TemperatureHvps2, hskp.QualityTemperatureHvps2);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
