#ifndef DUMPL1_1CRISLOWPRIORITYRATEBUFFER_C
   #define DUMPL1_1CRISLOWPRIORITYRATEBUFFER_C

   /* $Id: dumpL1_1CrisLowPriorityRateBuffer.c,v 1.1 1998/07/27 11:53:19 rgr Exp $ */

   /* $RCSfile: dumpL1_1CrisLowPriorityRateBuffer.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:19 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1_1CrisLowPriorityRate.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1CrisLowPriorityRateBuffer(struct L1_1CrisLowPriorityRate lp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Low Priority Rates - <start time               >   <S/C Clock: xx.xxxxxxx>",
                          "",
                          "    Buffer(c/s)          Buffer(c/s)          Buffer(c/s)          Buffer(c/s)",
                          "  0 <buffer{0} >      16 <buffer{16}>      32 <buffer{32}>      48 <buffer{48}>",
                          "  1 <buffer{1} >      17 <buffer{17}>      33 <buffer{33}>      49 <buffer{49}>",
                          "  2 <buffer{2} >      18 <buffer{18}>      34 <buffer{34}>      50 <buffer{50}>",
                          "  3 <buffer{3} >      19 <buffer{19}>      35 <buffer{35}>      51 <buffer{51}>",
                          "  4 <buffer{4} >      20 <buffer{20}>      36 <buffer{36}>      52 <buffer{52}>",
                          "  5 <buffer{5} >      21 <buffer{21}>      37 <buffer{37}>      53 <buffer{53}>",
                          "  6 <buffer{6} >      22 <buffer{22}>      38 <buffer{38}>      54 <buffer{54}>",
                          "  7 <buffer{7} >      23 <buffer{23}>      39 <buffer{39}>      55 <buffer{55}>",
                          "  8 <buffer{8} >      24 <buffer{24}>      40 <buffer{40}>      56 <buffer{56}>",
                          "  9 <buffer{9} >      25 <buffer{25}>      41 <buffer{41}>      57 <buffer{57}>",
                          " 10 <buffer{10}>      26 <buffer{26}>      42 <buffer{42}>      58 <buffer{58}>",
                          " 11 <buffer{11}>      27 <buffer{27}>      43 <buffer{43}>      59 <buffer{59}>",
                          " 12 <buffer{12}>      28 <buffer{28}>      44 <buffer{44}>      60 <buffer{60}>",
                          " 13 <buffer{13}>      29 <buffer{29}>      45 <buffer{45}>      61 <buffer{61}>",
                          " 14 <buffer{14}>      30 <buffer{30}>      46 <buffer{46}>      62 <buffer{62}>",
                          " 15 <buffer{15}>      31 <buffer{31}>      47 <buffer{47}>      63 <buffer{63}>",
                          "",
                          "     Data(c/s)            Data(c/s)            Data(c/s)            Data(c/s)",
                          "  0 <data{0}   >      16 <data{16}  >      32 <data{32}  >      48 <data{48}  >",
                          "  1 <data{1}   >      17 <data{17}  >      33 <data{33}  >      49 <data{49}  >",
                          "  2 <data{2}   >      18 <data{18}  >      34 <data{34}  >      50 <data{50}  >",
                          "  3 <data{3}   >      19 <data{19}  >      35 <data{35}  >      51 <data{51}  >",
                          "  4 <data{4}   >      20 <data{20}  >      36 <data{36}  >      52 <data{52}  >",
                          "  5 <data{5}   >      21 <data{21}  >      37 <data{37}  >      53 <data{53}  >",
                          "  6 <data{6}   >      22 <data{22}  >      38 <data{38}  >      54 <data{54}  >",
                          "  7 <data{7}   >      23 <data{23}  >      39 <data{39}  >      55 <data{55}  >",
                          "  8 <data{8}   >      24 <data{24}  >      40 <data{40}  >      56 <data{56}  >",
                          "  9 <data{9}   >      25 <data{25}  >      41 <data{41}  >      57 <data{57}  >",
                          " 10 <data{10}  >      26 <data{26}  >      42 <data{42}  >      58 <data{58}  >",
                          " 11 <data{11}  >      27 <data{27}  >      43 <data{43}  >      59 <data{59}  >",
                          " 12 <data{12}  >      28 <data{28}  >      44 <data{44}  >      60 <data{60}  >",
                          " 13 <data{13}  >      29 <data{29}  >      45 <data{45}  >      61 <data{61}  >",
                          " 14 <data{14}  >      30 <data{30}  >      46 <data{46}  >      62 <data{62}  >",
                          " 15 <data{15}  >      31 <data{31}  >      47 <data{47}  >      63 <data{63}  >"};

      strcpy(line, template[0]);
         memset(line + 26, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(lp.Second1996), lp.microsecond);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", lp.ClockCycle);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[0], lp.QualityEventBufferRate[0]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[16], lp.QualityEventBufferRate[16]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[32], lp.QualityEventBufferRate[32]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[48], lp.QualityEventBufferRate[48]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[1], lp.QualityEventBufferRate[1]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[17], lp.QualityEventBufferRate[17]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[33], lp.QualityEventBufferRate[33]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[49], lp.QualityEventBufferRate[49]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[2], lp.QualityEventBufferRate[2]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[18], lp.QualityEventBufferRate[18]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[34], lp.QualityEventBufferRate[34]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[50], lp.QualityEventBufferRate[50]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[3], lp.QualityEventBufferRate[3]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[19], lp.QualityEventBufferRate[19]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[35], lp.QualityEventBufferRate[35]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[51], lp.QualityEventBufferRate[51]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[4], lp.QualityEventBufferRate[4]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[20], lp.QualityEventBufferRate[20]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[36], lp.QualityEventBufferRate[36]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[52], lp.QualityEventBufferRate[52]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[5], lp.QualityEventBufferRate[5]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[21], lp.QualityEventBufferRate[21]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[37], lp.QualityEventBufferRate[37]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[53], lp.QualityEventBufferRate[53]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[6], lp.QualityEventBufferRate[6]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[22], lp.QualityEventBufferRate[22]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[38], lp.QualityEventBufferRate[38]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[54], lp.QualityEventBufferRate[54]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[7], lp.QualityEventBufferRate[7]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[23], lp.QualityEventBufferRate[23]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[39], lp.QualityEventBufferRate[39]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[55], lp.QualityEventBufferRate[55]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[8], lp.QualityEventBufferRate[8]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[24], lp.QualityEventBufferRate[24]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[40], lp.QualityEventBufferRate[40]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[56], lp.QualityEventBufferRate[56]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[9], lp.QualityEventBufferRate[9]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[25], lp.QualityEventBufferRate[25]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[41], lp.QualityEventBufferRate[41]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[57], lp.QualityEventBufferRate[57]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[10], lp.QualityEventBufferRate[10]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[26], lp.QualityEventBufferRate[26]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[42], lp.QualityEventBufferRate[42]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[58], lp.QualityEventBufferRate[58]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[11], lp.QualityEventBufferRate[11]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[27], lp.QualityEventBufferRate[27]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[43], lp.QualityEventBufferRate[43]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[59], lp.QualityEventBufferRate[59]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[12], lp.QualityEventBufferRate[12]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[28], lp.QualityEventBufferRate[28]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[44], lp.QualityEventBufferRate[44]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[60], lp.QualityEventBufferRate[60]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[13], lp.QualityEventBufferRate[13]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[29], lp.QualityEventBufferRate[29]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[45], lp.QualityEventBufferRate[45]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[61], lp.QualityEventBufferRate[61]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[14], lp.QualityEventBufferRate[14]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[30], lp.QualityEventBufferRate[30]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[46], lp.QualityEventBufferRate[46]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[62], lp.QualityEventBufferRate[62]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[15], lp.QualityEventBufferRate[15]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[31], lp.QualityEventBufferRate[31]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[47], lp.QualityEventBufferRate[47]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.EventBufferRate[63], lp.QualityEventBufferRate[63]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         printf("%s\n", line);
      strcpy(line, template[20]);
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[0], lp.QualityDataBufferRate[0]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[16], lp.QualityDataBufferRate[16]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[32], lp.QualityDataBufferRate[32]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[48], lp.QualityDataBufferRate[48]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[1], lp.QualityDataBufferRate[1]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[17], lp.QualityDataBufferRate[17]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[33], lp.QualityDataBufferRate[33]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[49], lp.QualityDataBufferRate[49]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[2], lp.QualityDataBufferRate[2]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[18], lp.QualityDataBufferRate[18]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[34], lp.QualityDataBufferRate[34]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[50], lp.QualityDataBufferRate[50]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[3], lp.QualityDataBufferRate[3]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[19], lp.QualityDataBufferRate[19]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[35], lp.QualityDataBufferRate[35]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[51], lp.QualityDataBufferRate[51]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[4], lp.QualityDataBufferRate[4]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[20], lp.QualityDataBufferRate[20]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[36], lp.QualityDataBufferRate[36]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[52], lp.QualityDataBufferRate[52]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[5], lp.QualityDataBufferRate[5]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[21], lp.QualityDataBufferRate[21]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[37], lp.QualityDataBufferRate[37]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[53], lp.QualityDataBufferRate[53]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[6], lp.QualityDataBufferRate[6]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[22], lp.QualityDataBufferRate[22]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[38], lp.QualityDataBufferRate[38]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[54], lp.QualityDataBufferRate[54]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[7], lp.QualityDataBufferRate[7]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[23], lp.QualityDataBufferRate[23]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[39], lp.QualityDataBufferRate[39]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[55], lp.QualityDataBufferRate[55]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[8], lp.QualityDataBufferRate[8]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[24], lp.QualityDataBufferRate[24]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[40], lp.QualityDataBufferRate[40]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[56], lp.QualityDataBufferRate[56]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[9], lp.QualityDataBufferRate[9]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[25], lp.QualityDataBufferRate[25]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[41], lp.QualityDataBufferRate[41]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[57], lp.QualityDataBufferRate[57]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[31]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[10], lp.QualityDataBufferRate[10]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[26], lp.QualityDataBufferRate[26]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[42], lp.QualityDataBufferRate[42]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[58], lp.QualityDataBufferRate[58]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[32]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[11], lp.QualityDataBufferRate[11]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[27], lp.QualityDataBufferRate[27]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[43], lp.QualityDataBufferRate[43]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[59], lp.QualityDataBufferRate[59]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[33]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[12], lp.QualityDataBufferRate[12]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[28], lp.QualityDataBufferRate[28]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[44], lp.QualityDataBufferRate[44]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[60], lp.QualityDataBufferRate[60]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[34]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[13], lp.QualityDataBufferRate[13]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[29], lp.QualityDataBufferRate[29]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[45], lp.QualityDataBufferRate[45]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[61], lp.QualityDataBufferRate[61]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[35]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[14], lp.QualityDataBufferRate[14]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[30], lp.QualityDataBufferRate[30]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[46], lp.QualityDataBufferRate[46]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[62], lp.QualityDataBufferRate[62]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[36]);
         memset(line + 4, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[15], lp.QualityDataBufferRate[15]);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[31], lp.QualityDataBufferRate[31]);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[47], lp.QualityDataBufferRate[47]);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 12);
         sprintf(segmentValue, " %7.3f %2.2x ", lp.DataBufferRate[63], lp.QualityDataBufferRate[63]);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
