#ifndef DUMPL1_1CRISLOWPRIORITYRATESINGLE_C
   #define DUMPL1_1CRISLOWPRIORITYRATESINGLE_C

   /* $Id: dumpL1_1CrisLowPriorityRateSingle.c,v 1.1 1998/07/27 11:53:20 rgr Exp $ */

   /* $RCSfile: dumpL1_1CrisLowPriorityRateSingle.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:20 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1_1CrisLowPriorityRate.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1CrisLowPriorityRateSingle(struct L1_1CrisLowPriorityRate lp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Low Priority Rates - <start time               >   <S/C Clock: xxx.xxx.xx>",
                          "",
                          "<livetim: xxx.xxx xx>   <ntagint: xxx.xx xx>   <nmacsys: xxx.xx xx>",
                          "<helivet: xxx.xxx xx>   <nvldint: xxx.xx xx>     <stmco: xxx.xx xx>",
                          "<hylivet: xxx.xxx xx>   <nevproc: xxx.xx xx>    <stmoff: xxx.xx xx>",
                          "<trg0rat: xxxx.xx xx>   <nrtproc: xxx.xx xx>    <hazard: xxx.xx xx>",
                          "<trg1rat: xxxx.xx xx>   <nsfterr: xx.xxx xx>        <gh: xxx.xx xx>",
                          "  <trg01: xxxx.xx xx>    <nbadid: xxx.xx xx>       <mor: xxx.xx xx>",
                          "<nhdwrej: xxxxx.x xx>   <ncebful: xx.xxx xx>       <hor: xxx.xx xx>",
                          "                        <nrebful: xx.xxx xx>",
                          "",
                          "  <e1a: xxx.xx xx>   <g2ab: xxx.xx xx>      <e1c: xxx.xx xx>   <g2cd: xxx.xx xx>",
                          "  <e1b: xxx.xx xx>   <g3ab: xxx.xx xx>      <e1d: xxx.xx xx>   <g3cd: xxx.xx xx>",
                          " <e2ab: xxx.xx xx>   <g4ab: xxx.xx xx>     <e2cd: xxx.xx xx>   <g4cd: xxx.xx xx>",
                          " <e3ab: xxx.xx xx>   <g5ab: xxx.xx xx>     <e3cd: xxx.xx xx>   <g5cd: xxx.xx xx>",
                          " <e4ab: xxx.xx xx>   <g6ab: xxx.xx xx>     <e4cd: xxx.xx xx>   <g6cd: xxx.xx xx>",
                          " <e5ab: xxx.xx xx>   <g7ab: xxx.xx xx>     <e5cd: xxx.xx xx>   <g7cd: xxx.xx xx>",
                          " <e6ab: xxx.xx xx> <adc2ab: xxx.xx xx>     <e6cd: xxx.xx xx> <adc2cd: xxx.xx xx>",
                          " <e7ab: xxx.xx xx> <mnrgab: xxx.xx xx>     <e7cd: xxx.xx xx> <mnrgcd: xxx.xx xx>",
                          " <e8ab: xxx.xx xx>   <z1ab: xx.xxx xx>     <e8cd: xxx.xx xx>   <z1cd: xx.xxx xx>",
                          " <e9ab: xxx.xx xx>   <z2ab: xx.xxx xx>     <e9cd: xxx.xx xx>   <z2cd: xx.xxx xx>",
                          "                 <z_gt_2ab: xx.xxx xx>                     <z_gt_2cd: xx.xxx xx>"};

      strcpy(line, template[0]);
         memset(line + 26, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(lp.Second1996), lp.microsecond);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", lp.ClockCycle);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " livetim:%8.3f %2.2x ", lp.livetim, lp.QualityLivetim);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " ntagint:%7.2f %2.2x ", lp.ntagint, lp.QualityNtagint);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 47, (int) ' ', 20);
         sprintf(segmentValue, " nmacsys:%7.2f %2.2x ", lp.nmacsys, lp.QualityNmacsys);
         memcpy(line + 47, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " helivet:%8.3f %2.2x ", lp.helivet, lp.QualityHelivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nvldint:%7.2f %2.2x ", lp.nvldint, lp.QualityNvldint);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 49, (int) ' ', 18);
         sprintf(segmentValue, " stmco:%7.2f %2.2x ", lp.stmco, lp.QualityStmco);
         memcpy(line + 49, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " hylivet:%8.3f %2.2x ", lp.hylivet, lp.QualityHylivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nevproc:%7.2f %2.2x ", lp.nevproc, lp.QualityNevproc);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 19);
         sprintf(segmentValue, " stmoff:%7.2f %2.2x ", lp.stmoff, lp.QualityStmoff);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " trg0rat:%8.2f %2.2x ", lp.trg0rat, lp.QualityTrg0rat);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nrtproc:%7.2f %2.2x ", lp.nrtproc, lp.QualityNrtproc);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 19);
         sprintf(segmentValue, " hazard:%7.2f %2.2x ", lp.hazard, lp.QualityHazard);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " trg1rat:%8.2f %2.2x ", lp.trg1rat, lp.QualityTrg1rat);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nsfterr:%7.3f %2.2x ", lp.nsfterr, lp.QualityNsfterr);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 15);
         sprintf(segmentValue, " gh:%7.2f %2.2x ", lp.gh, lp.QualityGh);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 2, (int) ' ', 19);
         sprintf(segmentValue, " trg01:%8.2f %2.2x ", lp.trg01, lp.QualityTrg01);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 19);
         sprintf(segmentValue, " nbadid:%7.2f %2.2x ", lp.nbadid, lp.QualityNbadid);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 16);
         sprintf(segmentValue, " mor:%7.2f %2.2x ", lp.mor, lp.QualityMor);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " nhdwrej:%8.1f %2.2x ", lp.nhdwrej, lp.QualityNhdwrej);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " ncebful:%7.3f %2.2x ", lp.ncebful, lp.QualityNcebful);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 16);
         sprintf(segmentValue, " hor:%7.2f %2.2x ", lp.hor, lp.QualityHor);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " nrebful:%7.3f %2.2x ", lp.nrebful, lp.QualityNrebful);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 2, (int) ' ', 16);
         sprintf(segmentValue, " e1a:%7.2f %2.2x ", lp.e1a, lp.QualityE1a);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g2ab:%7.2f %2.2x ", lp.g2ab, lp.QualityG2ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 16);
         sprintf(segmentValue, " e1c:%7.2f %2.2x ", lp.e1c, lp.QualityE1c);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g2cd:%7.2f %2.2x ", lp.g2cd, lp.QualityG2cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 2, (int) ' ', 16);
         sprintf(segmentValue, " e1b:%7.2f %2.2x ", lp.e1b, lp.QualityE1b);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g3ab:%7.2f %2.2x ", lp.g3ab, lp.QualityG3ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 16);
         sprintf(segmentValue, " e1d:%7.2f %2.2x ", lp.e1d, lp.QualityE1d);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g3cd:%7.2f %2.2x ", lp.g3cd, lp.QualityG3cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e2ab:%7.2f %2.2x ", lp.e2ab, lp.QualityE2ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g4ab:%7.2f %2.2x ", lp.g4ab, lp.QualityG4ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e2cd:%7.2f %2.2x ", lp.e2cd, lp.QualityE2cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g4cd:%7.2f %2.2x ", lp.g4cd, lp.QualityG4cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e3ab:%7.2f %2.2x ", lp.e3ab, lp.QualityE3ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g5ab:%7.2f %2.2x ", lp.g5ab, lp.QualityG5ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e3cd:%7.2f %2.2x ", lp.e3cd, lp.QualityE3cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g5cd:%7.2f %2.2x ", lp.g5cd, lp.QualityG5cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e4ab:%7.2f %2.2x ", lp.e4ab, lp.QualityE4ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g6ab:%7.2f %2.2x ", lp.g6ab, lp.QualityG6ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e4cd:%7.2f %2.2x ", lp.e4cd, lp.QualityE4cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g6cd:%7.2f %2.2x ", lp.g6cd, lp.QualityG6cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e5ab:%7.2f %2.2x ", lp.e5ab, lp.QualityE5ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " g7ab:%7.2f %2.2x ", lp.g7ab, lp.QualityG7ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e5cd:%7.2f %2.2x ", lp.e5cd, lp.QualityE5cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " g7cd:%7.2f %2.2x ", lp.g7cd, lp.QualityG7cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e6ab:%7.2f %2.2x ", lp.e6ab, lp.QualityE6ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 19);
         sprintf(segmentValue, " adc2ab:%7.2f %2.2x ", lp.adc2ab, lp.QualityAdc2ab);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e6cd:%7.2f %2.2x ", lp.e6cd, lp.QualityE6cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 19);
         sprintf(segmentValue, " adc2cd:%7.2f %2.2x ", lp.adc2cd, lp.QualityAdc2cd);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e7ab:%7.2f %2.2x ", lp.e7ab, lp.QualityE7ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 19);
         sprintf(segmentValue, " mnrgab:%7.2f %2.2x ", lp.mnrgab, lp.QualityMnrgab);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e7cd:%7.2f %2.2x ", lp.e7cd, lp.QualityE7cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 19);
         sprintf(segmentValue, " mnrgcd:%7.2f %2.2x ", lp.mnrgcd, lp.QualityMnrgcd);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e8ab:%7.2f %2.2x ", lp.e8ab, lp.QualityE8ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " z1ab:%7.3f %2.2x ", lp.z1ab, lp.QualityZ1ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e8cd:%7.2f %2.2x ", lp.e8cd, lp.QualityE8cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " z1cd:%7.3f %2.2x ", lp.z1cd, lp.QualityZ1cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 1, (int) ' ', 17);
         sprintf(segmentValue, " e9ab:%7.2f %2.2x ", lp.e9ab, lp.QualityE9ab);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 17);
         sprintf(segmentValue, " z2ab:%7.3f %2.2x ", lp.z2ab, lp.QualityZ2ab);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 17);
         sprintf(segmentValue, " e9cd:%7.2f %2.2x ", lp.e9cd, lp.QualityE9cd);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, " z2cd:%7.3f %2.2x ", lp.z2cd, lp.QualityZ2cd);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 17, (int) ' ', 21);
         sprintf(segmentValue, " z_gt_2ab:%7.3f %2.2x ", lp.z_gt_2ab, lp.QualityZ_gt_2ab);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 21);
         sprintf(segmentValue, " z_gt_2cd:%7.3f %2.2x ", lp.z_gt_2cd, lp.QualityZ_gt_2cd);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
