#ifndef DUMPL1_1CRISSUMMARY_C
   #define DUMPL1_1CRISSUMMARY_C

   /* $Id: dumpL1_1CrisSummary.c,v 1.1 1998/07/27 11:53:24 rgr Exp $ */

   /* $RCSfile: dumpL1_1CrisSummary.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 11:53:24 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/L1_1CrisSummary.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1CrisSummary(struct L1_1CrisSummary sum)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Summary <start time               >   <S/C Clock: xxxxxxxxxx>   <MJF: x xx>",
                          "Hskp:<hskp0  >                                                   <Quality: xx>",
                          "",
                          "  <MainBusVoltage: xx.xxx>V   <InternalTemperature1: xxx.xx>DegC",
                          "     <CrisCurrent: xx.xxx>A   <InternalTemperature2: xxx.xx>DegC",
                          "                              <InterfaceTemperature: xxx.xx>DegC"};

      strcpy(line, template[0]);
         memset(line + 13, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(sum.Second1996), sum.microsecond);
         memcpy(line + 13, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", sum.ClockMinorFrame);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 69, (int) ' ', 11);
         sprintf(segmentValue, " MJF: %1d %2.2d ", sum.MajorFrameCount, sum.MinorFrameCount);
         memcpy(line + 69, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 5, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x  ", sum.CrisHskp[0], sum.CrisHskp[1], sum.CrisHskp[2]);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 65, (int) ' ', 13);
         sprintf(segmentValue, " Quality: %2.2x ", sum.quality);
         memcpy(line + 65, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 2, (int) ' ', 24);
         sprintf(segmentValue, " MainBusVoltage:%7.3f ", sum.MainBusVoltage);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InternalTemperature1:%7.3f ", sum.CrisInternalTemperature1);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 5, (int) ' ', 21);
         sprintf(segmentValue, " CrisCurrent:%7.3f ", sum.CrisCurrent);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InternalTemperature2:%7.3f ", sum.CrisInternalTemperature2);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InterfaceTemperature:%7.3f ", sum.CrisInterfaceTemperature);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
