#ifndef DUMPCE_CRISEVT_C
   #define DUMPCE_CRISEVT_C

   /* $Id: dumpce_crisEvt.c,v 1.2 1998/07/31 00:57:10 rgr Exp $ */

   /* $RCSfile: dumpce_crisEvt.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/31 00:57:10 $ */
   /* $Revision: 1.2 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "cris/ce_crisEvt.h"
   #include "ace/expandUint16.h"
   #include "utilities/stringDate1996.h"

   void dumpce_crisEvt(struct ce_crisEvt evt)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"CRIS Normal Event - <start time               >        <Event No: xxxxxxxxxx xx>",
                          "SOFT:",
                          "    x   y    int         x   y    int          x   y    int         x   y    int",
                          "<hodoscope{0}  >     <hodoscope{8}  >      <hodoscope{16} >     <hodoscope{24} >",
                          "<hodoscope{1}  >     <hodoscope{9}  >      <hodoscope{17} >     <hodoscope{25} >",
                          "<hodoscope{2}  >     <hodoscope{10} >      <hodoscope{18} >     <hodoscope{26} >",
                          "<hodoscope{3}  >     <hodoscope{11} >      <hodoscope{19} >     <hodoscope{27} >",
                          "<hodoscope{4}  >     <hodoscope{12} >      <hodoscope{20} >     <hodoscope{28} >",
                          "<hodoscope{5}  >     <hodoscope{13} >      <hodoscope{21} >     <hodoscope{29} >",
                          "<hodoscope{6}  >     <hodoscope{14} >      <hodoscope{22} >     <hodoscope{30} >",
                          "<hodoscope{7}  >     <hodoscope{15} >      <hodoscope{23} >",
                          "",
                          "  <nblobs: xx>      Primary Telescope:            Secondary Telescope:  ",
                          "    <npix: xxxxxx>    <e1: aaaa>  <g2: xxxx>        <e1: cccc>  <g2: yyyy>",
                          "  <camera: x>         <e1: bbbb>  <g3: xxxx>        <e1: dddd>  <g3: yyyy>",
                          "  <buffer: xx>        <e2: xxxx>  <g4: xxxx>        <e2: yyyy>  <g4: yyyy>",
                          "     <age: xx>        <e3: xxxx>  <g5: xxxx>        <e3: yyyy>  <g5: yyyy>",
                          "<activity: x>         <e4: xxxx>  <g6: xxxx>        <e4: yyyy>  <g6: yyyy>",
                          "   <prime: x>         <e5: xxxx>  <g7: xxxx>        <e5: yyyy>  <g7: yyyy>",
                          "    <stim: x>         <e6: xxxx>                    <e6: yyyy> ",
                          "  <hazard: x>         <e7: xxxx>  <range: x>        <e7: yyyy>  <range: y>",
                          " <2nd Tel: x>         <e8: xxxx>  <no. guards: x>   <e8: yyyy>  <no. guards: y>",
                          "<guard or: x>         <e9: xxxx>  <tags: XXXX>      <e9: yyyy>  <tags: YYYY>",
                          "  <guards: x>",
                          "<cent err: x>",
                          "",
                          "Stimulated Data:",
                          "  <center high gain: xx>    <center DAC level: xxx>    <center pulsers: xx>",
                          "   <guard high gain: xx>     <guard DAC level: xxx>     <guard pulsers: xx>",
                          "                              <SOFT LED pulse: xxx>"};

      strcpy(line, template[0]);
         memset(line + 20, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(evt.secs1996), evt.usec);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 55, (int) ' ', 25);
         sprintf(segmentValue, " Event No: %10lu %2u ", evt.evtno, evt.evt_offset);
         memcpy(line + 55, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[0].x, evt.hodo[0].y, evt.hodo[0].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[8].x, evt.hodo[8].y, evt.hodo[8].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[16].x, evt.hodo[16].y, evt.hodo[16].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[24].x, evt.hodo[24].y, evt.hodo[24].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[1].x, evt.hodo[1].y, evt.hodo[1].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[9].x, evt.hodo[9].y, evt.hodo[9].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[17].x, evt.hodo[17].y, evt.hodo[17].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[25].x, evt.hodo[25].y, evt.hodo[25].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[2].x, evt.hodo[2].y, evt.hodo[2].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[10].x, evt.hodo[10].y, evt.hodo[10].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[18].x, evt.hodo[18].y, evt.hodo[18].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[26].x, evt.hodo[26].y, evt.hodo[26].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[3].x, evt.hodo[3].y, evt.hodo[3].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[11].x, evt.hodo[11].y, evt.hodo[11].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[19].x, evt.hodo[19].y, evt.hodo[19].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[27].x, evt.hodo[27].y, evt.hodo[27].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[4].x, evt.hodo[4].y, evt.hodo[4].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[12].x, evt.hodo[12].y, evt.hodo[12].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[20].x, evt.hodo[20].y, evt.hodo[20].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[28].x, evt.hodo[28].y, evt.hodo[28].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[5].x, evt.hodo[5].y, evt.hodo[5].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[13].x, evt.hodo[13].y, evt.hodo[13].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[21].x, evt.hodo[21].y, evt.hodo[21].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[29].x, evt.hodo[29].y, evt.hodo[29].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[6].x, evt.hodo[6].y, evt.hodo[6].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[14].x, evt.hodo[14].y, evt.hodo[14].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[22].x, evt.hodo[22].y, evt.hodo[22].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[30].x, evt.hodo[30].y, evt.hodo[30].I);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 0, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[7].x, evt.hodo[7].y, evt.hodo[7].I);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[15].x, evt.hodo[15].y, evt.hodo[15].I);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 16);
         sprintf(segmentValue, " %4d %3d %6lu", evt.hodo[23].x, evt.hodo[23].y, evt.hodo[23].I);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 2, (int) ' ', 12);
         sprintf(segmentValue, " nblobs: %2u ", evt.nblobs);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 4, (int) ' ', 14);
         sprintf(segmentValue, " npix: %6ld ", evt.npix);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e1: %4d ", evt.prim_ctr_ph[0]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g2: %4d ", evt.prim_guard_ph[0]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e1: %4d ", evt.sec_ctr_ph[0]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g2: %4d ", evt.sec_guard_ph[0]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 2, (int) ' ', 11);
         sprintf(segmentValue, " camera: %1u ", evt.cam);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e1: %4d ", evt.prim_ctr_ph[1]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g3: %4d ", evt.prim_guard_ph[1]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e1: %4d ", evt.sec_ctr_ph[1]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g3: %4d ", evt.sec_guard_ph[1]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 2, (int) ' ', 12);
         sprintf(segmentValue, " buffer: %2u ", evt.buffer_id);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e2: %4d ", evt.prim_ctr_ph[2]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g4: %4d ", evt.prim_guard_ph[2]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e2: %4d ", evt.sec_ctr_ph[2]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g4: %4d ", evt.sec_guard_ph[2]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 5, (int) ' ', 9);
         sprintf(segmentValue, " age: %2u ", evt.age);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e3: %4d ", evt.prim_ctr_ph[3]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g5: %4d ", evt.prim_guard_ph[3]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e3: %4d ", evt.sec_ctr_ph[3]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g5: %4d ", evt.sec_guard_ph[3]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 0, (int) ' ', 13);
         sprintf(segmentValue, " activity: %1u ", evt.sec_tel_act);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e4: %4d ", evt.prim_ctr_ph[4]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g6: %4d ", evt.prim_guard_ph[4]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e4: %4d ", evt.sec_ctr_ph[4]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g6: %4d ", evt.sec_guard_ph[4]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 3, (int) ' ', 10);
         sprintf(segmentValue, " prime: %1u ", evt.prim_tel_pair);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e5: %4d ", evt.prim_ctr_ph[5]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " g7: %4d ", evt.prim_guard_ph[5]);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e5: %4d ", evt.sec_ctr_ph[5]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " g7: %4d ", evt.sec_guard_ph[5]);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 4, (int) ' ', 9);
         sprintf(segmentValue, " stim: %1u ", evt.stim);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e6: %4d ", evt.prim_ctr_ph[6]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e6: %4d ", evt.sec_ctr_ph[6]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 2, (int) ' ', 11);
         sprintf(segmentValue, " hazard: %1u ", evt.hazard);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e7: %4d ", evt.prim_ctr_ph[7]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 10);
         sprintf(segmentValue, " range: %1u ", evt.R1);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e7: %4d ", evt.sec_ctr_ph[7]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 10);
         sprintf(segmentValue, " range: %1u ", evt.R2);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 1, (int) ' ', 12);
         sprintf(segmentValue, " 2nd Tel: %1u ", evt.got_2nd_tel);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e8: %4d ", evt.prim_ctr_ph[8]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 15);
         sprintf(segmentValue, " no. guards: %1u ", evt.G1);
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e8: %4d ", evt.sec_ctr_ph[8]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 15);
         sprintf(segmentValue, " no. guards: %1u ", evt.G2);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 0, (int) ' ', 13);
         sprintf(segmentValue, " guard or: %1u ", evt.guard_hi_or);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 22, (int) ' ', 10);
         sprintf(segmentValue, " e9: %4d ", evt.prim_ctr_ph[9]);
         memcpy(line + 22, segmentValue, strlen(segmentValue));
         memset(line + 34, (int) ' ', 12);
         sprintf(segmentValue, " tags: %4.4lx ", expandUint16(evt.prim_tag));
         memcpy(line + 34, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 10);
         sprintf(segmentValue, " e9: %4d ", evt.sec_ctr_ph[9]);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 12);
         sprintf(segmentValue, " tags: %4.4lx ", expandUint16(evt.sec_tag));
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 2, (int) ' ', 11);
         sprintf(segmentValue, " guards: %1u ", evt.got_guard);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 0, (int) ' ', 13);
         sprintf(segmentValue, " cent err: %1u ", evt.centroid_err);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         printf("%s\n", line);
      strcpy(line, template[26]);
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 2, (int) ' ', 22);
         sprintf(segmentValue, " center high gain: %2x ", evt.stimdata.ctr_hi_gain);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 28, (int) ' ', 23);
         sprintf(segmentValue, " center DAC level: %3u ", evt.stimdata.ctr_dac_level);
         memcpy(line + 28, segmentValue, strlen(segmentValue));
         memset(line + 55, (int) ' ', 20);
         sprintf(segmentValue, " center pulsers: %2x ", evt.stimdata.ctr_pulsers);
         memcpy(line + 55, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " guard high gain: %2x ", evt.stimdata.guard_hi_gain);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 22);
         sprintf(segmentValue, " guard DAC level: %3u ", evt.stimdata.guard_dac_level);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 19);
         sprintf(segmentValue, " guard pulsers: %2x ", evt.stimdata.guard_pulsers);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 30, (int) ' ', 21);
         sprintf(segmentValue, " SOFT LED pulse: %3u ", evt.stimdata.soft_led_pulse);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
