#ifndef DUMPL1SISHSKP_C
   #define DUMPL1SISHSKP_C

   /* $Id: dumpL1SisHskp.c,v 1.2 1998/07/27 12:10:24 rgr Exp $ */

   /* $RCSfile: dumpL1SisHskp.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:10:24 $ */
   /* $Revision: 1.2 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "sis/L1SisHskp.h"
   #include "utilities/stringDate1996.h"

   void dumpL1SisHskp(struct L1SisHskp hskp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Housekeeping - <start time               >   <S/C Clock: xxxxxxxxxx>",
                          "",
                          "Temperature(ADC):          Voltage(ADC):      PostDC(ADC):",
                          "  <Motherboard: xxxx xx>     <+4V: xxxx xx>     <T1A: xxxx xx>  <T1B: xxxx xx>",
                          " <Analog Board: xxxx xx>     <+5V: xxxx xx>     <T2A: xxxx xx>  <T2B: xxxx xx>",
                          "<PostReg Board: xxxx xx>     <+7V: xxxx xx>     <T3A: xxxx xx>  <T3B: xxxx xx>",
                          "  <Logic Board: xxxx xx>     <-7V: xxxx xx>     <T4A: xxxx xx>  <T4B: xxxx xx>",
                          "   <LVPS Board: xxxx xx>    <+13V: xxxx xx>     <T5A: xxxx xx>  <T5B: xxxx xx>",
                          "   <HVPS Board: xxxx xx>    <-13V: xxxx xx>     <T6A: xxxx xx>  <T6B: xxxx xx>",
                          "    <M1A Board: xxxx xx>    <+19V: xxxx xx>     <T7A: xxxx xx>  <T7B: xxxx xx>",
                          "    <M2B Board: xxxx xx>                        <T8A: xxxx xx>  <T8B: xxxx xx>",
                          "   <T12A Board: xxxx xx>",
                          "   <T34A Board: xxxx xx>   Current(ADC):      Status:",
                          "   <T56A Board: xxxx xx>     <A: xxxx xx>       <Telemetry Side: x xx>",
                          "   <T78A Board: xxxx xx>     <B: xxxx xx>       <Refresh Enable: x xx>",
                          "   <T12B Board: xxxx xx>                           <Heater Auto: x xx>",
                          "   <T34B Board: xxxx xx>                          <Heater Level: xx xx>",
                          "   <T56B Board: xxxx xx>                          <Cycle Number: xxxxxxxx xx>",
                          "   <T78B Board: xxxx xx>                   <Command Table Index: xxxx xx>"};

      strcpy(line, template[0]);
         memset(line + 19, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(hskp.Second1996), hskp.microsecond);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 49, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", hskp.ClockCycle);
         memcpy(line + 49, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 2, (int) ' ', 22);
         sprintf(segmentValue, " Motherboard: %4u %2.2x ", hskp.TemperatureMotherBoard, hskp.QualityTemperatureMotherBoard);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 14);
         sprintf(segmentValue, " +4V: %4u %2.2x ", hskp.MonitorP4V, hskp.QualityMonitorP4V);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T1A: %4u %2.2x ", hskp.PostDcT1a, hskp.QualityPostDcT1a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T1B: %4u %2.2x ", hskp.PostDcT1b, hskp.QualityPostDcT1b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 1, (int) ' ', 23);
         sprintf(segmentValue, " Analog Board: %4u %2.2x ", hskp.TemperatureAnalogBoard, hskp.QualityTemperatureAnalogBoard);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 14);
         sprintf(segmentValue, " +5V: %4u %2.2x ", hskp.MonitorP5V, hskp.QualityMonitorP5V);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T2A: %4u %2.2x ", hskp.PostDcT2a, hskp.QualityPostDcT2a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T2B: %4u %2.2x ", hskp.PostDcT2b, hskp.QualityPostDcT2b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 24);
         sprintf(segmentValue, " PostReg Board: %4u %2.2x ", hskp.TemperaturePostRegBoard, hskp.QualityTemperaturePostRegBoard);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 14);
         sprintf(segmentValue, " +7V: %4u %2.2x ", hskp.MonitorP7V, hskp.QualityMonitorP7V);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T3A: %4u %2.2x ", hskp.PostDcT3a, hskp.QualityPostDcT3a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T3B: %4u %2.2x ", hskp.PostDcT3b, hskp.QualityPostDcT3b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 2, (int) ' ', 22);
         sprintf(segmentValue, " Logic Board: %4u %2.2x ", hskp.TemperatureLogicBoard, hskp.QualityTemperatureLogicBoard);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 14);
         sprintf(segmentValue, " -7V: %4u %2.2x ", hskp.MonitorM7V, hskp.QualityMonitorM7V);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T4A: %4u %2.2x ", hskp.PostDcT4a, hskp.QualityPostDcT4a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T4B: %4u %2.2x ", hskp.PostDcT4b, hskp.QualityPostDcT4b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " LVPS Board: %4u %2.2x ", hskp.TemperatureLvpsBoard, hskp.QualityTemperatureLvpsBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 28, (int) ' ', 15);
         sprintf(segmentValue, " +13V: %4u %2.2x ", hskp.MonitorP13V, hskp.QualityMonitorP13V);
         memcpy(line + 28, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T5A: %4u %2.2x ", hskp.PostDcT5a, hskp.QualityPostDcT5a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T5B: %4u %2.2x", hskp.PostDcT5b, hskp.QualityPostDcT5b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " HVPS Board: %4u %2.2x ", hskp.TemperatureHvpsBoard, hskp.QualityTemperatureHvpsBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 28, (int) ' ', 15);
         sprintf(segmentValue, " -13V: %4u %2.2x ", hskp.MonitorM13V, hskp.QualityMonitorM13V);
         memcpy(line + 28, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T6A: %4u %2.2x ", hskp.PostDcT6a, hskp.QualityPostDcT6a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T6B: %4u %2.2x ", hskp.PostDcT6b, hskp.QualityPostDcT6b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 4, (int) ' ', 20);
         sprintf(segmentValue, " M1A Board: %4u %2.2x ", hskp.TemperatureM1aBoard, hskp.QualityTemperatureM1aBoard);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 28, (int) ' ', 15);
         sprintf(segmentValue, " +19V: %4u %2.2x ", hskp.MonitorP19V, hskp.QualityMonitorP19V);
         memcpy(line + 28, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T7A: %4u %2.2x ", hskp.PostDcT7a, hskp.QualityPostDcT7a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T7B: %4u %2.2x ", hskp.PostDcT7b, hskp.QualityPostDcT7b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 4, (int) ' ', 20);
         sprintf(segmentValue, " M2B Board: %4u %2.2x ", hskp.TemperatureM2bBoard, hskp.QualityTemperatureM2bBoard);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 14);
         sprintf(segmentValue, " T8A: %4u %2.2x ", hskp.PostDcT8a, hskp.QualityPostDcT8a);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         memset(line + 64, (int) ' ', 14);
         sprintf(segmentValue, " T8B: %4u %2.2x ", hskp.PostDcT8b, hskp.QualityPostDcT8b);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T12A Board: %4u %2.2x ", hskp.TemperatureT12aBoard, hskp.QualityTemperatureT12aBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T34A Board: %4u %2.2x ", hskp.TemperatureT34aBoard, hskp.QualityTemperatureT34aBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T56A Board: %4u %2.2x ", hskp.TemperatureT56aBoard, hskp.QualityTemperatureT56aBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 12);
         sprintf(segmentValue, " A: %4u %2.2x ", hskp.MonitorCurrentA, hskp.QualityMonitorCurrentA);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 22);
         sprintf(segmentValue, " Telemetry Side: %1u %2.2x ", hskp.StatusTelemetrySide, hskp.QualityStatusTelemetrySide);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T78A Board: %4u %2.2x ", hskp.TemperatureT78aBoard, hskp.QualityTemperatureT78aBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 12);
         sprintf(segmentValue, " B: %4u %2.2x ", hskp.MonitorCurrentB, hskp.QualityMonitorCurrentB);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 48, (int) ' ', 22);
         sprintf(segmentValue, " Refresh Enable: %1u %2.2x ", hskp.StatusRefreshEnable, hskp.QualityStatusRefreshEnable);
         memcpy(line + 48, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T12B Board: %4u %2.2x ", hskp.TemperatureT12bBoard, hskp.QualityTemperatureT12bBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 19);
         sprintf(segmentValue, " Heater Auto: %1u %2.2x ", hskp.StatusHeatAuto, hskp.QualityStatusHeatAuto);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T34B Board: %4u %2.2x ", hskp.TemperatureT34bBoard, hskp.QualityTemperatureT34bBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 21);
         sprintf(segmentValue, " Heater Level: %2.2u %2.2x ", hskp.StatusHeatLevel, hskp.QualityStatusHeatLevel);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T56B Board: %4u %2.2x ", hskp.TemperatureT56bBoard, hskp.QualityTemperatureT56bBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 27);
         sprintf(segmentValue, " Cycle Number: %8.8lu %2.2x ", hskp.CycleNumber, hskp.QualityCycleNumber);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " T78B Board: %4u %2.2x ", hskp.TemperatureT78bBoard, hskp.QualityTemperatureT78bBoard);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 30);
         sprintf(segmentValue, " Command Table Index: %4u %2.2x ", hskp.CommandTableIndex, hskp.QualityCommandTableIndex);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
