#ifndef DUMPL1SISLOWPRIORITYRATESINGLE_C
   #define DUMPL1SISLOWPRIORITYRATESINGLE_C

   /* $Id: dumpL1SisLowPriorityRateSingle.c,v 1.1 1998/07/27 12:15:38 rgr Exp $ */

   /* $RCSfile: dumpL1SisLowPriorityRateSingle.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:15:38 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   #include "hdfi.h"
   
   #include "sis/L1SisLowPriorityRate.h"
   #include "sis/uncompressSisValue.h"
   #include "utilities/stringDate1996.h"

   void dumpL1SisLowPriorityRateSingle(struct L1SisLowPriorityRate lp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Low Priority Rates - <start time               >   <S/C Clock: xxxxxxxxxx>",
                          "",
                          "<livetim: xxxxxxxx.x xx>   <ntagint: xxxxxxxx.x xx>    <nbadid: xxxxxxxx.x xx>",
                          "<helivet: xxxxxxxx.x xx>   <nvldint: xxxxxxxx.x xx>   <ncebful: xxxxxxxx.x xx>",
                          "<hylivet: xxxxxxxx.x xx>   <nevproc: xxxxxxxx.x xx>   <nrebful: xxxxxxxx.x xx>",
                          "                           <nrtproc: xxxxxxxx.x xx>   <nhdwrej: xxxxxxxx.x xx>",
                          "",
                          "Reject Rates(counts):",
                          "<MaybeHiza: xxxx.x xx>                  <MaybeHizb: xxxx.x xx>",
                          " <MaybeZ2a: xxxx.x xx> <m1a: xxxxx.x xx> <MaybeZ2b: xxxx.x xx> <m1b: xxxxx.x xx>",
                          " <MaybeZ1a: xxxx.x xx> <m2a: xxxxx.x xx> <MaybeZ1b: xxxx.x xx> <m2b: xxxxx.x xx>",
                          "     <hiza: xxxx.x xx> <t1a: xxxxx.x xx>     <hizb: xxxx.x xx> <t1b: xxxxx.x xx>",
                          "      <z2a: xxxx.x xx> <t2a: xxxxx.x xx>      <z2b: xxxx.x xx> <t2b: xxxxx.x xx>",
                          "    <adc2a: xxxx.x xx> <t3a: xxxxx.x xx>    <adc2b: xxxx.x xx> <t3b: xxxxx.x xx>",
                          "    <adc3a: xxxx.x xx> <t4a: xxxxx.x xx>    <adc3b: xxxx.x xx> <t4b: xxxxx.x xx>",
                          "     <mora: xxxx.x xx> <t5a: xxxxx.x xx>     <morb: xxxx.x xx> <t5b: xxxxx.x xx>",
                          "     <hora: xxxx.x xx> <t6a: xxxxx.x xx>     <horb: xxxx.x xx> <t6b: xxxxx.x xx>",
                          "     <m12a: xxxx.x xx> <t7a: xxxxx.x xx>     <m12b: xxxx.x xx> <t7b: xxxxx.x xx>",
                          "     <m1ha: xxxx.x xx> <t8a: xxxxx.x xx>     <m1hb: xxxx.x xx> <t8b: xxxxx.x xx>",
                          "     <m2ha: xxxx.x xx>                       <m2hb: xxxx.x xx>",
                          "",
                          "  <CoinRate0: xxxxxx.x xx>   <CoinRate1: xxxxxx.x xx>   <StimCoin: xxxxxx.x xx>",
                          "     <hazard: xxxxxx.x xx>                               <RejFast: xxxxxx.x xx>",
                          "",
                          "Valid Rates(counts):",
                          "<MaybeHiza: yyyy.y yy>                  <MaybeHizb: yyyy.y yy>",
                          " <MaybeZ2a: yyyy.y yy> <m1a: yyyyy.y yy> <MaybeZ2b: yyyy.y yy> <m1b: yyyyy.y yy>",
                          " <MaybeZ1a: yyyy.y yy> <m2a: yyyyy.y yy> <MaybeZ1b: yyyy.y yy> <m2b: yyyyy.y yy>",
                          "     <hiza: yyyy.y yy> <t1a: yyyyy.y yy>     <hizb: yyyy.y yy> <t1b: yyyyy.y yy>",
                          "      <z2a: yyyy.y yy> <t2a: yyyyy.y yy>      <z2b: yyyy.y yy> <t2b: yyyyy.y yy>",
                          "    <adc2a: yyyy.y yy> <t3a: yyyyy.y yy>    <adc2b: yyyy.y yy> <t3b: yyyyy.y yy>",
                          "    <adc3a: yyyy.y yy> <t4a: yyyyy.y yy>    <adc3b: yyyy.y yy> <t4b: yyyyy.y yy>",
                          "     <mora: yyyy.y yy> <t5a: yyyyy.y yy>     <morb: yyyy.y yy> <t5b: yyyyy.y yy>",
                          "     <hora: yyyy.y yy> <t6a: yyyyy.y yy>     <horb: yyyy.y yy> <t6b: yyyyy.y yy>",
                          "     <m12a: yyyy.y yy> <t7a: yyyyy.y yy>     <m12b: yyyy.y yy> <t7b: yyyyy.y yy>",
                          "     <m1ha: yyyy.y yy> <t8a: yyyyy.y yy>     <m1hb: yyyy.y yy> <t8b: yyyyy.y yy>",
                          "     <m2ha: yyyy.y yy>                       <m2hb: yyyy.y yy>",
                          "",
                          "  <CoinRate0: yyyyyy.y yy>   <CoinRate1: yyyyyy.y yy>   <StimCoin: yyyyyy.y yy>",
                          "     <hazard: yyyyyy.y yy>                               <RejFast: yyyyyy.y yy>"};

      strcpy(line, template[0]);
         memset(line + 25, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(lp.Second1996), lp.microsecond);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 55, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", lp.ClockCycle);
         memcpy(line + 55, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 0, (int) ' ', 24);
         sprintf(segmentValue, "livetim:%11.1f %2.2x ", uncompressSisValue(lp.livetim), lp.QualityLivetim);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 27, (int) ' ', 24);
         sprintf(segmentValue, "ntagint:%11.1f %2.2x ", uncompressSisValue(lp.ntagint), lp.QualityNtagint);
         memcpy(line + 27, segmentValue, strlen(segmentValue));
         memset(line + 55, (int) ' ', 23);
         sprintf(segmentValue, "nbadid:%11.1f %2.2x ", uncompressSisValue(lp.nbadid),  lp.QualityNbadid);
         memcpy(line + 55, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 24);
         sprintf(segmentValue, "helivet:%11.1f %2.2x ", uncompressSisValue(lp.helivet), lp.QualityHelivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 27, (int) ' ', 24);
         sprintf(segmentValue, "nvldint:%11.1f %2.2x ", uncompressSisValue(lp.nvldint), lp.QualityNvldint);
         memcpy(line + 27, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 24);
         sprintf(segmentValue, "ncebful:%11.1f %2.2x ", uncompressSisValue(lp.ncebful), lp.QualityNcebful);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 24);
         sprintf(segmentValue, "hylivet:%11.1f %2.2x ", uncompressSisValue(lp.hylivet), lp.QualityHylivet);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 27, (int) ' ', 24);
         sprintf(segmentValue, "nevproc:%11.1f %2.2x ", uncompressSisValue(lp.nevproc), lp.QualityNevproc);
         memcpy(line + 27, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 24);
         sprintf(segmentValue, "nrebful:%11.1f %2.2x ", uncompressSisValue(lp.nrebful), lp.QualityNrebful);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 27, (int) ' ', 24);
         sprintf(segmentValue, "nrtproc:%11.1f %2.2x ", uncompressSisValue(lp.nrtproc), lp.QualityNrtproc);
         memcpy(line + 27, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 24);
         sprintf(segmentValue, "nhdwrej:%11.1f %2.2x ", uncompressSisValue(lp.nhdwrej), lp.QualityNhdwrej);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         printf("%s\n", line);
      strcpy(line, template[7]);
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, "MaybeHiza:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeHiza), lp.QualityRejcntsMaybeHiza);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 40, (int) ' ', 22);
         sprintf(segmentValue, "MaybeHizb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeHizb), lp.QualityRejcntsMaybeHizb);
         memcpy(line + 40, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 1, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ2a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeZ2a), lp.QualityRejcntsMaybeZ2a);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "m1a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsM1a), lp.QualityRejcntsM1a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ2b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeZ2b), lp.QualityRejcntsMaybeZ2b);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "m1b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsM1b), lp.QualityRejcntsM1b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 1, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ1a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeZ1a), lp.QualityRejcntsMaybeZ1a);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "m2a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsM2a), lp.QualityRejcntsM2a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ1b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMaybeZ1b), lp.QualityRejcntsMaybeZ1b);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "m2b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsM2b), lp.QualityRejcntsM2b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "hiza:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsHiza), lp.QualityRejcntsHiza);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t1a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT1a), lp.QualityRejcntsT1a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "hizb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsHizb), lp.QualityRejcntsHizb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t1b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT1b), lp.QualityRejcntsT1b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 6, (int) ' ', 16);
         sprintf(segmentValue, "z2a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsZ2a), lp.QualityRejcntsZ2a);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t2a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT2a), lp.QualityRejcntsT2a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 16);
         sprintf(segmentValue, "z2b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsZ2b), lp.QualityRejcntsZ2b);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t2b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT2b), lp.QualityRejcntsT2b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 4, (int) ' ', 18);
         sprintf(segmentValue, "adc2a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsAdc2a), lp.QualityRejcntsAdc2a);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t3a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT3a), lp.QualityRejcntsT3a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 18);
         sprintf(segmentValue, "adc2b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsAdc2b), lp.QualityRejcntsAdc2b);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t3b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT3b), lp.QualityRejcntsT3b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 4, (int) ' ', 18);
         sprintf(segmentValue, "adc3a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsAdc3a), lp.QualityRejcntsAdc3a);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t4a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT4a), lp.QualityRejcntsT4a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 18);
         sprintf(segmentValue, "adc3b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsAdc3b), lp.QualityRejcntsAdc3b);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t4b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT4b), lp.QualityRejcntsT4b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "mora:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMora), lp.QualityRejcntsMora);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t5a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT5a), lp.QualityRejcntsT5a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "morb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsMorb), lp.QualityRejcntsMorb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t5b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT5b), lp.QualityRejcntsT5b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "hora:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsHora), lp.QualityRejcntsHora);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t6a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT6a), lp.QualityRejcntsT6a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "horb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsHorb), lp.QualityRejcntsHorb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t6b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT6b), lp.QualityRejcntsT6b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m12a:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM12a), lp.QualityRejcntsM12a);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t7a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT7a), lp.QualityRejcntsT7a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m12b:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM12b), lp.QualityRejcntsM12b);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t7b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT7b), lp.QualityRejcntsT7b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m1ha:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM1ha), lp.QualityRejcntsM1ha);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t8a:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT8a), lp.QualityRejcntsT8a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m1hb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM1hb), lp.QualityRejcntsM1hb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t8b:%8.1f %2.2x ", uncompressSisValue(lp.RejcntsT8b), lp.QualityRejcntsT8b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m2ha:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM2ha), lp.QualityRejcntsM2ha);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m2hb:%7.1f %2.2x ", uncompressSisValue(lp.RejcntsM2hb), lp.QualityRejcntsM2hb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 2, (int) ' ', 24);
         sprintf(segmentValue, "CoinRate0:%9.1f %2.2x ", uncompressSisValue(lp.RejcntsCoinRate0), lp.QualityRejcntsCoinRate0);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 24);
         sprintf(segmentValue, "CoinRate1:%9.1f %2.2x ", uncompressSisValue(lp.RejcntsCoinRate1), lp.QualityRejcntsCoinRate1);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, "StimCoin:%9.1f %2.2x ", uncompressSisValue(lp.RejcntsStimCoin), lp.QualityRejcntsStimCoin);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 5, (int) ' ', 21);
         sprintf(segmentValue, "hazard:%9.1f %2.2x ", uncompressSisValue(lp.RejcntsHazard), lp.QualityRejcntsHazard);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 57, (int) ' ', 22);
         sprintf(segmentValue, "RejFast:%9.1f %2.2x ", uncompressSisValue(lp.RejcntsRejFast), lp.QualityRejcntsRejFast);
         memcpy(line + 57, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         printf("%s\n", line);
      strcpy(line, template[24]);
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, "MaybeHiza:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeHiza), lp.QualityVldcntsMaybeHiza);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 40, (int) ' ', 22);
         sprintf(segmentValue, "MaybeHizb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeHizb), lp.QualityVldcntsMaybeHizb);
         memcpy(line + 40, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 1, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ2a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeZ2a), lp.QualityVldcntsMaybeZ2a);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "m1a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsM1a), lp.QualityVldcntsM1a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ2b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeZ2b), lp.QualityVldcntsMaybeZ2b);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "m1b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsM1b), lp.QualityVldcntsM1b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 1, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ1a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeZ1a), lp.QualityVldcntsMaybeZ1a);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "m2a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsM2a), lp.QualityVldcntsM2a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 21);
         sprintf(segmentValue, "MaybeZ1b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMaybeZ1b), lp.QualityVldcntsMaybeZ1b);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "m2b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsM2b), lp.QualityVldcntsM2b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "hiza:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsHiza), lp.QualityVldcntsHiza);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t1a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT1a), lp.QualityVldcntsT1a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "hizb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsHizb), lp.QualityVldcntsHizb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t1b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT1b), lp.QualityVldcntsT1b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 6, (int) ' ', 16);
         sprintf(segmentValue, "z2a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsZ2a), lp.QualityVldcntsZ2a);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t2a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT2a), lp.QualityVldcntsT2a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 16);
         sprintf(segmentValue, "z2b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsZ2b), lp.QualityVldcntsZ2b);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t2b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT2b), lp.QualityVldcntsT2b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 4, (int) ' ', 18);
         sprintf(segmentValue, "adc2a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsAdc2a), lp.QualityVldcntsAdc2a);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t3a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT3a), lp.QualityVldcntsT3a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 18);
         sprintf(segmentValue, "adc2b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsAdc2b), lp.QualityVldcntsAdc2b);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t3b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT3b), lp.QualityVldcntsT3b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[31]);
         memset(line + 4, (int) ' ', 18);
         sprintf(segmentValue, "adc3a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsAdc3a), lp.QualityVldcntsAdc3a);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t4a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT4a), lp.QualityVldcntsT4a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 18);
         sprintf(segmentValue, "adc3b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsAdc3b), lp.QualityVldcntsAdc3b);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t4b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT4b), lp.QualityVldcntsT4b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[32]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "mora:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMora), lp.QualityVldcntsMora);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t5a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT5a), lp.QualityVldcntsT5a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "morb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsMorb), lp.QualityVldcntsMorb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t5b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT5b), lp.QualityVldcntsT5b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[33]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "hora:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsHora), lp.QualityVldcntsHora);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t6a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT6a), lp.QualityVldcntsT6a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "horb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsHorb), lp.QualityVldcntsHorb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t6b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT6b), lp.QualityVldcntsT6b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[34]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m12a:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM12a), lp.QualityVldcntsM12a);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t7a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT7a), lp.QualityVldcntsT7a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m12b:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM12b), lp.QualityVldcntsM12b);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t7b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT7b), lp.QualityVldcntsT7b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[35]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m1ha:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM1ha), lp.QualityVldcntsM1ha);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 23, (int) ' ', 17);
         sprintf(segmentValue, "t8a:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT8a), lp.QualityVldcntsT8a);
         memcpy(line + 23, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m1hb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM1hb), lp.QualityVldcntsM1hb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 17);
         sprintf(segmentValue, "t8b:%8.1f %2.2x ", uncompressSisValue(lp.VldcntsT8b), lp.QualityVldcntsT8b);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[36]);
         memset(line + 5, (int) ' ', 17);
         sprintf(segmentValue, "m2ha:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM2ha), lp.QualityVldcntsM2ha);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 17);
         sprintf(segmentValue, "m2hb:%7.1f %2.2x ", uncompressSisValue(lp.VldcntsM2hb), lp.QualityVldcntsM2hb);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[37]);
         printf("%s\n", line);
      strcpy(line, template[38]);
         memset(line + 2, (int) ' ', 24);
         sprintf(segmentValue, "CoinRate0:%9.1f %2.2x ", uncompressSisValue(lp.VldcntsCoinRate0), lp.QualityVldcntsCoinRate0);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 29, (int) ' ', 24);
         sprintf(segmentValue, "CoinRate1:%9.1f %2.2x ", uncompressSisValue(lp.VldcntsCoinRate1), lp.QualityVldcntsCoinRate1);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         memset(line + 56, (int) ' ', 23);
         sprintf(segmentValue, "StimCoin:%9.1f %2.2x ", uncompressSisValue(lp.VldcntsStimCoin), lp.QualityVldcntsStimCoin);
         memcpy(line + 56, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[39]);
         memset(line + 5, (int) ' ', 21);
         sprintf(segmentValue, "hazard:%9.1f %2.2x ", uncompressSisValue(lp.VldcntsHazard), lp.QualityVldcntsHazard);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 57, (int) ' ', 22);
         sprintf(segmentValue, "RejFast:%9.1f %2.2x ", uncompressSisValue(lp.VldcntsRejFast), lp.QualityVldcntsRejFast);
         memcpy(line + 57, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
