#ifndef DUMPL1SISSUBSET_C
   #define DUMPL1SISSUBSET_C

   /* $Id: dumpL1SisSubset.c,v 1.1 1998/07/27 12:15:39 rgr Exp $ */

   /* $RCSfile: dumpL1SisSubset.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:15:39 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "sis/L1SisSubset.h"
   #include "utilities/stringDate1996.h"

   void dumpL1SisSubset(struct L1SisSubset sub)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Subset <start time               >   <S/C Clock: xxxxxxxxxx>    <MJF: x xx>",
                          "                                                                <Quality: xx>",
                          "  <MainBusVoltage: xxx>       <InternalTemperature1: xxx>",
                          "      <SisCurrent: xxx>       <InternalTemperature2: xxx>",
                          "<SisCoverTelltale: xx>        <InterfaceTemperature: xxx>",
                          "",
                          "   <dt{0}  ><dt{4}  ><dt{8}  ><dt{12} >  <dt{16} ><dt{20} ><dt{24} ><dt{28} >",
                          "   <dt{32} ><dt{36} ><dt{40} ><dt{44} >  <dt{48} ><dt{52} ><dt{56} ><dt{60} >",
                          "   <dt{64} ><dt{68} ><dt{72} ><dt{76} >  <dt{80} ><dt{84} ><dt{88} ><dt{92} >",
                          "   <dt{96} ><dt{100}><dt{104}><dt{108}>  <dt{112}><dt{116}><dt{120}><dt{124}>",
                          "   <dt{128}><dt{132}><dt{136}><dt{140}>  <dt{144}><dt{148}><dt{152}><dt{156}>",
                          "   <dt{160}><dt{164}><dt{168}><dt{172}>  <dt{176}><dt{180}><dt{184}><dt{188}>",
                          "   <dt{192}><dt{194}><dt{200}><dt{204}>  <dt{208}><dt{212}><dt{216}><dt{220}>",
                          "   <dt{224}><dt{228}><dt{232}><dt{236}>  <dt{240}><dt{244}><data248>"};

      strcpy(line, template[0]);
         memset(line + 11, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(sub.Second1996), sub.microsecond);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", sub.ClockMinorFrame);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 11);
         sprintf(segmentValue, " MJF: %1d %2.2d ", sub.MajorFrameCount, sub.MinorFrameCount);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 64, (int) ' ', 13);
         sprintf(segmentValue, " Quality: %2.2x ", sub.quality);
         memcpy(line + 64, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 2, (int) ' ', 21);
         sprintf(segmentValue, " MainBusVoltage: %3d ", sub.MainBusVoltage);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 27);
         sprintf(segmentValue, " InternalTemperature1: %3d ", sub.SisInternalTemperature1);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 6, (int) ' ', 17);
         sprintf(segmentValue, " SisCurrent: %3d ", sub.SisCurrent);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 27);
         sprintf(segmentValue, " InternalTemperature2: %3d ", sub.SisInternalTemperature2);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, " SisCoverTelltale: %2.2x ", sub.SisCoverTelltale);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 27);
         sprintf(segmentValue, " InterfaceTemperature: %3d ", sub.SisInterfaceTemperature);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[0], sub.SisData[0+1], sub.SisData[0+2], sub.SisData[0+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[4], sub.SisData[4+1], sub.SisData[4+2], sub.SisData[4+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[8], sub.SisData[8+1], sub.SisData[8+2], sub.SisData[8+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[12], sub.SisData[12+1], sub.SisData[12+2], sub.SisData[12+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[16], sub.SisData[16+1], sub.SisData[16+2], sub.SisData[16+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[20], sub.SisData[20+1], sub.SisData[20+2], sub.SisData[20+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[24], sub.SisData[24+1], sub.SisData[24+2], sub.SisData[24+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[28], sub.SisData[28+1], sub.SisData[28+2], sub.SisData[28+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[32], sub.SisData[32+1], sub.SisData[32+2], sub.SisData[32+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[36], sub.SisData[36+1], sub.SisData[36+2], sub.SisData[36+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[40], sub.SisData[40+1], sub.SisData[40+2], sub.SisData[40+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[44], sub.SisData[44+1], sub.SisData[44+2], sub.SisData[44+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[48], sub.SisData[48+1], sub.SisData[48+2], sub.SisData[48+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[52], sub.SisData[52+1], sub.SisData[52+2], sub.SisData[52+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[56], sub.SisData[56+1], sub.SisData[56+2], sub.SisData[56+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[60], sub.SisData[60+1], sub.SisData[60+2], sub.SisData[60+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[64], sub.SisData[64+1], sub.SisData[64+2], sub.SisData[64+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[68], sub.SisData[68+1], sub.SisData[68+2], sub.SisData[68+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[72], sub.SisData[72+1], sub.SisData[72+2], sub.SisData[72+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[76], sub.SisData[76+1], sub.SisData[76+2], sub.SisData[76+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[80], sub.SisData[80+1], sub.SisData[80+2], sub.SisData[80+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[84], sub.SisData[84+1], sub.SisData[84+2], sub.SisData[84+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[88], sub.SisData[88+1], sub.SisData[88+2], sub.SisData[88+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[92], sub.SisData[92+1], sub.SisData[92+2], sub.SisData[92+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[96], sub.SisData[96+1], sub.SisData[96+2], sub.SisData[96+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[100], sub.SisData[100+1], sub.SisData[100+2], sub.SisData[100+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[104], sub.SisData[104+1], sub.SisData[104+2], sub.SisData[104+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[108], sub.SisData[108+1], sub.SisData[108+2], sub.SisData[108+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[112], sub.SisData[112+1], sub.SisData[112+2], sub.SisData[112+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[116], sub.SisData[116+1], sub.SisData[116+2], sub.SisData[116+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[120], sub.SisData[120+1], sub.SisData[120+2], sub.SisData[120+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[124], sub.SisData[124+1], sub.SisData[124+2], sub.SisData[124+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[128], sub.SisData[128+1], sub.SisData[128+2], sub.SisData[128+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[132], sub.SisData[132+1], sub.SisData[132+2], sub.SisData[132+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[136], sub.SisData[136+1], sub.SisData[136+2], sub.SisData[136+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[140], sub.SisData[140+1], sub.SisData[140+2], sub.SisData[140+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[144], sub.SisData[144+1], sub.SisData[144+2], sub.SisData[144+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[148], sub.SisData[148+1], sub.SisData[148+2], sub.SisData[148+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[152], sub.SisData[152+1], sub.SisData[152+2], sub.SisData[152+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[156], sub.SisData[156+1], sub.SisData[156+2], sub.SisData[156+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[160], sub.SisData[160+1], sub.SisData[160+2], sub.SisData[160+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[164], sub.SisData[164+1], sub.SisData[164+2], sub.SisData[164+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[168], sub.SisData[168+1], sub.SisData[168+2], sub.SisData[168+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[172], sub.SisData[172+1], sub.SisData[172+2], sub.SisData[172+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[176], sub.SisData[176+1], sub.SisData[176+2], sub.SisData[176+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[180], sub.SisData[180+1], sub.SisData[180+2], sub.SisData[180+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[184], sub.SisData[184+1], sub.SisData[184+2], sub.SisData[184+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[188], sub.SisData[188+1], sub.SisData[188+2], sub.SisData[188+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[192], sub.SisData[192+1], sub.SisData[192+2], sub.SisData[192+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[194], sub.SisData[194+1], sub.SisData[194+2], sub.SisData[194+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[200], sub.SisData[200+1], sub.SisData[200+2], sub.SisData[200+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[204], sub.SisData[204+1], sub.SisData[204+2], sub.SisData[204+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[208], sub.SisData[208+1], sub.SisData[208+2], sub.SisData[208+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[212], sub.SisData[212+1], sub.SisData[212+2], sub.SisData[212+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[216], sub.SisData[216+1], sub.SisData[216+2], sub.SisData[216+3]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[220], sub.SisData[220+1], sub.SisData[220+2], sub.SisData[220+3]);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 3, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[224], sub.SisData[224+1], sub.SisData[224+2], sub.SisData[224+3]);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[228], sub.SisData[228+1], sub.SisData[228+2], sub.SisData[228+3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[232], sub.SisData[232+1], sub.SisData[232+2], sub.SisData[232+3]);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[236], sub.SisData[236+1], sub.SisData[236+2], sub.SisData[236+3]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[240], sub.SisData[240+1], sub.SisData[240+2], sub.SisData[240+3]);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sub.SisData[244], sub.SisData[244+1], sub.SisData[244+2], sub.SisData[244+3]);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         memset(line + 59, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x      ", sub.SisData[248]);
         memcpy(line + 59, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
