#ifndef DUMPL1_1SISEVENT_C
   #define DUMPL1_1SISEVENT_C

   /* $Id: dumpL1_1SisEvent.c,v 1.2 1998/07/27 12:15:52 rgr Exp $ */

   /* $RCSfile: dumpL1_1SisEvent.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:15:52 $ */
   /* $Revision: 1.2 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   #include "hdfi.h"
   
   #include "sis/L1_1SisEvent.h"
   #include "ace/expandUint16.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1SisEvent(struct L1_1SisEvent evt)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Normal Event - <start time               >",
                          "",
                          "                                m1-  m1-    m1+  m1+    m2-  m2-    m2+  m2+",
                          "<EventNo.: xxxxxxxxxx>  00/32 <m1-{0}  >  <m1+{0}  >  <m2-{0}  >  <m2+{0}  >",
                          "<EventOffset: xxx>      01/33 <m1-{1}  >  <m1+{1}  >  <m2-{1}  >  <m2+{1}  >",
                          "                        02/34 <m1-{2}  >  <m1+{2}  >  <m2-{2}  >  <m2+{2}  >",
                          "       <BufferId: xxx>  03/35 <m1-{3}  >  <m1+{3}  >  <m2-{3}  >  <m2+{3}  >",
                          "<Stimulated Flag: x>    04/36 <m1-{4}  >  <m1+{4}  >  <m2-{4}  >  <m2+{4}  >",
                          "     <Maybe Flag: x>    05/37 <m1-{5}  >  <m1+{5}  >  <m2-{5}  >  <m2+{5}  >",
                          "    <Hazard Flag: x>    06/38 <m1-{6}  >  <m1+{6}  >  <m2-{6}  >  <m2+{6}  >",
                          " <Peak Time Flag: x>    07/39 <m1-{7}  >  <m1+{7}  >  <m2-{7}  >  <m2+{7}  >",
                          "                        08/40 <m1-{8}  >  <m1+{8}  >  <m2-{8}  >  <m2+{8}  >",
                          "   <Status/Range A: x/x>09/41 <m1-{9}  >  <m1+{9}  >  <m2-{9}  >  <m2+{9}  >",
                          "   <Status/Range B: x/x>10/42 <m1-{10} >  <m1+{10} >  <m2-{10} >  <m2+{10} >",
                          "         <Time Tag: x>  11/43 <m1-{11} >  <m1+{11} >  <m2-{11} >  <m2+{11} >",
                          "            <Phase: xx> 12/44 <m1-{12} >  <m1+{12} >  <m2-{12} >  <m2+{12} >",
                          "  <NumMatrixStrips: xx> 13/45 <m1-{13} >  <m1+{13} >  <m2-{13} >  <m2+{13} >",
                          "<OtherMatrixGroups: x>  14/46 <m1-{14} >  <m1+{14} >  <m2-{14} >  <m2+{14} >",
                          "     <Peak Time M1: xx> 15/47 <m1-{15} >  <m1+{15} >  <m2-{15} >  <m2+{15} >",
                          "     <Peak time M2: xx> 16/48 <m1-{16} >  <m1+{16} >  <m2-{16} >  <m2+{16} >",
                          "     <Peak Time T1: xx> 17/49 <m1-{17} >  <m1+{17} >  <m2-{17} >  <m2+{17} >",
                          "  <M1GndSideOffset: xx> 18/50 <m1-{18} >  <m1+{18} >  <m2-{18} >  <m2+{18} >",
                          "   <M1HvSideOffset: xx> 19/51 <m1-{19} >  <m1+{19} >  <m2-{19} >  <m2+{19} >",
                          "  <M2GndSideOffset: xx> 20/52 <m1-{20} >  <m1+{20} >  <m2-{20} >  <m2+{20} >",
                          "   <M2HvSideOffset: xx> 21/53 <m1-{21} >  <m1+{21} >  <m2-{21} >  <m2+{21} >",
                          "                        22/54 <m1-{22} >  <m1+{22} >  <m2-{22} >  <m2+{22} >",
                          "<t1a: xxxx><t1b: xxxx>  23/55 <m1-{23} >  <m1+{23} >  <m2-{23} >  <m2+{23} >",
                          "<t1a: xxxx><t1b: xxxx>  24/56 <m1-{24} >  <m1+{24} >  <m2-{24} >  <m2+{24} >",
                          "<t2a: xxxx><t2b: xxxx>  25/57 <m1-{25} >  <m1+{25} >  <m2-{25} >  <m2+{25} >",
                          "<t3a: xxxx><t3b: xxxx>  26/58 <m1-{26} >  <m1+{26} >  <m2-{26} >  <m2+{26} >",
                          "<t4a: xxxx><t4b: xxxx>  27/59 <m1-{27} >  <m1+{27} >  <m2-{27} >  <m2+{27} >",
                          "<t5a: xxxx><t5b: xxxx>  28/60 <m1-{28} >  <m1+{28} >  <m2-{28} >  <m2+{28} >",
                          "<t6a: xxxx><t6b: xxxx>  29/61 <m1-{29} >  <m1+{29} >  <m2-{29} >  <m2+{29} >",
                          "<t7a: xxxx><t7b: xxxx>  30/62 <m1-{30} >  <m1+{30} >  <m2-{30} >  <m2+{30} >",
                          "<t8a: xxxx><t8b: xxxx>  31/63 <m1-{31} >  <m1+{31} >  <m2-{31} >  <m2+{31} >",
                          "",
                          "    <Stim Mask: XXXX>   <MatrixGndSide: xxx>  <vref: xxx> <gain_f1: xxx>",
                          " <Cal Sequence: xxxxx>  <AMatrixHvSide: xxx> <vref1: xxx> <gain_f2: xxx>",
                          "                        <BMatrixHvSide: xxx> <vref2: xxx>"};

      strcpy(line, template[0]);
         memset(line + 19, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(evt.Second1996), evt.microsecond);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, " EventNo.: %10.10lu ", evt.EventNumber);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[0], evt.M1GndPha[0+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[0], evt.M1FloatPha[0+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[0], evt.M2GndPha[0+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[0], evt.M2FloatPha[0+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 18);
         sprintf(segmentValue, " EventOffset: %3.3u ", evt.EventOffset);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[1], evt.M1GndPha[1+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[1], evt.M1FloatPha[1+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[1], evt.M2GndPha[1+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[1], evt.M2FloatPha[1+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[2], evt.M1GndPha[2+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[2], evt.M1FloatPha[2+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[2], evt.M2GndPha[2+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[2], evt.M2FloatPha[2+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 7, (int) ' ', 15);
         sprintf(segmentValue, " BufferId: %3.3u ", evt.BufferId);
         memcpy(line + 7, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[3], evt.M1GndPha[3+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[3], evt.M1FloatPha[3+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[3], evt.M2GndPha[3+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[3], evt.M2FloatPha[3+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 0, (int) ' ', 20);
         sprintf(segmentValue, " Stimulated Flag: %1u ", evt.flag.stimulated);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[4], evt.M1GndPha[4+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[4], evt.M1FloatPha[4+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[4], evt.M2GndPha[4+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[4], evt.M2FloatPha[4+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 5, (int) ' ', 15);
         sprintf(segmentValue, " Maybe Flag: %1u ", evt.flag.maybe);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[5], evt.M1GndPha[5+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[5], evt.M1FloatPha[5+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[5], evt.M2GndPha[5+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[5], evt.M2FloatPha[5+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 4, (int) ' ', 16);
         sprintf(segmentValue, " Hazard Flag: %1u ", evt.flag.hazard);
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[6], evt.M1GndPha[6+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[6], evt.M1FloatPha[6+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[6], evt.M2GndPha[6+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[6], evt.M2FloatPha[6+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 1, (int) ' ', 19);
         sprintf(segmentValue, " Peak Time Flag: %1u ", evt.flag.PeakTime);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[7], evt.M1GndPha[7+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[7], evt.M1FloatPha[7+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[7], evt.M2GndPha[7+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[7], evt.M2FloatPha[7+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[8], evt.M1GndPha[8+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[8], evt.M1FloatPha[8+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[8], evt.M2GndPha[8+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[8], evt.M2FloatPha[8+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " Status/Range A: %1u/%1u ", evt.StackAStatus, evt.RangeA);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[9], evt.M1GndPha[9+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[9], evt.M1FloatPha[9+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[9], evt.M2GndPha[9+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[9], evt.M2FloatPha[9+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 3, (int) ' ', 21);
         sprintf(segmentValue, " Status/Range B: %1u/%1u ", evt.StackBStatus, evt.RangeB);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[10], evt.M1GndPha[10+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[10], evt.M1FloatPha[10+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[10], evt.M2GndPha[10+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[10], evt.M2FloatPha[10+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 9, (int) ' ', 13);
         sprintf(segmentValue, " Time Tag: %1u ", evt.TimeTag);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[11], evt.M1GndPha[11+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[11], evt.M1FloatPha[11+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[11], evt.M2GndPha[11+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[11], evt.M2FloatPha[11+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 12, (int) ' ', 11);
         sprintf(segmentValue, " Phase: %2.2u ", evt.phase);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[12], evt.M1GndPha[12+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[12], evt.M1FloatPha[12+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[12], evt.M2GndPha[12+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[12], evt.M2FloatPha[12+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 2, (int) ' ', 21);
         sprintf(segmentValue, " NumMatrixStrips: %2.2u ", evt.NumberMatrixStrips);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[13], evt.M1GndPha[13+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[13], evt.M1FloatPha[13+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[13], evt.M2GndPha[13+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[13], evt.M2FloatPha[13+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, " OtherMatrixGroups: %1u ", evt.OtherMatrixGroups);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[14], evt.M1GndPha[14+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[14], evt.M1FloatPha[14+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[14], evt.M2GndPha[14+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[14], evt.M2FloatPha[14+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 5, (int) ' ', 18);
         sprintf(segmentValue, " Peak Time M1: %2.2u ", evt.PeakTimeM1);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[15], evt.M1GndPha[15+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[15], evt.M1FloatPha[15+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[15], evt.M2GndPha[15+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[15], evt.M2FloatPha[15+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 5, (int) ' ', 18);
         sprintf(segmentValue, " Peak time M2: %2.2u ", evt.PeakTimeM2);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[16], evt.M1GndPha[16+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[16], evt.M1FloatPha[16+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[16], evt.M2GndPha[16+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[16], evt.M2FloatPha[16+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 5, (int) ' ', 18);
         sprintf(segmentValue, " Peak Time T1: %2.2u ", evt.PeakTimeT1);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[17], evt.M1GndPha[17+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[17], evt.M1FloatPha[17+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[17], evt.M2GndPha[17+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[17], evt.M2FloatPha[17+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 2, (int) ' ', 21);
         sprintf(segmentValue, " M1GndSideOffset: %2.2d ", evt.M1GndSideOffset);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[18], evt.M1GndPha[18+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[18], evt.M1FloatPha[18+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[18], evt.M2GndPha[18+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[18], evt.M2FloatPha[18+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 3, (int) ' ', 20);
         sprintf(segmentValue, " M1HvSideOffset: %2.2d ", evt.M1HvSideOffset);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[19], evt.M1GndPha[19+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[19], evt.M1FloatPha[19+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[19], evt.M2GndPha[19+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[19], evt.M2FloatPha[19+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 2, (int) ' ', 21);
         sprintf(segmentValue, " M2GndSideOffset: %2.2d ", evt.M2GndSideOffset);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[20], evt.M1GndPha[20+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[20], evt.M1FloatPha[20+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[20], evt.M2GndPha[20+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[20], evt.M2FloatPha[20+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 3, (int) ' ', 20);
         sprintf(segmentValue, " M2HvSideOffset: %2.2d ", evt.M2HvSideOffset);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[21], evt.M1GndPha[21+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[21], evt.M1FloatPha[21+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[21], evt.M2GndPha[21+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[21], evt.M2FloatPha[21+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[22], evt.M1GndPha[22+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[22], evt.M1FloatPha[22+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[22], evt.M2GndPha[22+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[22], evt.M2FloatPha[22+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t1a: %4d ", evt.StackA[0]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t1b: %4d ", evt.StackB[0]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[23], evt.M1GndPha[23+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[23], evt.M1FloatPha[23+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[23], evt.M2GndPha[23+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[23], evt.M2FloatPha[23+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t1a: %4d ", evt.StackA[0]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t1b: %4d ", evt.StackB[0]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[24], evt.M1GndPha[24+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[24], evt.M1FloatPha[24+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[24], evt.M2GndPha[24+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[24], evt.M2FloatPha[24+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t2a: %4d ", evt.StackA[1]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t2b: %4d ", evt.StackB[1]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[25], evt.M1GndPha[25+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[25], evt.M1FloatPha[25+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[25], evt.M2GndPha[25+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[25], evt.M2FloatPha[25+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t3a: %4d ", evt.StackA[2]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t3b: %4d ", evt.StackB[2]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[26], evt.M1GndPha[26+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[26], evt.M1FloatPha[26+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[26], evt.M2GndPha[26+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[26], evt.M2FloatPha[26+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t4a: %4d ", evt.StackA[3]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t4b: %4d ", evt.StackB[3]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[27], evt.M1GndPha[27+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[27], evt.M1FloatPha[27+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[27], evt.M2GndPha[27+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[27], evt.M2FloatPha[27+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[31]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t5a: %4d ", evt.StackA[4]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t5b: %4d ", evt.StackB[4]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[28], evt.M1GndPha[28+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[28], evt.M1FloatPha[28+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[28], evt.M2GndPha[28+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[28], evt.M2FloatPha[28+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[32]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t6a: %4d ", evt.StackA[5]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t6b: %4d ", evt.StackB[5]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[29], evt.M1GndPha[29+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[29], evt.M1FloatPha[29+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[29], evt.M2GndPha[29+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[29], evt.M2FloatPha[29+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[33]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t7a: %4d ", evt.StackA[6]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t7b: %4d ", evt.StackB[6]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[30], evt.M1GndPha[30+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[30], evt.M1FloatPha[30+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[30], evt.M2GndPha[30+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[30], evt.M2FloatPha[30+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[34]);
         memset(line + 0, (int) ' ', 11);
         sprintf(segmentValue, " t8a: %4d ", evt.StackA[7]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 11, (int) ' ', 11);
         sprintf(segmentValue, " t8b: %4d ", evt.StackB[7]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1GndPha[31], evt.M1GndPha[31+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M1FloatPha[31], evt.M1FloatPha[31+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2GndPha[31], evt.M2GndPha[31+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", evt.M2FloatPha[31], evt.M2FloatPha[31+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[35]);
         printf("%s\n", line);
      strcpy(line, template[36]);
         memset(line + 4, (int) ' ', 17);
         sprintf(segmentValue, " Stim Mask: %4.4lx ", expandUint16(evt.stimulated.stmask));
         memcpy(line + 4, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " MatrixGndSide: %3.3u ", evt.stimulated.MatrixGndSide);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 46, (int) ' ', 11);
         sprintf(segmentValue, " vref: %3.3u ", evt.stimulated.vref);
         memcpy(line + 46, segmentValue, strlen(segmentValue));
         memset(line + 58, (int) ' ', 14);
         sprintf(segmentValue, " gain_f1: %3.3u ", evt.stimulated.gain_f1);
         memcpy(line + 58, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[37]);
         memset(line + 1, (int) ' ', 21);
         sprintf(segmentValue, " Cal Sequence: %5.5lu ", expandUint16(evt.stimulated.CalSequence));
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " AMatrixHvSide: %3.3u ", evt.stimulated.AMatrixHvSide);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 12);
         sprintf(segmentValue, " vref1: %3.3u ", evt.stimulated.vref1);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         memset(line + 58, (int) ' ', 14);
         sprintf(segmentValue, " gain_f2: %3.3u ", evt.stimulated.gain_f2);
         memcpy(line + 58, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[38]);
         memset(line + 24, (int) ' ', 20);
         sprintf(segmentValue, " BMatrixHvSide: %3.3u ", evt.stimulated.BMatrixHvSide);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 45, (int) ' ', 12);
         sprintf(segmentValue, " vref2: %3.3u ", evt.stimulated.vref2);
         memcpy(line + 45, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
