#ifndef DUMPL1_1SISHIGHPRIORITYRATE_C
   #define DUMPL1_1SISHIGHPRIORITYRATE_C

   /* $Id: dumpL1_1SisHighPriorityRate.c,v 1.2 1998/07/31 01:20:05 rgr Exp $ */

   /* $RCSfile: dumpL1_1SisHighPriorityRate.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/31 01:20:05 $ */
   /* $Revision: 1.2 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   #include "hdfi.h"
   
   #include "sis/L1_1SisHighPriorityRate.h"
   #include "ace/expandUint16.h"
   #include "utilities/stringDate1996.h"
   #include "sis/stringSisHighPriorityRate.h"

   void dumpL1_1SisHighPriorityRate(struct L1_1SisHighPriorityRate hp)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS High Priority Rates ---- <Coincidence mask: xxxx xx>",
                          "<start time               >      <S/C Clock: xxxxxxxxxx>",
                          "",
                          "Quality           Rate   Name",
                          "<q{0} >  0. <rate{0} > :<name{0}                                >",
                          "<q{1} >  1. <rate{1} > :<name{1}                                >",
                          "<q{2} >  2. <rate{2} > :<name{2}                                >",
                          "<q{3} >  3. <rate{3} > :<name{3}                                >",
                          "<q{4} >  4. <rate{4} > :<name{4}                                >",
                          "<q{5} >  5. <rate{5} > :<name{5}                                >",
                          "<q{6} >  6. <rate{6} > :<name{6}                                >",
                          "<q{7} >  7. <rate{7} > :<name{7}                                >",
                          "<q{8} >  8. <rate{8} > :<name{8}                                >",
                          "<q{9} >  9. <rate{9} > :<name{9}                                >",
                          "<q{10}> 10. <rate{10}> :<name{10}                               >",
                          "<q{11}> 11. <rate{11}> :<name{11}                               >",
                          "<q{12}> 12. <rate{12}> :<name{12}                               >",
                          "<q{13}> 13. <rate{13}> :<name{13}                               >",
                          "<q{14}> 14. <rate{14}> :<name{14}                               >",
                          "<q{15}> 15. <rate{15}> :<name{15}                               >",
                          "<q{16}> 16. <rate{16}> :<name{16}                               >",
                          "<q{17}> 17. <rate{17}> :<name{17}                               >"};

      strcpy(line, template[0]);
         memset(line + 29, (int) ' ', 27);
         sprintf(segmentValue, " Coincidence mask: %4.4lx %2.2x", expandUint16(hp.CoinMask), hp.QualityCoinMask);
         memcpy(line + 29, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 0, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(hp.Second1996), hp.microsecond);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 33, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", hp.ClockMinorFrame);
         memcpy(line + 33, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[0], hp.QualityDefinition[0]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[0]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[0],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[1], hp.QualityDefinition[1]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[1]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[1],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[2], hp.QualityDefinition[2]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[2]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[2],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[3], hp.QualityDefinition[3]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[3]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[3],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[4], hp.QualityDefinition[4]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[4]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[4],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[5], hp.QualityDefinition[5]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[5]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[5],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[6], hp.QualityDefinition[6]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[6]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[6],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[7], hp.QualityDefinition[7]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[7]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[7],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[8], hp.QualityDefinition[8]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[8]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[8],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[9], hp.QualityDefinition[9]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[9]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[9],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[10], hp.QualityDefinition[10]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[10]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[10],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[11], hp.QualityDefinition[11]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[11]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[11],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[12], hp.QualityDefinition[12]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[12]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[12],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[13], hp.QualityDefinition[13]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[13]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[13],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[14], hp.QualityDefinition[14]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[14]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[14],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[15], hp.QualityDefinition[15]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[15]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[15],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[16], hp.QualityDefinition[16]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[16]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[16],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x:%2.2x ", hp.QualityHp[17], hp.QualityDefinition[17]);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 12, (int) ' ', 10);
         sprintf(segmentValue, "%10.3f", hp.hp[17]);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 41);
         sprintf(segmentValue, " %s", stringSisHighPriorityRate(hp.definition[17],hp.CoinMask));
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
