#ifndef DUMPL1_1SISRAWEVENT_C
   #define DUMPL1_1SISRAWEVENT_C

   /* $Id: dumpL1_1SisRawEvent.c,v 1.2 1998/07/27 12:16:02 rgr Exp $ */

   /* $RCSfile: dumpL1_1SisRawEvent.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:16:02 $ */
   /* $Revision: 1.2 $ */


   #include <memory.h>
   #include <stdio.h>
   #include "sis/L1_1SisDiagnosticEvent.h"

   void dumpL1_1SisRawEvent(struct L1_1SisRawEvent raw)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"Telescope A:                               Telescope B:",
                          "",
                          "<t1: x>   <m1: x>       <hiz: x>           <t1: y>   <m1: y>       <hiz: y>",
                          "<t2: x>  <m1h: x> <maybe_hiz: x>           <t2: y>  <m1h: y> <maybe_hiz: y>",
                          "<t3: x>   <m2: x>        <z2: x>           <t3: y>   <m2: y>        <z2: y>",
                          "<t4: x>  <m2h: x>  <maybe_z2: x>           <t4: y>  <m2h: y>  <maybe_z2: y>",
                          "<t5: x>  <m12: x>  <maybe_z1: x>           <t5: y>  <m12: y>  <maybe_z1: y>",
                          "<t6: x> <adc2: x>   <time_m1: xx>          <t6: y> <adc2: y>   <time_m1: yy>",
                          "<t7: x> <adc3: x>   <time_m2: xx>          <t7: y> <adc3: y>   <time_m2: yy>",
                          "<t8: x>  <mor: x>   <time_t1: xx>          <t8: y>  <mor: y>   <time_t1: yy>",
                          "         <hor: x>                                   <hor: y>",
                          "",
                          "                                m1-  m1-    m1+  m1+    m2-  m2-    m2+  m2+",
                          "   <cycle count: xxx>   00/32 <m1-{0}  >  <m1+{0}  >  <m2-{0}  >  <m2+{0}  >",
                          "         <phase: xx>    01/33 <m1-{1}  >  <m1+{1}  >  <m2-{1}  >  <m2+{1}  >",
                          "                        02/34 <m1-{2}  >  <m1+{2}  >  <m2-{2}  >  <m2+{2}  >",
                          "       <telescope: x>   03/35 <m1-{3}  >  <m1+{3}  >  <m2-{3}  >  <m2+{3}  >",
                          "           <class: x>   04/36 <m1-{4}  >  <m1+{4}  >  <m2-{4}  >  <m2+{4}  >",
                          "      <coin_valid: x>   05/37 <m1-{5}  >  <m1+{5}  >  <m2-{5}  >  <m2+{5}  >",
                          "        <rej_fast: x>   06/38 <m1-{6}  >  <m1+{6}  >  <m2-{6}  >  <m2+{6}  >",
                          "       <stim_anti: x>   07/39 <m1-{7}  >  <m1+{7}  >  <m2-{7}  >  <m2+{7}  >",
                          "       <stim_coin: x>   08/40 <m1-{8}  >  <m1+{8}  >  <m2-{8}  >  <m2+{8}  >",
                          "     <stim_offset: x>   09/41 <m1-{9}  >  <m1+{9}  >  <m2-{9}  >  <m2+{9}  >",
                          "          <hazard: x>   10/42 <m1-{10} >  <m1+{10} >  <m2-{10} >  <m2+{10} >",
                          " <hydrogen_enable: x>   11/43 <m1-{11} >  <m1+{11} >  <m2-{11} >  <m2+{11} >",
                          "   <helium_enable: x>   12/44 <m1-{12} >  <m1+{12} >  <m2-{12} >  <m2+{12} >",
                          "<stop_acknowledge: x>   13/45 <m1-{13} >  <m1+{13} >  <m2-{13} >  <m2+{13} >",
                          "                        14/46 <m1-{14} >  <m1+{14} >  <m2-{14} >  <m2+{14} >",
                          "           <t1: xxxx>   15/47 <m1-{15} >  <m1+{15} >  <m2-{15} >  <m2+{15} >",
                          "           <t2: xxxx>   16/48 <m1-{16} >  <m1+{16} >  <m2-{16} >  <m2+{16} >",
                          "           <t3: xxxx>   17/49 <m1-{17} >  <m1+{17} >  <m2-{17} >  <m2+{17} >",
                          "           <t4: xxxx>   18/50 <m1-{18} >  <m1+{18} >  <m2-{18} >  <m2+{18} >",
                          "           <t5: xxxx>   19/51 <m1-{19} >  <m1+{19} >  <m2-{19} >  <m2+{19} >",
                          "           <t6: xxxx>   20/52 <m1-{20} >  <m1+{20} >  <m2-{20} >  <m2+{20} >",
                          "           <t7: xxxx>   21/53 <m1-{21} >  <m1+{21} >  <m2-{21} >  <m2+{21} >",
                          "           <t8: xxxx>   22/54 <m1-{22} >  <m1+{22} >  <m2-{22} >  <m2+{22} >",
                          "                        23/55 <m1-{23} >  <m1+{23} >  <m2-{23} >  <m2+{23} >",
                          "                        24/56 <m1-{24} >  <m1+{24} >  <m2-{24} >  <m2+{24} >",
                          "                        25/57 <m1-{25} >  <m1+{25} >  <m2-{25} >  <m2+{25} >",
                          "                        26/58 <m1-{26} >  <m1+{26} >  <m2-{26} >  <m2+{26} >",
                          "                        27/59 <m1-{27} >  <m1+{27} >  <m2-{27} >  <m2+{27} >",
                          "                        28/60 <m1-{28} >  <m1+{28} >  <m2-{28} >  <m2+{28} >",
                          "                        29/61 <m1-{29} >  <m1+{29} >  <m2-{29} >  <m2+{29} >",
                          "                        30/62 <m1-{30} >  <m1+{30} >  <m2-{30} >  <m2+{30} >",
                          "                        31/63 <m1-{31} >  <m1+{31} >  <m2-{31} >  <m2+{31} >"};

      strcpy(line, template[0]);
         printf("%s\n", line);
      strcpy(line, template[1]);
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t1: %1d ", raw.a.tag.t1);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 10, (int) ' ', 7);
         sprintf(segmentValue, " m1: %1d ", raw.a.tag.m1);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 24, (int) ' ', 8);
         sprintf(segmentValue, " hiz: %1d ", raw.a.tag.hiz);
         memcpy(line + 24, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t1: %1d ", raw.b.tag.t1);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 7);
         sprintf(segmentValue, " m1: %1d ", raw.b.tag.m1);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 67, (int) ' ', 8);
         sprintf(segmentValue, " hiz: %1d ", raw.b.tag.hiz);
         memcpy(line + 67, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t2: %1d ", raw.a.tag.t2);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 9, (int) ' ', 8);
         sprintf(segmentValue, " m1h: %1d ", raw.a.tag.m1h);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 18, (int) ' ', 14);
         sprintf(segmentValue, " maybe_hiz: %1d ", raw.a.tag.maybe_hiz);
         memcpy(line + 18, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t2: %1d ", raw.b.tag.t2);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 8);
         sprintf(segmentValue, " m1h: %1d ", raw.b.tag.m1h);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 14);
         sprintf(segmentValue, " maybe_hiz: %1d ", raw.b.tag.maybe_hiz);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t3: %1d ", raw.a.tag.t3);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 10, (int) ' ', 7);
         sprintf(segmentValue, " m2: %1d ", raw.a.tag.m2);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 25, (int) ' ', 7);
         sprintf(segmentValue, " z2: %1d ", raw.a.tag.z2);
         memcpy(line + 25, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t3: %1d ", raw.b.tag.t3);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 7);
         sprintf(segmentValue, " m2: %1d ", raw.b.tag.m2);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 68, (int) ' ', 7);
         sprintf(segmentValue, " z2: %1d ", raw.b.tag.z2);
         memcpy(line + 68, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t4: %1d ", raw.a.tag.t4);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 9, (int) ' ', 8);
         sprintf(segmentValue, " m2h: %1d ", raw.a.tag.m2h);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 13);
         sprintf(segmentValue, " maybe_z2: %1d ", raw.a.tag.maybe_z2);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t4: %1d ", raw.b.tag.t4);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 8);
         sprintf(segmentValue, " m2h: %1d ", raw.b.tag.m2h);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 13);
         sprintf(segmentValue, " maybe_z2: %1d ", raw.b.tag.maybe_z2);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t5: %1d ", raw.a.tag.t5);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 9, (int) ' ', 8);
         sprintf(segmentValue, " m12: %1d ", raw.a.tag.m12);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 19, (int) ' ', 13);
         sprintf(segmentValue, " maybe_z1: %1d ", raw.a.tag.maybe_z1);
         memcpy(line + 19, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t5: %1d ", raw.b.tag.t5);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 8);
         sprintf(segmentValue, " m12: %1d ", raw.b.tag.m12);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 13);
         sprintf(segmentValue, " maybe_z1: %1d ", raw.b.tag.maybe_z1);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t6: %1d ", raw.a.tag.t6);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " adc2: %1d ", raw.a.tag.adc2);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 13);
         sprintf(segmentValue, " time_m1: %2.2d ", raw.a.time_m1);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t6: %1d ", raw.b.tag.t6);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 9);
         sprintf(segmentValue, " adc2: %1d ", raw.b.tag.adc2);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 13);
         sprintf(segmentValue, " time_m1: %2.2d ", raw.b.time_m1);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t7: %1d ", raw.a.tag.t7);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " adc3: %1d ", raw.a.tag.adc3);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 13);
         sprintf(segmentValue, " time_m2: %2.2d ", raw.a.time_m2);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t7: %1d ", raw.b.tag.t7);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 51, (int) ' ', 9);
         sprintf(segmentValue, " adc3: %1d ", raw.b.tag.adc3);
         memcpy(line + 51, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 13);
         sprintf(segmentValue, " time_m2: %2.2d ", raw.b.time_m2);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         memset(line + 0, (int) ' ', 7);
         sprintf(segmentValue, " t8: %1d ", raw.a.tag.t8);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 9, (int) ' ', 8);
         sprintf(segmentValue, " mor: %1d ", raw.a.tag.mor);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 13);
         sprintf(segmentValue, " time_t1: %2.2d ", raw.a.time_t1);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 43, (int) ' ', 7);
         sprintf(segmentValue, " t8: %1d ", raw.b.tag.t8);
         memcpy(line + 43, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 8);
         sprintf(segmentValue, " mor: %1d ", raw.b.tag.mor);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         memset(line + 63, (int) ' ', 13);
         sprintf(segmentValue, " time_t1: %2.2d ", raw.b.time_t1);
         memcpy(line + 63, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 9, (int) ' ', 8);
         sprintf(segmentValue, " hor: %1d ", raw.a.tag.hor);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 52, (int) ' ', 8);
         sprintf(segmentValue, " hor: %1d ", raw.b.tag.hor);
         memcpy(line + 52, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         printf("%s\n", line);
      strcpy(line, template[12]);
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 3, (int) ' ', 18);
         sprintf(segmentValue, " cycle count: %3.3d ", raw.CycleCount);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][0], raw.MatrixStrip[0][0+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][0], raw.MatrixStrip[1][0+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][0], raw.MatrixStrip[2][0+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][0], raw.MatrixStrip[3][0+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 9, (int) ' ', 11);
         sprintf(segmentValue, " phase: %2.2d ", raw.phase);
         memcpy(line + 9, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][1], raw.MatrixStrip[0][1+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][1], raw.MatrixStrip[1][1+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][1], raw.MatrixStrip[2][1+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][1], raw.MatrixStrip[3][1+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][2], raw.MatrixStrip[0][2+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][2], raw.MatrixStrip[1][2+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][2], raw.MatrixStrip[2][2+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][2], raw.MatrixStrip[3][2+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 7, (int) ' ', 14);
         sprintf(segmentValue, " telescope: %1d ", raw.tag.telescope);
         memcpy(line + 7, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][3], raw.MatrixStrip[0][3+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][3], raw.MatrixStrip[1][3+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][3], raw.MatrixStrip[2][3+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][3], raw.MatrixStrip[3][3+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " class: %1d ", raw.class);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][4], raw.MatrixStrip[0][4+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][4], raw.MatrixStrip[1][4+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][4], raw.MatrixStrip[2][4+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][4], raw.MatrixStrip[3][4+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 6, (int) ' ', 15);
         sprintf(segmentValue, " coin_valid: %1d ", raw.tag.coin_valid);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][5], raw.MatrixStrip[0][5+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][5], raw.MatrixStrip[1][5+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][5], raw.MatrixStrip[2][5+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][5], raw.MatrixStrip[3][5+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 8, (int) ' ', 13);
         sprintf(segmentValue, " rej_fast: %1d ", raw.tag.rej_fast);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][6], raw.MatrixStrip[0][6+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][6], raw.MatrixStrip[1][6+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][6], raw.MatrixStrip[2][6+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][6], raw.MatrixStrip[3][6+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 7, (int) ' ', 14);
         sprintf(segmentValue, " stim_anti: %1d ", raw.tag.stim_anti);
         memcpy(line + 7, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][7], raw.MatrixStrip[0][7+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][7], raw.MatrixStrip[1][7+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][7], raw.MatrixStrip[2][7+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][7], raw.MatrixStrip[3][7+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 7, (int) ' ', 14);
         sprintf(segmentValue, " stim_coin: %1d ", raw.tag.stim_coin);
         memcpy(line + 7, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][8], raw.MatrixStrip[0][8+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][8], raw.MatrixStrip[1][8+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][8], raw.MatrixStrip[2][8+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][8], raw.MatrixStrip[3][8+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 5, (int) ' ', 16);
         sprintf(segmentValue, " stim_offset: %1d ", raw.tag.stim_offset);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][9], raw.MatrixStrip[0][9+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][9], raw.MatrixStrip[1][9+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][9], raw.MatrixStrip[2][9+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][9], raw.MatrixStrip[3][9+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 10, (int) ' ', 11);
         sprintf(segmentValue, " hazard: %1d ", raw.tag.hazard);
         memcpy(line + 10, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][10], raw.MatrixStrip[0][10+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][10], raw.MatrixStrip[1][10+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][10], raw.MatrixStrip[2][10+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][10], raw.MatrixStrip[3][10+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 1, (int) ' ', 20);
         sprintf(segmentValue, " hydrogen_enable: %1d ", raw.tag.hydrogen_enable);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][11], raw.MatrixStrip[0][11+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][11], raw.MatrixStrip[1][11+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][11], raw.MatrixStrip[2][11+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][11], raw.MatrixStrip[3][11+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 3, (int) ' ', 18);
         sprintf(segmentValue, " helium_enable: %1d ", raw.tag.helium_enable);
         memcpy(line + 3, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][12], raw.MatrixStrip[0][12+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][12], raw.MatrixStrip[1][12+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][12], raw.MatrixStrip[2][12+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][12], raw.MatrixStrip[3][12+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 0, (int) ' ', 21);
         sprintf(segmentValue, " stop_acknowledge: %1d ", raw.tag.stop_acknowledge);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][13], raw.MatrixStrip[0][13+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][13], raw.MatrixStrip[1][13+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][13], raw.MatrixStrip[2][13+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][13], raw.MatrixStrip[3][13+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][14], raw.MatrixStrip[0][14+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][14], raw.MatrixStrip[1][14+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][14], raw.MatrixStrip[2][14+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][14], raw.MatrixStrip[3][14+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t1: %4d ", raw.StackPha[0]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][15], raw.MatrixStrip[0][15+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][15], raw.MatrixStrip[1][15+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][15], raw.MatrixStrip[2][15+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][15], raw.MatrixStrip[3][15+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t2: %4d ", raw.StackPha[1]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][16], raw.MatrixStrip[0][16+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][16], raw.MatrixStrip[1][16+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][16], raw.MatrixStrip[2][16+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][16], raw.MatrixStrip[3][16+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t3: %4d ", raw.StackPha[2]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][17], raw.MatrixStrip[0][17+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][17], raw.MatrixStrip[1][17+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][17], raw.MatrixStrip[2][17+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][17], raw.MatrixStrip[3][17+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[31]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t4: %4d ", raw.StackPha[3]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][18], raw.MatrixStrip[0][18+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][18], raw.MatrixStrip[1][18+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][18], raw.MatrixStrip[2][18+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][18], raw.MatrixStrip[3][18+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[32]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t5: %4d ", raw.StackPha[4]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][19], raw.MatrixStrip[0][19+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][19], raw.MatrixStrip[1][19+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][19], raw.MatrixStrip[2][19+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][19], raw.MatrixStrip[3][19+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[33]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t6: %4d ", raw.StackPha[5]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][20], raw.MatrixStrip[0][20+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][20], raw.MatrixStrip[1][20+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][20], raw.MatrixStrip[2][20+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][20], raw.MatrixStrip[3][20+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[34]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t7: %4d ", raw.StackPha[6]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][21], raw.MatrixStrip[0][21+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][21], raw.MatrixStrip[1][21+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][21], raw.MatrixStrip[2][21+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][21], raw.MatrixStrip[3][21+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[35]);
         memset(line + 11, (int) ' ', 10);
         sprintf(segmentValue, " t8: %4d ", raw.StackPha[7]);
         memcpy(line + 11, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][22], raw.MatrixStrip[0][22+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][22], raw.MatrixStrip[1][22+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][22], raw.MatrixStrip[2][22+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][22], raw.MatrixStrip[3][22+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[36]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][23], raw.MatrixStrip[0][23+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][23], raw.MatrixStrip[1][23+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][23], raw.MatrixStrip[2][23+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][23], raw.MatrixStrip[3][23+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[37]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][24], raw.MatrixStrip[0][24+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][24], raw.MatrixStrip[1][24+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][24], raw.MatrixStrip[2][24+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][24], raw.MatrixStrip[3][24+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[38]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][25], raw.MatrixStrip[0][25+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][25], raw.MatrixStrip[1][25+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][25], raw.MatrixStrip[2][25+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][25], raw.MatrixStrip[3][25+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[39]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][26], raw.MatrixStrip[0][26+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][26], raw.MatrixStrip[1][26+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][26], raw.MatrixStrip[2][26+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][26], raw.MatrixStrip[3][26+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[40]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][27], raw.MatrixStrip[0][27+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][27], raw.MatrixStrip[1][27+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][27], raw.MatrixStrip[2][27+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][27], raw.MatrixStrip[3][27+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[41]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][28], raw.MatrixStrip[0][28+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][28], raw.MatrixStrip[1][28+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][28], raw.MatrixStrip[2][28+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][28], raw.MatrixStrip[3][28+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[42]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][29], raw.MatrixStrip[0][29+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][29], raw.MatrixStrip[1][29+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][29], raw.MatrixStrip[2][29+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][29], raw.MatrixStrip[3][29+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[43]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][30], raw.MatrixStrip[0][30+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][30], raw.MatrixStrip[1][30+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][30], raw.MatrixStrip[2][30+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][30], raw.MatrixStrip[3][30+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[44]);
         memset(line + 30, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[0][31], raw.MatrixStrip[0][31+32]);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[1][31], raw.MatrixStrip[1][31+32]);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 54, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[2][31], raw.MatrixStrip[2][31+32]);
         memcpy(line + 54, segmentValue, strlen(segmentValue));
         memset(line + 66, (int) ' ', 10);
         sprintf(segmentValue, " %4d %4d", raw.MatrixStrip[3][31], raw.MatrixStrip[3][31+32]);
         memcpy(line + 66, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
