#ifndef DUMPL1_1SISSUMMARY_C
   #define DUMPL1_1SISSUMMARY_C

   /* $Id: dumpL1_1SisSummary.c,v 1.1 1998/07/27 12:18:42 rgr Exp $ */

   /* $RCSfile: dumpL1_1SisSummary.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:18:42 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "sis/L1_1SisSummary.h"
   #include "utilities/stringDate1996.h"

   void dumpL1_1SisSummary(struct L1_1SisSummary sum)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Summary <start time               >   <S/C Clock: xxxxxxxxxx>    <MJF: x xx>",
                          "Hskp:<data0  ><data4>                                            <Quality: xx>",
                          "",
                          "  <MainBusVoltage: xx.xxx>V   <InternalTemperature1: xxx.xx>DegC",
                          "      <SisCurrent: xx.xxx>A   <InternalTemperature2: xxx.xx>DegC",
                          "<SisCoverTelltale: xx>        <InterfaceTemperature: xxx.xx>DegC"};

      strcpy(line, template[0]);
         memset(line + 12, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(sum.Second1996), sum.microsecond);
         memcpy(line + 12, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", sum.ClockMinorFrame);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 69, (int) ' ', 11);
         sprintf(segmentValue, " MJF: %1d %2.2d ", sum.MajorFrameCount, sum.MinorFrameCount);
         memcpy(line + 69, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 5, (int) ' ', 9);
         sprintf(segmentValue, " %2.2x%2.2x%2.2x%2.2x", sum.SisHskp[0], sum.SisHskp[1], sum.SisHskp[2], sum.SisHskp[3]);
         memcpy(line + 5, segmentValue, strlen(segmentValue));
         memset(line + 14, (int) ' ', 7);
         sprintf(segmentValue, " %2.2x%2.2x  ", sum.SisHskp[4], sum.SisHskp[5]);
         memcpy(line + 14, segmentValue, strlen(segmentValue));
         memset(line + 65, (int) ' ', 13);
         sprintf(segmentValue, " Quality: %2.2x ", sum.quality);
         memcpy(line + 65, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 2, (int) ' ', 24);
         sprintf(segmentValue, " MainBusVoltage:%7.3f ", sum.MainBusVoltage);
         memcpy(line + 2, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InternalTemperature1:%7.3f ", sum.SisInternalTemperature1);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 6, (int) ' ', 20);
         sprintf(segmentValue, " SisCurrent:%7.3f ", sum.SisCurrent);
         memcpy(line + 6, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InternalTemperature2:%7.3f ", sum.SisInternalTemperature2);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 0, (int) ' ', 22);
         sprintf(segmentValue, " SisCoverTelltale: %2.2x ", sum.SisCoverTelltale);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 30, (int) ' ', 30);
         sprintf(segmentValue, " InterfaceTemperature:%7.3f ", sum.SisInterfaceTemperature);
         memcpy(line + 30, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
