/* $Id: computeSisEventBufferRates.c,v 1.1 1998/07/27 12:33:06 rgr Exp $ */

/* $RCSfile: computeSisEventBufferRates.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 12:33:06 $ */
/* $Revision: 1.1 $ */

#include "hdfi.h"
#include "SisConstants.h"

#include "sis/L1SisLowPriorityRate.h"
#include "sis/L1_1SisLowPriorityRate.h"

#include "sis/uncompressSisValue.h"

#define NBUF         NUM_SIS_EVT_BUFFERS
#define QUALITY_BIT  SIS_QUALITY_FILL_LEVEL1_BIT

void computeSisEventBufferRates(struct L1SisLowPriorityRate *lp,
                              struct L1_1SisLowPriorityRate *engr)
{
       int i;
    uint16 NumberEvents;
   float64 nevent;  

  for (i=0; i<NBUF; i++) {
   
     NumberEvents = lp->NumberEvents[i][0] + lp->NumberEvents[i][1] +
                    lp->NumberEvents[i][2] + lp->NumberEvents[i][3];
     nevent = (NumberEvents) ? (float64) NumberEvents : 1.0;
 
     engr->EventBufferRate[i] =
                     (uncompressSisValue(lp->EventBuffer[i])/nevent)
                                            * engr->DataBufferRate[i];
     engr->QualityEventBufferRate[i] = lp->QualityEventBuffer[i] |
                                       engr->QualityDataBufferRate[i];
     if ((!NumberEvents) && lp->EventBuffer[i])
        engr->QualityEventBufferRate[i] |= QUALITY_BIT;
   }
}

#undef NBUF
#undef QUALITY_BIT
