/* $Id: computeSisRejectRates.c,v 1.1 1998/07/27 12:33:11 rgr Exp $ */

/* $RCSfile: computeSisRejectRates.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 12:33:11 $ */
/* $Revision: 1.1 $ */

#include "hdfi.h"
#include "SisConstants.h"

#include "sis/L1SisLowPriorityRate.h"
#include "sis/L1_1SisLowPriorityRate.h"

#include "sis/uncompressSisValue.h"


void computeSisRejectRates(struct L1SisLowPriorityRate *lp,
                         struct L1_1SisLowPriorityRate *engr)
{
   float64 factor;
   float64 livetim;
   float64 nrtproc;
     uint8 quality;

   livetim = (float64) engr->livetim;
   if (livetim < 1.0e-6)
      livetim = 1.0e-6;
   nrtproc = (float64) engr->nrtproc;
   if (nrtproc < (1.0/NUM_SIS_MNFS_PER_CYCLE))
      nrtproc = 1.0/NUM_SIS_MNFS_PER_CYCLE;
   factor = ((float64) engr->nhdwrej) / (nrtproc * livetim);

   engr->RejectRate.m1a =
        (float32) (factor * uncompressSisValue(lp->RejcntsM1a));
   engr->RejectRate.m1ha =
        (float32) (factor * uncompressSisValue(lp->RejcntsM1ha));
   engr->RejectRate.m2a =
        (float32) (factor * uncompressSisValue(lp->RejcntsM2a));
   engr->RejectRate.m2ha =
        (float32) (factor * uncompressSisValue(lp->RejcntsM2ha));
   engr->RejectRate.t1a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT1a));
   engr->RejectRate.t2a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT2a));
   engr->RejectRate.t3a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT3a));
   engr->RejectRate.t4a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT4a));
   engr->RejectRate.t5a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT5a));
   engr->RejectRate.t6a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT6a));
   engr->RejectRate.t7a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT7a));
   engr->RejectRate.t8a =
        (float32) (factor * uncompressSisValue(lp->RejcntsT8a));
   engr->RejectRate.m12a =
        (float32) (factor * uncompressSisValue(lp->RejcntsM12a));
   engr->RejectRate.mora =
        (float32) (factor * uncompressSisValue(lp->RejcntsMora));
   engr->RejectRate.hora =
        (float32) (factor * uncompressSisValue(lp->RejcntsHora));
   engr->RejectRate.hiza =
        (float32) (factor * uncompressSisValue(lp->RejcntsHiza));

   engr->RejectRate.MaybeHiza =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeHiza));
   engr->RejectRate.z2a =
        (float32) (factor * uncompressSisValue(lp->RejcntsZ2a));
   engr->RejectRate.MaybeZ2a =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeZ2a));
   engr->RejectRate.MaybeZ1a =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeZ1a));
   engr->RejectRate.m1b =
        (float32) (factor * uncompressSisValue(lp->RejcntsM1b));
   engr->RejectRate.m1hb =
        (float32) (factor * uncompressSisValue(lp->RejcntsM1hb));
   engr->RejectRate.m2b =
        (float32) (factor * uncompressSisValue(lp->RejcntsM2b));
   engr->RejectRate.m2hb =
        (float32) (factor * uncompressSisValue(lp->RejcntsM2hb));
   engr->RejectRate.t1b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT1b));
   engr->RejectRate.t2b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT2b));
   engr->RejectRate.t3b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT3b));
   engr->RejectRate.t4b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT4b));
   engr->RejectRate.t5b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT5b));
   engr->RejectRate.t6b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT6b));
   engr->RejectRate.t7b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT7b));
   engr->RejectRate.t8b =
        (float32) (factor * uncompressSisValue(lp->RejcntsT8b));
   engr->RejectRate.m12b =
        (float32) (factor * uncompressSisValue(lp->RejcntsM12b));
   engr->RejectRate.morb =
        (float32) (factor * uncompressSisValue(lp->RejcntsMorb));
   engr->RejectRate.horb =
        (float32) (factor * uncompressSisValue(lp->RejcntsHorb));
   engr->RejectRate.hizb =
        (float32) (factor * uncompressSisValue(lp->RejcntsHizb));
   engr->RejectRate.MaybeHizb =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeHizb));
   engr->RejectRate.z2b =
        (float32) (factor * uncompressSisValue(lp->RejcntsZ2b));
   engr->RejectRate.MaybeZ2b =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeZ2b));
   engr->RejectRate.MaybeZ1b =
        (float32) (factor * uncompressSisValue(lp->RejcntsMaybeZ1b));
   engr->RejectRate.RejFast =
        (float32) (factor * uncompressSisValue(lp->RejcntsRejFast));
   engr->RejectRate.StimCoin =
        (float32) (factor * uncompressSisValue(lp->RejcntsStimCoin));
   engr->RejectRate.hazard =
        (float32) (factor * uncompressSisValue(lp->RejcntsHazard));
   engr->RejectRate.adc2a =
        (float32) (factor * uncompressSisValue(lp->RejcntsAdc2a));
   engr->RejectRate.adc3a =
        (float32) (factor * uncompressSisValue(lp->RejcntsAdc3a));
   engr->RejectRate.adc2b =
        (float32) (factor * uncompressSisValue(lp->RejcntsAdc2b));
   engr->RejectRate.adc3b =
        (float32) (factor * uncompressSisValue(lp->RejcntsAdc3b));
   engr->RejectRate.CoinRate0 =
        (float32) (factor * uncompressSisValue(lp->RejcntsCoinRate0));
   engr->RejectRate.CoinRate1 =
        (float32) (factor * uncompressSisValue(lp->RejcntsCoinRate1));

   quality = lp->QualityNhdwrej | lp->QualityNrtproc
                                | lp->QualityLivetim;

   engr->QualityRejectRate.m1a  = quality | lp->QualityRejcntsM1a;
   engr->QualityRejectRate.m1ha = quality | lp->QualityRejcntsM1ha;
   engr->QualityRejectRate.m2a  = quality | lp->QualityRejcntsM2a;
   engr->QualityRejectRate.m2ha = quality | lp->QualityRejcntsM2ha;
   engr->QualityRejectRate.t1a  = quality | lp->QualityRejcntsT1a;
   engr->QualityRejectRate.t2a  = quality | lp->QualityRejcntsT2a;
   engr->QualityRejectRate.t3a  = quality | lp->QualityRejcntsT3a;
   engr->QualityRejectRate.t4a  = quality | lp->QualityRejcntsT4a;
   engr->QualityRejectRate.t5a  = quality | lp->QualityRejcntsT5a;
   engr->QualityRejectRate.t6a  = quality | lp->QualityRejcntsT6a;
   engr->QualityRejectRate.t7a  = quality | lp->QualityRejcntsT7a;
   engr->QualityRejectRate.t8a  = quality | lp->QualityRejcntsT8a;
   engr->QualityRejectRate.m12a = quality | lp->QualityRejcntsM12a;
   engr->QualityRejectRate.mora = quality | lp->QualityRejcntsMora;
   engr->QualityRejectRate.hora = quality | lp->QualityRejcntsHora;
   engr->QualityRejectRate.hiza = quality | lp->QualityRejcntsHiza;
   engr->QualityRejectRate.MaybeHiza =
                                quality | lp->QualityRejcntsMaybeHiza;
   engr->QualityRejectRate.z2a  = quality | lp->QualityRejcntsZ2a;
   engr->QualityRejectRate.MaybeZ2a =
                                quality | lp->QualityRejcntsMaybeZ2a;
   engr->QualityRejectRate.MaybeZ1a  =
                                quality | lp->QualityRejcntsMaybeZ1a;
   engr->QualityRejectRate.m1b  = quality | lp->QualityRejcntsM1b;
   engr->QualityRejectRate.m1hb = quality | lp->QualityRejcntsM1hb;
   engr->QualityRejectRate.m2b  = quality | lp->QualityRejcntsM2b;
   engr->QualityRejectRate.m2hb = quality | lp->QualityRejcntsM2hb;
   engr->QualityRejectRate.t1b  = quality | lp->QualityRejcntsT1b;
   engr->QualityRejectRate.t2b  = quality | lp->QualityRejcntsT2b;
   engr->QualityRejectRate.t3b  = quality | lp->QualityRejcntsT3b;
   engr->QualityRejectRate.t4b  = quality | lp->QualityRejcntsT4b;
   engr->QualityRejectRate.t5b  = quality | lp->QualityRejcntsT5b;
   engr->QualityRejectRate.t6b  = quality | lp->QualityRejcntsT6b;
   engr->QualityRejectRate.t7b  = quality | lp->QualityRejcntsT7b;
   engr->QualityRejectRate.t8b  = quality | lp->QualityRejcntsT8b;
   engr->QualityRejectRate.m12b = quality | lp->QualityRejcntsM12b;
   engr->QualityRejectRate.morb = quality | lp->QualityRejcntsMorb;
   engr->QualityRejectRate.horb = quality | lp->QualityRejcntsHorb;
   engr->QualityRejectRate.hizb = quality | lp->QualityRejcntsHizb;
   engr->QualityRejectRate.MaybeHizb =
                                quality | lp->QualityRejcntsMaybeHizb;
   engr->QualityRejectRate.z2b  = quality | lp->QualityRejcntsZ2b;
   engr->QualityRejectRate.MaybeZ2b =
                                quality | lp->QualityRejcntsMaybeZ2b;
   engr->QualityRejectRate.MaybeZ1b =
                                quality | lp->QualityRejcntsMaybeZ1b;
   engr->QualityRejectRate.RejFast =
                                quality | lp->QualityRejcntsRejFast;
   engr->QualityRejectRate.StimCoin =
                                quality | lp->QualityRejcntsStimCoin;
   engr->QualityRejectRate.hazard = quality | lp->QualityRejcntsHazard;
   engr->QualityRejectRate.adc2a  = quality | lp->QualityRejcntsAdc2a;
   engr->QualityRejectRate.adc3a  = quality | lp->QualityRejcntsAdc3a;
   engr->QualityRejectRate.adc2b  = quality | lp->QualityRejcntsAdc2b;
   engr->QualityRejectRate.adc3b  = quality | lp->QualityRejcntsAdc3b;
   engr->QualityRejectRate.CoinRate0 =
                                quality | lp->QualityRejcntsCoinRate0;
   engr->QualityRejectRate.CoinRate1 =
                                quality | lp->QualityRejcntsCoinRate1;

}
