/* $Id: cvtSisAdcToMonitorValue.c,v 1.1 1998/07/27 12:33:18 rgr Exp $ */

/* $RCSfile: cvtSisAdcToMonitorValue.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 12:33:18 $ */
/* $Revision: 1.1 $ */

#include "hdfi.h"
#include "SisAdc.h"
#include "sis/sisGetData/cvtSisAdcToScaledVoltage.h"

float32 cvtSisAdcToMonitorValue(int AdcNumber, uint16 adc)
{
   static float64 MonScaleFactor[NUM_SIS_ADC];
   static int first = 1;

     int i;
   float64 ScaledVoltage;


   if (first) {
      first = 0;

      for (i=0; i<NUM_SIS_ADC; i++)
         MonScaleFactor[i] = 1.0;

      MonScaleFactor[SIS_ADC_MONITOR_P19V] = 1.0/4.011;
      MonScaleFactor[SIS_ADC_MONITOR_P13V] = 1.0/4.024;
      MonScaleFactor[SIS_ADC_MONITOR_M13V] = 1.0/4.024;
      MonScaleFactor[SIS_ADC_MONITOR_P5V]  = 1.0/4.013;
      MonScaleFactor[SIS_ADC_MONITOR_P4V]  = 1.0/4.013;
      MonScaleFactor[SIS_ADC_MONITOR_P7V]  = 1.0/4.013;
      MonScaleFactor[SIS_ADC_MONITOR_M7V]  = 1.0/4.013;

      MonScaleFactor[SIS_ADC_MONITOR_CURRENT_A] = 1.0;
      MonScaleFactor[SIS_ADC_MONITOR_CURRENT_B] = 1.0;
   }

   ScaledVoltage = (float64) cvtSisAdcToScaledVoltage(adc);
   return (float32) (ScaledVoltage / MonScaleFactor[AdcNumber]);
}
