/* $Id: expandSisHighPriorityRateDef.c,v 1.1 1998/08/03 13:21:19 rgr Exp $ */

/* $RCSfile: expandSisHighPriorityRateDef.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/08/03 13:21:19 $ */
/* $Revision: 1.1 $ */

/* This procedure expands a SIS high priority rate definition. */
/*                                                             */
/* Arguments                                                   */
/*   def = 32-bit SIS high priority rate definitions from      */
/*         command table-(input)                               */
/*   *definition = expanded SIS high priority rate             */
/*          definition-(output)                                */

#include "hdfi.h"
#include "sis/SisHighPriorityRateDefinition.h"

void expandSisHighPriorityRateDef(uint32 def,
    struct SisHighPriorityRateDefinition *definition)
{
   uint32 tmp;

   tmp = def;
   definition->Count1Index = (uint8) (tmp & 0x000000ff);
   tmp >>= 8;
   definition->Count2Index = (uint8) (tmp & 0x000000ff);
   tmp >>= 8;
   definition->LivetimeIndex = (uint8) (tmp & 0x00000007);
   tmp >>= 3;
   definition->EfficiencyIndex = (uint8) (tmp & 0x00000007);
   tmp >>= 3;
   definition->FlagCount2 = (uint8) (tmp & 0x00000001);
   tmp >>= 1;
   definition->FlagCalculated = (uint8) (tmp & 0x00000001);
   tmp >>= 1;
   definition->ScaleExp = (uint8) (tmp & 0x0000000f);
   tmp >>= 4;
   definition->FlagAb = (uint8) (tmp & 0x00000001);
}
