#ifndef GETGROUPLORATES_SE
   #define GETGROUPLORATES_SE

   /* $Id: getGroupLoRates_se.c,v 1.2 1998/08/03 13:24:50 rgr Exp $ */
   
   /* $RCSfile: getGroupLoRates_se.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/08/03 13:24:50 $ */
   /* $Revision: 1.2 $ */

   #include <stdlib.h>

   #include "hdfi.h"
   
   #include "sis/L1SisLowPriorityRate.h"
   #include "sis/L1_1SisLowPriorityRate.h"

   #include "sisGetData/getGroupLoRates_s.h"
   #include "sis/sisGetData/computeSisDataBufferRates.h"
   #include "sis/sisGetData/computeSisDataClassRates.h"
   #include "sis/sisGetData/computeSisEventBufferRates.h"
   #include "sis/sisGetData/computeSisMiscRates.h"
   #include "sis/sisGetData/computeSisRejectRates.h"
   #include "sis/sisGetData/computeSisSingleRates.h"
   #include "sis/sisGetData/computeSisValidRates.h"

   struct L1_1SisLowPriorityRate *getGroupLoRates_se(uint32 sec1996_0,
                                                     uint32 sec1996_1,
                                                     int autoFreeFlag)
   {
      static struct L1_1SisLowPriorityRate *allocatedMemory = NULL;

      struct L1_1SisLowPriorityRate *engr;
        struct L1SisLowPriorityRate *lp;
                             size_t nrec;
      struct L1_1SisLowPriorityRate *pointerEngr;
        struct L1SisLowPriorityRate *pointerLp;

      /* Do the automatic deallocation of memory.  When free is    */
      /* called with the address of a previously allocated memory  */
      /* block, free deallocates the memory block.  If the address */
      /* is NULL, free does nothing.                               */

      free(allocatedMemory);


      /* Find the number of structures and allocate and zero the */
      /* memory for them.                                        */

      pointerLp = getGroupLoRates_s(sec1996_0, sec1996_1, 0);
      lp = pointerLp;
      nrec = 0;
      while (lp->Second1996) {
         nrec++;
         lp++;
      }
      pointerEngr =
                calloc(nrec+1, sizeof(struct L1_1SisLowPriorityRate));



      /* Build an L1_1SisLowPriorityRate structure for each */
      /* L1SisLowPriorityRate structure present.            */

      lp = pointerLp;
      engr = pointerEngr;
      while (lp->Second1996) {
         engr->ClockCycle = lp->ClockCycle;
         engr->Second1996 = lp->Second1996;
         engr->microsecond = lp->microsecond;
      
         computeSisMiscRates(lp, engr);
         computeSisRejectRates(lp, engr);
         computeSisValidRates(lp, engr);
         computeSisSingleRates(engr);
         computeSisDataClassRates(lp, engr);
         computeSisDataBufferRates(engr);
         computeSisEventBufferRates(lp, engr);
      
         lp++;
         engr++;
      }

      free(pointerLp);


      /* Set the variable that controls the automatic deallocation */
      /* of the memory allocated.  If the user wants automatic     */
      /* deallocation of memory, set the variable equal to address */
      /* of the allocated memory; otherwise, set to NULL.          */

      allocatedMemory = autoFreeFlag ? pointerEngr : NULL;

      return pointerEngr;
   }

#endif
