/* $Id: scaleSisHighPriorityRate.c,v 1.1 1998/08/03 13:26:10 rgr Exp $ */

/* $RCSfile: scaleSisHighPriorityRate.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/08/03 13:26:10 $ */
/* $Revision: 1.1 $ */

/* This function generates and returns the scaling factor necessary */
/* to convert a SIS high priority rate to seconds (if a live time)  */
/* or counts/second.                                                */
/*                                                                  */
/* Arguments                                                        */
/*   def = 32-bit SIS high priority rate definition from the        */
/*         command table-(input)                                    */

#include "hdfi.h"

#include "SisConstants.h"
#include "SisRate.h"
#include "sis/SisHighPriorityRateDefinition.h"

#include "sis/sisGetData/expandSisHighPriorityRateDef.h"


float64 scaleSisHighPriorityRate(uint32 def)
{
   struct SisHighPriorityRateDefinition definition;
                                 uint32 factor;

   expandSisHighPriorityRateDef(def, &definition);
   factor = 0x00000001 << definition.ScaleExp;

   if ((definition.Count1Index == SIS_RATE_LIVETIM) ||
       (definition.Count1Index == SIS_RATE_HELIVET) ||
       (definition.Count1Index == SIS_RATE_HYLIVET)) 
      return (SIS_LIVETIME_UNIT_MICROSECOND * 1.0e-6)/factor;

   return 1.0 / (SIS_HIGH_PRIORITY_RATE_SAMPLE_PERIOD * factor);
}
