/* $Id: stringSisRate.c,v 1.2 1998/08/03 12:32:24 rgr Exp $ */

/* $RCSfile: stringSisRate.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/08/03 12:32:24 $ */
/* $Revision: 1.2 $ */

#include <stdio.h>

#include "hdfi.h"
#include "SisConstants.h"
#include "SisRate.h"

#define NBUF    NUM_SIS_EVT_BUFFERS
#define NCLASS  NUM_SIS_EVT_CLASSES
#define OFFSET  SIS_BUFFER_ID_OFFSET


char *stringSisRate(uint8 rate)
{
         uint8 buffer;
         uint8 class;
   static char stringRate[32];

   switch(rate) {
      case SIS_RATE_REJCNTS_M1A        : return "RejcntsM1a";
      case SIS_RATE_REJCNTS_M1HA       : return "RejcntsM1ha";
      case SIS_RATE_REJCNTS_M2A        : return "RejcntsM2a";
      case SIS_RATE_REJCNTS_M2HA       : return "RejcntsM2ha";
      case SIS_RATE_REJCNTS_T1A        : return "RejcntsT1a";
      case SIS_RATE_REJCNTS_T2A        : return "RejcntsT2a";
      case SIS_RATE_REJCNTS_T3A        : return "RejcntsT3a";
      case SIS_RATE_REJCNTS_T4A        : return "RejcntsT4a";
      case SIS_RATE_REJCNTS_T5A        : return "RejcntsT5a";
      case SIS_RATE_REJCNTS_T6A        : return "RejcntsT6a";
      case SIS_RATE_REJCNTS_T7A        : return "RejcntsT7a";
      case SIS_RATE_REJCNTS_T8A        : return "RejcntsT8a";
      case SIS_RATE_REJCNTS_M12A       : return "RejcntsM12a";
      case SIS_RATE_REJCNTS_MORA       : return "RejcntsMora";
      case SIS_RATE_REJCNTS_HORA       : return "RejcntsHora";
      case SIS_RATE_REJCNTS_HIZA       : return "RejcntsHiza";
      case SIS_RATE_REJCNTS_MAYBE_HIZA : return "RejcntsMaybeHiza";
      case SIS_RATE_REJCNTS_Z2A        : return "RejcntsZ2a";
      case SIS_RATE_REJCNTS_MAYBE_Z2A  : return "RejcntsMaybeZ2a";
      case SIS_RATE_REJCNTS_MAYBE_Z1A  : return "RejcntsMaybeZ1a";
      case SIS_RATE_REJCNTS_M1B        : return "RejcntsM1b";
      case SIS_RATE_REJCNTS_M1HB       : return "RejcntsM1hb";
      case SIS_RATE_REJCNTS_M2B        : return "RejcntsM2b";
      case SIS_RATE_REJCNTS_M2HB       : return "RejcntsM2hb";
      case SIS_RATE_REJCNTS_T1B        : return "RejcntsT1b";
      case SIS_RATE_REJCNTS_T2B        : return "RejcntsT2b";
      case SIS_RATE_REJCNTS_T3B        : return "RejcntsT3b";
      case SIS_RATE_REJCNTS_T4B        : return "RejcntsT4b";
      case SIS_RATE_REJCNTS_T5B        : return "RejcntsT5b";
      case SIS_RATE_REJCNTS_T6B        : return "RejcntsT6b";
      case SIS_RATE_REJCNTS_T7B        : return "RejcntsT7b";
      case SIS_RATE_REJCNTS_T8B        : return "RejcntsT8b";
      case SIS_RATE_REJCNTS_M12B       : return "RejcntsM12b";
      case SIS_RATE_REJCNTS_MORB       : return "RejcntsMorb";
      case SIS_RATE_REJCNTS_HORB       : return "RejcntsHorb";
      case SIS_RATE_REJCNTS_HIZB       : return "RejcntsHizb";
      case SIS_RATE_REJCNTS_MAYBE_HIZB : return "RejcntsMaybeHizb";
      case SIS_RATE_REJCNTS_Z2B        : return "RejcntsZ2b";
      case SIS_RATE_REJCNTS_MAYBE_Z2B  : return "RejcntsMaybeZ2b";
      case SIS_RATE_REJCNTS_MAYBE_Z1B  : return "RejcntsMaybeZ1b";
      case SIS_RATE_REJCNTS_REJ_FAST   : return "RejcntsRejfast";
      case SIS_RATE_REJCNTS_STIM_COIN  : return "RejcntsStimCoin";
      case SIS_RATE_REJCNTS_HAZARD     : return "RejcntsHazard";
      case SIS_RATE_REJCNTS_ADC2A      : return "RejcntsAdc2a";
      case SIS_RATE_REJCNTS_ADC3A      : return "RejcntsAdc3a";
      case SIS_RATE_REJCNTS_ADC2B      : return "RejcntsAdc2b";
      case SIS_RATE_REJCNTS_ADC3B      : return "RejcntsAdc3b";
      case SIS_RATE_REJCNTS_COIN_RATE0 : return "RejcntsCoinRate0";
      case SIS_RATE_REJCNTS_COIN_RATE1 : return "RejcntsCoinRate1";
      case SIS_RATE_VLDCNTS_M1A        : return "VldcntsM1a";
      case SIS_RATE_VLDCNTS_M1HA       : return "VldcntsM1ha";
      case SIS_RATE_VLDCNTS_M2A        : return "VldcntsM2a";
      case SIS_RATE_VLDCNTS_M2HA       : return "VldcntsM2ha";
      case SIS_RATE_VLDCNTS_T1A        : return "VldcntsT1a";
      case SIS_RATE_VLDCNTS_T2A        : return "VldcntsT2a";
      case SIS_RATE_VLDCNTS_T3A        : return "VldcntsT3a";
      case SIS_RATE_VLDCNTS_T4A        : return "VldcntsT4a";
      case SIS_RATE_VLDCNTS_T5A        : return "VldcntsT5a";
      case SIS_RATE_VLDCNTS_T6A        : return "VldcntsT6a";
      case SIS_RATE_VLDCNTS_T7A        : return "VldcntsT7a";
      case SIS_RATE_VLDCNTS_T8A        : return "VldcntsT8a";
      case SIS_RATE_VLDCNTS_M12A       : return "VldcntsM12a";
      case SIS_RATE_VLDCNTS_MORA       : return "VldcntsMora";
      case SIS_RATE_VLDCNTS_HORA       : return "VldcntsHora";
      case SIS_RATE_VLDCNTS_HIZA       : return "VldcntsHiza";
      case SIS_RATE_VLDCNTS_MAYBE_HIZA : return "VldcntsMaybeHiza";
      case SIS_RATE_VLDCNTS_Z2A        : return "VldcntsZ2a";
      case SIS_RATE_VLDCNTS_MAYBE_Z2A  : return "VldcntsMaybeZ2a";
      case SIS_RATE_VLDCNTS_MAYBE_Z1A  : return "VldcntsMaybeZ1a";
      case SIS_RATE_VLDCNTS_M1B        : return "VldcntsM1b";
      case SIS_RATE_VLDCNTS_M1HB       : return "VldcntsM1hb";
      case SIS_RATE_VLDCNTS_M2B        : return "VldcntsM2b";
      case SIS_RATE_VLDCNTS_M2HB       : return "VldcntsM2hb";
      case SIS_RATE_VLDCNTS_T1B        : return "VldcntsT1b";
      case SIS_RATE_VLDCNTS_T2B        : return "VldcntsT2b";
      case SIS_RATE_VLDCNTS_T3B        : return "VldcntsT3b";
      case SIS_RATE_VLDCNTS_T4B        : return "VldcntsT4b";
      case SIS_RATE_VLDCNTS_T5B        : return "VldcntsT5b";
      case SIS_RATE_VLDCNTS_T6B        : return "VldcntsT6b";
      case SIS_RATE_VLDCNTS_T7B        : return "VldcntsT7b";
      case SIS_RATE_VLDCNTS_T8B        : return "VldcntsT8b";
      case SIS_RATE_VLDCNTS_M12B       : return "VldcntsM12b";
      case SIS_RATE_VLDCNTS_MORB       : return "VldcntsMorb";
      case SIS_RATE_VLDCNTS_HORB       : return "VldcntsHorb";
      case SIS_RATE_VLDCNTS_HIZB       : return "VldcntsHizb";
      case SIS_RATE_VLDCNTS_MAYBE_HIZB : return "VldcntsMaybeHizb";
      case SIS_RATE_VLDCNTS_Z2B        : return "VldcntsZ2b";
      case SIS_RATE_VLDCNTS_MAYBE_Z2B  : return "VldcntsMaybeZ2b";
      case SIS_RATE_VLDCNTS_MAYBE_Z1B  : return "VldcntsMaybeZ1b";
      case SIS_RATE_VLDCNTS_REJ_FAST   : return "VldcntsRejFast";
      case SIS_RATE_VLDCNTS_STIM_COIN  : return "VldcntsStimCoin";
      case SIS_RATE_VLDCNTS_HAZARD     : return "VldcntsHazard";
      case SIS_RATE_VLDCNTS_ADC2A      : return "VldcntsAdc2a";
      case SIS_RATE_VLDCNTS_ADC3A      : return "VldcntsAdc3a";
      case SIS_RATE_VLDCNTS_ADC2B      : return "VldcntsAdc2b";
      case SIS_RATE_VLDCNTS_ADC3B      : return "VldcntsAdc3b";
      case SIS_RATE_VLDCNTS_COIN_RATE0 : return "VldcntsCoinRate0";
      case SIS_RATE_VLDCNTS_COIN_RATE1 : return "VldcntsCoinRate1";
      case SIS_RATE_LIVETIM            : return "livetim";
      case SIS_RATE_HELIVET            : return "helivet";
      case SIS_RATE_HYLIVET            : return "hylivet";
      case SIS_RATE_NTAGINT            : return "ntagint";
      case SIS_RATE_NVLDINT            : return "nvldint";
      case SIS_RATE_NEVPROC            : return "nevproc";
      case SIS_RATE_NRTPROC            : return "nrtproc";
      case SIS_RATE_NBADID             : return "nbadid";
      case SIS_RATE_NCEBFUL            : return "ncebful";
      case SIS_RATE_NREBFUL            : return "nrebful";
      case SIS_RATE_NHDWREJ            : return "nhdwrej";
      
      default : 
         if ((SIS_RATE_EVENT_BUFFER <= rate) &&
             (rate < (SIS_RATE_EVENT_BUFFER + NBUF))) {
            buffer = rate - (uint8) SIS_RATE_EVENT_BUFFER;
            sprintf(stringRate, "buffer[%u]", buffer + OFFSET);
            return stringRate;
         }
         if ((SIS_RATE_CLASACC <= rate) &&
             (rate < (SIS_RATE_CLASACC + NCLASS))) {
            class = rate - (uint8) SIS_RATE_CLASACC;
            sprintf(stringRate, "clasacc[%u]", class);
            return stringRate;
         }
         if ((SIS_RATE_CLASTOT <= rate) &&
             (rate < (SIS_RATE_CLASTOT + NCLASS))) {
            class = rate - (uint8) SIS_RATE_CLASTOT;
            sprintf(stringRate, "clastot[%u]", class);
            return stringRate;
         }
         return "";
   }
}

#undef NBUF
#undef NCLASS
#undef OFFSET
