#ifndef FIND_DUMP_LINE_C
   #define FIND_DUMP_LINE_C
   
   /* $Id: findDumpLine.c,v 1.1 1998/05/04 17:58:22 rgr Exp $ */

   /* $RCSfile: findDumpLine.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/05/04 17:58:22 $ */
   /* $Revision: 1.1 $ */

   /* This fuction searches the contents of the template file for    */
   /* the first occurence of a pattern.  When the pattern is found,  */
   /* the function returns the line number of the template file in   */
   /* which it was found.  If the pattern is not found, the          */
   /* function returns -1.  The number system for the lines begins   */
   /* with 0.                                                        */
   /*                                                                */
   /* The search is case-insensitive.                                */
   /*                                                                */
   /*  Arguments                                                     */
   /*     nline = number of lines stored in the template             */
   /*             array-(input)                                      */
   /*     line = contents of template file stored in a string        */
   /*            array-(input)                                       */
   /*     pattern = pattern to locate-(input)                        */

   #include <string.h>

   int findDumpLine(int nline, char line[][256], char *pattern)
   {
      int i;
      int j;
      int length;
      char pat[256];
      char tmp[256];

   
      length = strlen(pattern);
      if (!length) return -1;
      strcpy(pat, pattern);
      for (i=0; i<length; i++)
         if (('A' <= pat[i]) && (pat[i] <= 'Z')) pat[i] += 0x20;

      for (i=0; i<nline; i++) {
         length = strlen(line[i]);
         strcpy(tmp, line[i]);
         for (j=0; j<length; j++)
            if (('A' <= tmp[j]) && (tmp[j] <= 'Z')) tmp[j] += 0x20;
         if (strstr(tmp, pat)) return i;
      }
      return -1;
   }

#endif
