/* $Id: L1SisPigeonHole.c,v 1.4 1998/05/18 22:43:40 rgr Exp $ */

/* $RCSfile: L1SisPigeonHole.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/05/18 22:43:40 $ */
/* $Revision: 1.4 $ */


#include <stdio.h>
#include <string.h>

#include "mfhdf.h"
#include "df.h"

#include "aosr.h"
#include "ccr.h"

#include "cris.h"
#include "sis.h"

#include "asc/prototype.h"
#include "sisPutData.h"

int main(argc, argv)
int argc;
char *argv[];
{
  int32 hdf_fp, sd_id;
  struct L1SisCommandEcho echo_s;
  struct L1SisCommandTable ct_s;
  struct L1SisEventCycle evt_s;
  struct L1SisHighPriorityRate hp_s[1001];
  struct L1SisHskp hskp_s;
  struct L1SisLowPriorityRate lp_s;
  struct L1SisSubset sub_s[1001];
  struct L1SisSummary sum_s[1001];
  struct L1SisDacOffset0 dac0;
  struct L1SisDacOffset1 dac1;
  struct L1SisDiagnosticEvent diag_s;

  int ii,retval;

  if (argc!=2)
    {
      printf("Usage: rd_hdf hdf_file\n");
      exit(1);
    }

  /* open hdf input file */

  if ((hdf_fp=Hopen(argv[1], DFACC_RDONLY, 0))==FAIL)
    {
      fprintf(stderr, "Hopen: could not open hdf file\n");
      exit(-1);
    }
  Vstart(hdf_fp);

if ((sd_id=SDstart(argv[1], DFACC_RDONLY))==FAIL)
    {
      fprintf(stderr, "SDstart: could not open hdf file\n");
      exit(-1);
    }
  printf("\n");


  ii = 0;
  if (init_rd_L1SisCommandEcho(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisCommandEcho(&echo_s,ii))!=FAIL) {
        putSisCommandEcho(&echo_s);
        ii++;
     }
  }
  printf("Number of SIS command echoes written: %d\n", ii);


  ii = 0;
  if (init_rd_L1SisCommandTable(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisCommandTable(&ct_s,ii))!=FAIL) {
        putSisCommandTable(&ct_s);
        ii++;
     }
  }
  printf("Number of SIS command tables written: %d\n", ii);


  ii = 0;
  if (init_rd_L1SisEventCycle(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisEventCycle(&evt_s,ii))!=FAIL) {
        putSisEvents(&evt_s);
        ii++;
     }
  }
  printf("Number of SIS event cycles written: %d\n", ii);


  ii = 0;
  if (init_rd_L1SisHighPriorityRate(hdf_fp, sd_id, "r")) {
     while((retval=
           read_L1SisHighPriorityRate(hp_s+(ii % 1000),ii))!=FAIL) {
        ii++;
        if (!(ii % 1000)) {
           hp_s[1000].ClockMinorFrame = 0;
           hp_s[1000].Second1996 = 0;
           hp_s[1000].microsecond = 0;
           putSisHighPriorityRatesGroup(hp_s);
        }
     }
     if (ii % 1000) {
        hp_s[ii % 1000].ClockMinorFrame = 0;
        hp_s[ii % 1000].Second1996 = 0;
        hp_s[ii % 1000].microsecond = 0;
        putSisHighPriorityRatesGroup(hp_s);
     }
  }
  printf("Number of SIS high priority rate records written: %d\n", ii);

  ii = 0;
  if (init_rd_L1SisHskp(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisHskp(&hskp_s,ii))!=FAIL) {
        putSisHskp(&hskp_s);
        ii++;
     }
  }
  printf("Number of SIS hskp records written: %d\n", ii);

  
  ii = 0;
  if (init_rd_L1SisLowPriorityRate(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisLowPriorityRate(&lp_s,ii))!=FAIL) {
        putSisLowPriorityRates(&lp_s);
        ii++;
     }
  }
  printf("Number of SIS low priority rate records written: %d\n", ii);


  ii = 0;
  if (init_rd_L1SisSubset(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisSubset(sub_s+(ii % 1000),ii))!=FAIL) {
        ii++;
        if (!(ii % 1000)) {
           sub_s[1000].ClockMinorFrame = 0;
           sub_s[1000].Second1996 = 0;
           sub_s[1000].microsecond = 0;
           putSisSubsetGroup(sub_s);
        }
     }
     if (ii % 1000) {
        sub_s[ii % 1000].ClockMinorFrame = 0;
        sub_s[ii % 1000].Second1996 = 0;
        sub_s[ii % 1000].microsecond = 0;
        putSisSubsetGroup(sub_s);
     }
  }
  printf("Number of SIS subsets written: %d\n", ii);

  
  ii = 0;
  if (init_rd_L1SisSummary(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisSummary(sum_s+(ii % 1000),ii))!=FAIL) {
        ii++;
        if (!(ii % 1000)) {
           sum_s[1000].ClockMinorFrame = 0;
           sum_s[1000].Second1996 = 0;
           sum_s[1000].microsecond = 0;
           putSisSummaryGroup(sum_s);
        }
     }
     if (ii % 1000) {
        sum_s[(ii) % 1000].ClockMinorFrame = 0;
        sum_s[(ii) % 1000].Second1996 = 0;
        sum_s[ii % 1000].microsecond = 0;
        putSisSummaryGroup(sum_s);
     }
  }
  printf("Number of SIS summaries written: %d\n", ii);

  
  ii = 0;
  if (init_rd_L1SisDacOffset0(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisDacOffset0(&dac0,ii))!=FAIL) {
        putSisDacOffset0(&dac0);
        ii++;
     }
  }
  printf("Number of DacOffset0 structures written: %d\n", ii);

  
  ii = 0;
  if (init_rd_L1SisDacOffset1(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisDacOffset1(&dac1,ii))!=FAIL) {
        putSisDacOffset1(&dac1);
        ii++;
     }
  }
  printf("Number of DacOffset1 structures written: %d\n", ii);

  
  ii = 0;
  if (init_rd_L1SisDiagnosticEvent(hdf_fp, sd_id, "r")) {
     while((retval= read_L1SisDiagnosticEvent(&diag_s,ii))!=FAIL) {
        putSisDiagnosticEvent(&diag_s);
        ii++;
     }
  }

  printf("Number of SIS diagnostic events written: %d\n", ii);

  printf("\n");

  /* all done, close HDF file */

  close_rd_L1SisCommandEcho();
  close_rd_L1SisCommandTable();
  close_rd_L1SisEventCycle();
  close_rd_L1SisHighPriorityRate();
  close_rd_L1SisHskp();
  close_rd_L1SisLowPriorityRate();
  close_rd_L1SisSubset();
  close_rd_L1SisSummary();
  close_rd_L1SisDacOffset0();
  close_rd_L1SisDacOffset1();
  close_rd_L1SisDiagnosticEvent();

  Vend(hdf_fp);
  if (SDend(sd_id)==FAIL)
    {
      fprintf(stderr, "SDend: could not close hdf file\n");
      exit(-1);
    }
  if (Hclose(hdf_fp)==FAIL)
    {
      fprintf(stderr, "Hclose: could not close hdf file\n");
      exit(-1);
    }

  exit(0);
}
