/* $Id: printL1SisSubsetHskp.c,v 1.1 1998/07/27 11:04:35 rgr Exp $ */

/* $RCSfile: printL1SisSubsetHskp.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/07/27 11:04:35 $ */
/* $Revision: 1.1 $ */

/* This program prints dumps of the housekeeping portion of the   */
/* L1SisSubset structures found between the start and stop times. */
/*                                                                */
/* Arguments                                                      */
/*    argv[1] = start day expressed as YYMMDD                     */
/*    argv[2] = start time-of-day expressed as HHMMSS             */
/*    argv[3] = stop day expressed as YYMM DD                     */
/*    argv[4] = stop time-of-day expressed as HHMMSS              */


#include <stdio.h>
#include <stdlib.h>

#include "hdfi.h"
#include "sis/L1SisSubset.h"

#include "utilities/cvtToSec1996_ymd_hms.h"
#include "sisGetData/getGroupSubsets_s.h"
#include "sis/dumpL1SisSubsetHskp.h"

int main(argc, argv)
int argc;
char *argv[];
{
                 long hms;
   struct L1SisSubset *sub;
               uint32 t0;
               uint32 t1;
                 long ymd;

   ymd = atol(argv[1]);
   hms = atol(argv[2]);
   t0 = cvtToSec1996_ymd_hms(ymd, hms);
   ymd = atol(argv[3]);
   hms = atol(argv[4]);
   t1 = cvtToSec1996_ymd_hms(ymd, hms);

   sub = getGroupSubsets_s(t0, t1, 1);
   while(sub->Second1996) {
      dumpL1SisSubsetHskp(*sub);
      sub++;
   }
   exit(0);
}
