#ifndef DUMPL1SISCOMMANDTABLE_C
   #define DUMPL1SISCOMMANDTABLE_C

   /* $Id: dumpL1SisCommandTable.c,v 1.1 1998/07/27 12:08:30 rgr Exp $ */

   /* $RCSfile: dumpL1SisCommandTable.c,v $ */
   /* $Author: rgr $ */
   /* $Date: 1998/07/27 12:08:30 $ */
   /* $Revision: 1.1 $ */


   #include <memory.h>
   #include <stdio.h>
   #include <sys/types.h>
   
   #include "sis/L1SisCommandTable.h"
   #include "ace/expandUint16.h"
   #include "utilities/stringDate1996.h"

   void dumpL1SisCommandTable(struct L1SisCommandTable ct)
   {
      char line[256];
      char segmentValue[256];
      char *template[] = {"SIS Command Table - <start time               >   <S/C Clock: xxxxxxxxxx>",
                          "                    <stop time                >   <S/C Clock: yyyyyyyyyy>",
                          "<No. echoes: xxxxx>",
                          "                                                              <hyflg: xxxxx xx>",
                          "<coinmsk: xxxxx xx> <scycflg: xxxxx xx>  <rnglim: xxxxx xx>  <hetlim: xxxxx xx>",
                          " <stbfon: xxxxx xx> <mtarget: xxxxx xx> <audgflg: xxxxx xx>  <hytlim: xxxxx xx>",
                          "<leakint: xxxxx xx>  <mscale: xxxxx xx> <audglim: xxxxx xx>  <stmask: xxxxx xx>",
                          "<oadjflg: xxxxx xx> <aulkflg: xxxxx xx> <samplim: xxxxx xx> <stimeid: xxxxx xx>",
                          "<vrefflg: xxxxx xx>  <ttpflg: xxxxx xx>   <heflg: xxxxx xx> <nbadstp: xxxxx xx>",
                          "",
                          "hkbltim:<a0{0}  ><a0{1}  >",
                          "mbounds:<b0{0}  ><b0{1}  >",
                          "   mnav:<c0{0}  ><c0{1}  >",
                          "claslim:<d0{0}  ><d0{1}  >",
                          "  htcmd:<e0{0}  ><e0{1}  ><e0{2}  ><e0{3}  >",
                          "   ecmd:<f0{0}  ><f0{1}  >",
                          "hiprcmd:<g0{0}  ><g0{1}  ><g0{2}  ><g0{3}  ><g0{4}  ><g0{5}  ><g0{6}  ><g0{7}  >",
                          "  (hex) <g0{8}  ><g0{9}  ><g0{10} ><g0{11} ><g0{12} ><g0{13} ><g0{14} ><g0{15} >",
                          "        <g0{16} ><g0{17} ><g0{18} ><g0{19} ><g0{20} ><g0{21} ><g0{22} ><g0{23} >",
                          "        <g0{24} ><g0{25} ><g0{26} ><g0{27} ><g0{28} ><g0{29} ><g0{30} ><g0{31} >",
                          "        <g0{32} ><g0{33} ><g0{34} ><g0{35} >",
                          "sdacval:<h0{0}  ><h0{1}  ><h0{2}  ><h0{3}  ><h0{4}  ><h0{5}  ><h0{6}  ><h0{7}  >",
                          "        <h0{8}  ><h0{9}  ><h0{10} ><h0{11} ><h0{12} ><h0{13} ><h0{14} ><h0{15} >",
                          "        <h0{16} ><h0{17} ><h0{18} ><h0{19} ><h0{20} ><h0{21} ><h0{22} ><h0{23} >",
                          "        <h0{24} ><h0{25} >",
                          "sdacsiz:<i0{0}  ><i0{1}  ><i0{2}  ><i0{3}  ><i0{4}  ><i0{5}  ><i0{6}  ><i0{7}  >",
                          "        <i0{8}  ><i0{9}  ><i0{10} ><i0{11} ><i0{12} ><i0{13} ><i0{14} ><i0{15} >",
                          "        <i0{16} ><i0{17} ><i0{18} ><i0{19} ><i0{20} ><i0{21} ><i0{22} ><i0{23} >",
                          "        <i0{24} ><i0{25} >",
                          "dacval0:<j0{0}  ><j0{1}  ><j0{2}  ><j0{3}  ><j0{4}  ><j0{5}  ><j0{6}  ><j0{7}  >",
                          "  (hex) <j0{8}  ><j0{9}  ><j0{10} ><j0{11} ><j0{12} ><j0{13} ><j0{14} ><j0{15} >",
                          "        <j0{16} ><j0{17} ><j0{18} ><j0{19} ><j0{20} ><j0{21} ><j0{22} ><j0{23} >",
                          "        <j0{24} ><j0{25} ><j0{26} ><j0{27} ><j0{28} ><j0{29} ><j0{30} ><j0{31} >",
                          "        <j0{32} ><j0{33} ><j0{34} ><j0{35} ><j0{36} ><j0{37} ><j0{38} ><j0{39} >",
                          "        <j0{40} ><j0{41} >",
                          "dacsiz0:<k0{0}  ><k0{1}  ><k0{2}  ><k0{3}  ><k0{4}  ><k0{5}  ><k0{6}  ><k0{7}  >",
                          "        <k0{8}  ><k0{9}  ><k0{10} ><k0{11} ><k0{12} ><k0{13} ><k0{14} ><k0{15} >",
                          "        <k0{16} ><k0{17} ><k0{18} ><k0{19} ><k0{20} ><k0{21} ><k0{22} ><k0{23} >",
                          "        <k0{24} ><k0{25} ><k0{26} ><k0{27} ><k0{28} ><k0{29} ><k0{30} ><k0{31} >",
                          "        <k0{32} ><k0{33} ><k0{34} ><k0{35} ><k0{36} ><k0{37} ><k0{38} ><k0{39} >",
                          "        <k0{40} ><k0{41} >",
                          "dacval1:<l0{0}  ><l0{1}  ><l0{2}  ><l0{3}  ><l0{4}  ><l0{5}  > (hex)",
                          "dacsiz1:<m0{0}  ><m0{1}  ><m0{2}  ><m0{3}  ><m0{4}  ><m0{5}  >",
                          " hdisc2:<n0{0}  ><n0{1}  ><n0{2}  ><n0{3}  ><n0{4}  ><n0{5}  ><n0{6}  ><n0{7}  >",
                          " hdisc0:<o0{0}  ><o0{1}  ><o0{2}  ><o0{3}  ><o0{4}  ><o0{5}  ><o0{6}  ><o0{7}  >",
                          " mdisc2:<p0{0}  ><p0{1}  ><p0{2}  ><p0{3}  ><p0{4}  ><p0{5}  ><p0{6}  ><p0{7}  >",
                          " mdisc0:<q0{0}  ><q0{1}  ><q0{2}  ><q0{3}  ><q0{4}  ><q0{5}  ><q0{6}  ><q0{7}  >",
                          "  adcen:<r0{0}  ><r0{1}  ><r0{2}  ><r0{3}  ><r0{4}  ><r0{5}  ><r0{6}  ><r0{7}  >",
                          "gdiscen:<s0{0}  ><s0{1}  ><s0{2}  ><s0{3}  ><s0{4}  ><s0{5}  ><s0{6}  ><s0{7}  >",
                          "mdiscen:<t0{0}  ><t0{1}  ><t0{2}  ><t0{3}  ><t0{4}  ><t0{5}  ><t0{6}  ><t0{7}  >",
                          "hdiscen:<u0{0}  ><u0{1}  ><u0{2}  ><u0{3}  ><u0{4}  ><u0{5}  ><u0{6}  ><u0{7}  >",
                          "dirbits:<v0{0}  ><v0{1}  ><v0{2}  ><v0{3}  ><v0{4}  ><v0{5}  ><v0{6}  ><v0{7}  >",
                          "  (hex) <v0{8}  ><v0{9}  ><v0{10} ><v0{11} ><v0{12} ><v0{13} ><v0{14} ><v0{15} >",
                          "        <v0{16} ><v0{17} ><v0{18} ><v0{19} ><v0{20} ><v0{21} ><v0{22} ><v0{23} >",
                          "        <v0{24} ><v0{25} ><v0{26} ><v0{27} ><v0{28} ><v0{29} ><v0{30} ><v0{31} >",
                          "  calen:<w0{0}  ><w0{1}  ><w0{2}  ><w0{3}  ><w0{4}  ><w0{5}  ><w0{6}  ><w0{7}  >",
                          "  (hex) <w0{8}  ><w0{9}  ><w0{10} ><w0{11} ><w0{12} ><w0{13} ><w0{14} ><w0{15} >",
                          "        <w0{16} ><w0{17} ><w0{18} ><w0{19} ><w0{20} ><w0{21} ><w0{22} ><w0{23} >",
                          "        <w0{24} ><w0{25} ><w0{26} ><w0{27} ><w0{28} ><w0{29} ><w0{30} ><w0{31} >",
                          "        <w0{32} ><w0{33} ><w0{34} ><w0{35} ><w0{36} ><w0{37} ><w0{38} ><w0{39} >",
                          "        <w0{40} ><w0{41} ><w0{42} ><w0{43} ><w0{44} ><w0{45} ><w0{46} ><w0{47} >",
                          "        <w0{48} ><w0{49} ><w0{50} ><w0{51} ><w0{52} ><w0{53} ><w0{54} ><w0{55} >",
                          "        <w0{56} ><w0{57} ><w0{58} ><w0{59} ><w0{60} ><w0{61} ><w0{62} ><w0{63} >",
                          " compen:<x0{0}  ><x0{1}  ><x0{2}  ><x0{3}  ><x0{4}  ><x0{5}  ><x0{6}  ><x0{7}  >",
                          "        <x0{8}  ><x0{9}  ><x0{10} ><x0{11} ><x0{12} ><x0{13} ><x0{14} ><x0{15} >",
                          "        <x0{16} ><x0{17} ><x0{18} ><x0{19} ><x0{20} ><x0{21} ><x0{22} ><x0{23} >",
                          "        <x0{24} ><x0{25} ><x0{26} ><x0{27} ><x0{28} ><x0{29} ><x0{30} ><x0{31} >",
                          "        <x0{32} ><x0{33} ><x0{34} ><x0{35} ><x0{36} ><x0{37} ><x0{38} ><x0{39} >",
                          "        <x0{40} ><x0{41} ><x0{42} ><x0{43} ><x0{44} ><x0{45} ><x0{46} ><x0{47} >",
                          "        <x0{48} ><x0{49} ><x0{50} ><x0{51} ><x0{52} ><x0{53} ><x0{54} ><x0{55} >",
                          "        <x0{56} ><x0{57} ><x0{58} ><x0{59} ><x0{60} ><x0{61} ><x0{62} ><x0{63} >",
                          "clasmap:<y0{0}  ><y0{1}  ><y0{2}  ><y0{3}  ><y0{4}  ><y0{5}  ><y0{6}  ><y0{7}  >",
                          "  (hex) <y0{8}  ><y0{9}  ><y0{10} ><y0{11} ><y0{12} ><y0{13} ><y0{14} ><y0{15} >",
                          "        <y0{16} ><y0{17} ><y0{18} ><y0{19} ><y0{20} ><y0{21} ><y0{22} ><y0{23} >",
                          "        <y0{24} ><y0{25} ><y0{26} ><y0{27} ><y0{28} ><y0{29} ><y0{30} ><y0{31} >",
                          "imthrsh:<z0{0}  ><z0{1}  ><z0{2}  ><z0{3}  >",
                          " imflag:<a1{0}  ><a1{1}  >",
                          " im0arr:<b1{0}  ><b1{1}  ><b1{2}  ><b1{3}  ><b1{4}  ><b1{5}  ><b1{6}  ><b1{7}  >",
                          "        <b1{8}  ><b1{9}  ><b1{10} ><b1{11} ><b1{12} ><b1{13} ><b1{14} ><b1{15} >",
                          "        <b1{16} ><b1{17} ><b1{18} ><b1{19} >",
                          " im1arr:<c1{0}  ><c1{1}  ><c1{2}  ><c1{3}  ><c1{4}  ><c1{5}  ><c1{6}  ><c1{7}  >",
                          "        <c1{8}  ><c1{9}  ><c1{10} ><c1{11} ><c1{12} ><c1{13} ><c1{14} ><c1{15} >",
                          "        <c1{16} ><c1{17} ><c1{18} ><c1{19} >",
                          "strplim:<d1{0}  ><d1{1}  ><d1{2}  ><d1{3}  >",
                          "mcntlim:<e1{0}  ><e1{1}  ><e1{2}  ><e1{3}  >",
                          " anglim:<f1{0}  ><f1{1}  >",
                          "  cnoc1:<g1{0}  ><g1{1}  ><g1{2}  ><g1{3}  ><g1{4}  ><g1{5}  ><g1{6}  ><g1{7}  >",
                          "  cnoc2:<h1{0}  ><h1{1}  ><h1{2}  ><h1{3}  ><h1{4}  ><h1{5}  ><h1{6}  ><h1{7}  >",
                          " eidmap:<i1{0}  ><i1{1}  ><i1{2}  ><i1{3}  ><i1{4}  ><i1{5}  ><i1{6}  ><i1{7}  >",
                          "        <i1{8}  ><i1{9}  ><i1{10} ><i1{11} ><i1{12} ><i1{13} ><i1{14} ><i1{15} >",
                          "        <i1{16} ><i1{17} ><i1{18} ><i1{19} ><i1{20} ><i1{21} ><i1{22} ><i1{23} >",
                          "        <i1{24} ><i1{25} ><i1{26} ><i1{27} ><i1{28} ><i1{29} ><i1{30} ><i1{31} >",
                          "        <i1{32} ><i1{33} ><i1{34} ><i1{35} ><i1{36} ><i1{37} ><i1{38} ><i1{39} >",
                          "        <i1{40} ><i1{41} ><i1{42} ><i1{43} ><i1{44} ><i1{45} ><i1{46} ><i1{47} >",
                          "        <i1{48} ><i1{49} ><i1{50} ><i1{51} ><i1{52} ><i1{53} ><i1{54} ><i1{55} >",
                          "        <i1{56} ><i1{57} ><i1{58} ><i1{59} ><i1{60} ><i1{61} ><i1{62} ><i1{63} >",
                          "        <i1{64} ><i1{65} ><i1{66} ><i1{67} ><i1{68} ><i1{69} ><i1{70} ><i1{71} >",
                          "        <i1{72} ><i1{73} ><i1{74} ><i1{75} ><i1{76} ><i1{77} ><i1{78} ><i1{79} >",
                          "        <i1{80} ><i1{81} ><i1{82} ><i1{83} ><i1{84} ><i1{85} ><i1{86} ><i1{87} >",
                          "        <i1{88} ><i1{89} ><i1{90} ><i1{91} ><i1{92} ><i1{93} ><i1{94} ><i1{95} >",
                          "        <i1{96} ><i1{97} ><i1{98} ><i1{99} ><i1{100}><i1{101}><i1{102}><i1{103}>",
                          "        <i1{104}><i1{105}><i1{106}><i1{107}><i1{108}><i1{109}><i1{110}><i1{111}>",
                          "        <i1{112}><i1{113}><i1{114}><i1{115}><i1{116}><i1{117}><i1{118}><i1{119}>",
                          "        <i1{120}><i1{121}><i1{122}><i1{123}><i1{124}><i1{125}><i1{126}><i1{127}>",
                          "        <i1{128}><i1{129}><i1{130}><i1{131}><i1{132}><i1{133}><i1{134}><i1{135}>",
                          "        <i1{136}><i1{137}><i1{138}><i1{139}><i1{140}><i1{141}><i1{142}><i1{143}>",
                          "        <i1{144}><i1{145}><i1{146}><i1{147}><i1{148}><i1{149}><i1{150}><i1{151}>",
                          "        <i1{152}><i1{153}><i1{154}><i1{155}><i1{156}><i1{157}><i1{158}><i1{159}>",
                          "        <i1{160}><i1{161}><i1{162}><i1{163}><i1{164}><i1{165}><i1{166}><i1{167}>",
                          "        <i1{168}><i1{169}><i1{170}><i1{171}><i1{172}><i1{173}><i1{174}><i1{175}>",
                          "        <i1{176}><i1{177}><i1{178}><i1{179}><i1{180}><i1{181}><i1{182}><i1{183}>",
                          "        <i1{184}><i1{185}><i1{186}><i1{187}><i1{188}><i1{189}><i1{190}><i1{191}>",
                          "        <i1{192}><i1{193}><i1{194}><i1{195}><i1{196}><i1{197}><i1{198}><i1{199}>",
                          "        <i1{200}><i1{201}><i1{202}><i1{203}><i1{204}><i1{205}><i1{206}><i1{207}>",
                          "        <i1{208}><i1{209}><i1{210}><i1{211}><i1{212}><i1{213}><i1{214}><i1{215}>",
                          "        <i1{216}><i1{217}><i1{218}><i1{219}><i1{220}><i1{221}><i1{222}><i1{223}>",
                          "        <i1{224}><i1{225}><i1{226}><i1{227}><i1{228}><i1{229}><i1{230}><i1{231}>",
                          "        <i1{232}><i1{233}><i1{234}><i1{235}><i1{236}><i1{237}><i1{238}><i1{239}>",
                          "        <i1{240}><i1{241}><i1{242}><i1{243}><i1{244}><i1{245}><i1{246}><i1{247}>",
                          "        <i1{248}><i1{249}><i1{250}><i1{251}><i1{252}><i1{253}><i1{254}><i1{255}>",
                          "        <i1{256}><i1{257}><i1{258}><i1{259}><i1{260}><i1{261}><i1{262}><i1{263}>",
                          "        <i1{264}><i1{265}><i1{266}><i1{267}><i1{268}><i1{269}><i1{270}><i1{271}>",
                          "        <i1{272}><i1{273}><i1{274}><i1{275}><i1{276}><i1{277}><i1{278}><i1{279}>",
                          "        <i1{280}><i1{281}><i1{282}><i1{283}><i1{284}><i1{285}><i1{286}><i1{287}>",
                          "        <i1{288}><i1{289}><i1{290}><i1{291}><i1{292}><i1{293}><i1{294}><i1{295}>",
                          "        <i1{296}><i1{297}><i1{298}><i1{299}><i1{300}><i1{301}><i1{302}><i1{303}>",
                          "        <i1{304}><i1{305}><i1{306}><i1{307}><i1{308}><i1{309}><i1{310}><i1{311}>",
                          "        <i1{312}><i1{313}><i1{314}><i1{315}><i1{316}><i1{317}><i1{318}><i1{319}>",
                          "        <i1{320}><i1{321}><i1{322}><i1{323}><i1{324}><i1{325}><i1{326}><i1{327}>",
                          "        <i1{328}><i1{329}><i1{330}><i1{331}><i1{332}><i1{333}><i1{334}><i1{335}>",
                          "        <i1{336}><i1{337}><i1{338}><i1{339}><i1{340}><i1{341}><i1{342}><i1{343}>",
                          "        <i1{344}><i1{345}><i1{346}><i1{347}><i1{348}><i1{349}><i1{350}><i1{351}>",
                          "        <i1{352}><i1{353}><i1{354}><i1{355}><i1{356}><i1{357}><i1{358}><i1{359}>",
                          "        <i1{360}><i1{361}><i1{362}><i1{363}><i1{364}><i1{365}><i1{366}><i1{367}>",
                          "        <i1{368}><i1{369}><i1{370}><i1{371}><i1{372}><i1{373}><i1{374}><i1{375}>",
                          "        <i1{376}><i1{377}><i1{378}><i1{379}><i1{380}><i1{381}><i1{382}><i1{383}>",
                          "        <i1{384}><i1{385}><i1{386}><i1{387}><i1{388}><i1{389}><i1{390}><i1{391}>",
                          "        <i1{392}><i1{393}><i1{394}><i1{395}><i1{396}><i1{397}><i1{398}><i1{399}>",
                          "        <i1{400}><i1{401}><i1{402}><i1{403}><i1{404}><i1{405}><i1{406}><i1{407}>",
                          "        <i1{408}><i1{409}><i1{410}><i1{411}><i1{412}><i1{413}><i1{414}><i1{415}>",
                          "        <i1{416}><i1{417}><i1{418}><i1{419}><i1{420}><i1{421}><i1{422}><i1{423}>",
                          "        <i1{424}><i1{425}><i1{426}><i1{427}><i1{428}><i1{429}><i1{430}><i1{431}>",
                          "        <i1{432}><i1{433}><i1{434}><i1{435}><i1{436}><i1{437}><i1{438}><i1{439}>",
                          "        <i1{440}><i1{441}><i1{442}><i1{443}><i1{444}><i1{445}><i1{446}><i1{447}>",
                          "        <i1{448}><i1{449}><i1{450}><i1{451}><i1{452}><i1{453}><i1{454}><i1{455}>",
                          "        <i1{456}><i1{457}><i1{458}><i1{459}><i1{460}><i1{461}><i1{462}><i1{463}>",
                          "        <i1{464}><i1{465}><i1{466}><i1{467}><i1{468}><i1{469}><i1{470}><i1{471}>",
                          "        <i1{472}><i1{473}><i1{474}><i1{475}><i1{476}><i1{477}><i1{478}><i1{479}>",
                          "        <i1{480}><i1{481}><i1{482}><i1{483}><i1{484}><i1{485}><i1{486}><i1{487}>",
                          "        <i1{488}><i1{489}><i1{490}><i1{491}><i1{492}><i1{493}><i1{494}><i1{495}>",
                          "        <i1{496}><i1{497}><i1{498}><i1{499}><i1{500}><i1{501}><i1{502}><i1{503}>",
                          "        <i1{504}><i1{505}><i1{506}><i1{507}><i1{508}><i1{509}><i1{510}><i1{511}>",
                          "badstrp:<j1{0}  ><j1{1}  ><j1{2}  ><j1{3}  ><j1{4}  ><j1{5}  ><j1{6}  ><j1{7}  >",
                          "        <j1{8}  ><j1{9}  ><j1{10} ><j1{11} ><j1{12} ><j1{13} ><j1{14} ><j1{15} >"};

      strcpy(line, template[0]);
         memset(line + 20, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(ct.Second1996MinorFrame0), ct.MicrosecondMinorFrame0);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", ct.ClockMinorFrame0);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[1]);
         memset(line + 20, (int) ' ', 27);
         sprintf(segmentValue, "%s.%6.6lu", stringDate1996(ct.Second1996MinorFrame1), ct.MicrosecondMinorFrame1);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 50, (int) ' ', 23);
         sprintf(segmentValue, " S/C Clock: %10.10lu ", ct.ClockMinorFrame1);
         memcpy(line + 50, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[2]);
         memset(line + 0, (int) ' ', 19);
         sprintf(segmentValue, " No. echoes: %5u ", ct.NumberCommandEchoes);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[3]);
         memset(line + 62, (int) ' ', 17);
         sprintf(segmentValue, " hyflg: %5ld %2.2x ", expandUint16(ct.hyflg), ct.QualityHyflg);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[4]);
         memset(line + 0, (int) ' ', 19);
         sprintf(segmentValue, " coinmsk: $%4.4lx %2.2x ", expandUint16(ct.coinmsk), ct.QualityCoinmsk);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 19);
         sprintf(segmentValue, " scycflg: %5d %2.2x ", ct.scycflg, ct.QualityScycflg);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 41, (int) ' ', 18);
         sprintf(segmentValue, " rnglim: %5ld %2.2x ", expandUint16(ct.rnglim), ct.QualityRnglim);
         memcpy(line + 41, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 18);
         sprintf(segmentValue, " hetlim: %5ld %2.2x ", expandUint16(ct.hetlim), ct.QualityHetlim);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[5]);
         memset(line + 1, (int) ' ', 18);
         sprintf(segmentValue, " stbfon: %5d %2.2x ", ct.stbfon, ct.QualityStbfon);
         memcpy(line + 1, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 19);
         sprintf(segmentValue, " mtarget: %5ld %2.2x ", expandUint16(ct.mtarget), ct.QualityMtarget);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 40, (int) ' ', 19);
         sprintf(segmentValue, " audgflg: %5d %2.2x ", ct.audgflg, ct.QualityAudgflg);
         memcpy(line + 40, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 18);
         sprintf(segmentValue, " hytlim: %5ld %2.2x ", expandUint16(ct.hytlim), ct.QualityHytlim);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[6]);
         memset(line + 0, (int) ' ', 19);
         sprintf(segmentValue, " leakint: %5ld %2.2x ", expandUint16(ct.leakint), ct.QualityLeakint);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 18);
         sprintf(segmentValue, " mscale: %5ld %2.2x ", expandUint16(ct.mscale), ct.QualityMscale);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 40, (int) ' ', 19);
         sprintf(segmentValue, " audglim: %5ld %2.2x ", expandUint16(ct.audglim), ct.QualityAudglim);
         memcpy(line + 40, segmentValue, strlen(segmentValue));
         memset(line + 61, (int) ' ', 18);
         sprintf(segmentValue, " stmask: $%4.4lx %2.2x ", expandUint16(ct.stmask), ct.QualityStmask);
         memcpy(line + 61, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[7]);
         memset(line + 0, (int) ' ', 19);
         sprintf(segmentValue, " oadjflg: %5d %2.2x ", ct.oadjflg, ct.QualityOadjflg);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 20, (int) ' ', 19);
         sprintf(segmentValue, " aulkflg: %5ld %2.2x ", expandUint16(ct.aulkflg), ct.QualityAulkflg);
         memcpy(line + 20, segmentValue, strlen(segmentValue));
         memset(line + 40, (int) ' ', 19);
         sprintf(segmentValue, " samplim: %5ld %2.2x ", expandUint16(ct.samplim), ct.QualitySamplim);
         memcpy(line + 40, segmentValue, strlen(segmentValue));
         memset(line + 60, (int) ' ', 19);
         sprintf(segmentValue, " stimeid: %5ld %2.2x ", expandUint16(ct.stimeid), ct.QualityStimeid);
         memcpy(line + 60, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[8]);
         memset(line + 0, (int) ' ', 19);
         sprintf(segmentValue, " vrefflg: %5d %2.2x ", ct.vrefflg, ct.QualityVrefflg);
         memcpy(line + 0, segmentValue, strlen(segmentValue));
         memset(line + 21, (int) ' ', 18);
         sprintf(segmentValue, " ttpflg: %5d %2.2x ", ct.ttpflg, ct.QualityTtpflg);
         memcpy(line + 21, segmentValue, strlen(segmentValue));
         memset(line + 42, (int) ' ', 17);
         sprintf(segmentValue, " heflg: %5ld %2.2x ", expandUint16(ct.heflg), ct.QualityHeflg);
         memcpy(line + 42, segmentValue, strlen(segmentValue));
         memset(line + 60, (int) ' ', 19);
         sprintf(segmentValue, " nbadstp: %5ld %2.2x ", expandUint16(ct.nbadstp), ct.QualityNbadstp);
         memcpy(line + 60, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[9]);
         printf("%s\n", line);
      strcpy(line, template[10]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hkbltim[0], ct.QualityHkbltim[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hkbltim[1], ct.QualityHkbltim[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[11]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mbounds[0]), ct.QualityMbounds[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mbounds[1]), ct.QualityMbounds[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[12]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mnav[0]), ct.QualityMnav[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mnav[1]), ct.QualityMnav[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[13]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.claslim[0]), ct.QualityClaslim[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.claslim[1]), ct.QualityClaslim[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[14]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.htcmd[0], ct.QualityHtcmd[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.htcmd[1], ct.QualityHtcmd[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.htcmd[2], ct.QualityHtcmd[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.htcmd[3], ct.QualityHtcmd[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[15]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.ecmd[0], ct.QualityEcmd[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.ecmd[1], ct.QualityEcmd[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[16]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[0]), ct.QualityHiprcmd[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[1]), ct.QualityHiprcmd[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[2]), ct.QualityHiprcmd[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[3]), ct.QualityHiprcmd[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[4]), ct.QualityHiprcmd[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[5]), ct.QualityHiprcmd[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[6]), ct.QualityHiprcmd[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[7]), ct.QualityHiprcmd[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[17]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[8]), ct.QualityHiprcmd[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[9]), ct.QualityHiprcmd[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[10]), ct.QualityHiprcmd[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[11]), ct.QualityHiprcmd[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[12]), ct.QualityHiprcmd[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[13]), ct.QualityHiprcmd[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[14]), ct.QualityHiprcmd[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[15]), ct.QualityHiprcmd[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[18]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[16]), ct.QualityHiprcmd[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[17]), ct.QualityHiprcmd[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[18]), ct.QualityHiprcmd[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[19]), ct.QualityHiprcmd[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[20]), ct.QualityHiprcmd[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[21]), ct.QualityHiprcmd[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[22]), ct.QualityHiprcmd[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[23]), ct.QualityHiprcmd[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[19]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[24]), ct.QualityHiprcmd[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[25]), ct.QualityHiprcmd[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[26]), ct.QualityHiprcmd[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[27]), ct.QualityHiprcmd[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[28]), ct.QualityHiprcmd[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[29]), ct.QualityHiprcmd[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[30]), ct.QualityHiprcmd[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[31]), ct.QualityHiprcmd[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[20]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[32]), ct.QualityHiprcmd[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[33]), ct.QualityHiprcmd[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[34]), ct.QualityHiprcmd[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "  %4.4lx %2.2x", expandUint16(ct.hiprcmd[35]), ct.QualityHiprcmd[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[21]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[0], ct.QualitySdacval[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[1], ct.QualitySdacval[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[2], ct.QualitySdacval[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[3], ct.QualitySdacval[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[4], ct.QualitySdacval[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[5], ct.QualitySdacval[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[6], ct.QualitySdacval[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[7], ct.QualitySdacval[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[22]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[8], ct.QualitySdacval[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[9], ct.QualitySdacval[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[10], ct.QualitySdacval[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[11], ct.QualitySdacval[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[12], ct.QualitySdacval[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[13], ct.QualitySdacval[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[14], ct.QualitySdacval[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[15], ct.QualitySdacval[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[23]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[16], ct.QualitySdacval[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[17], ct.QualitySdacval[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[18], ct.QualitySdacval[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[19], ct.QualitySdacval[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[20], ct.QualitySdacval[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[21], ct.QualitySdacval[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[22], ct.QualitySdacval[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[23], ct.QualitySdacval[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[24]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[24], ct.QualitySdacval[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacval[25], ct.QualitySdacval[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[25]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[0], ct.QualitySdacsiz[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[1], ct.QualitySdacsiz[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[2], ct.QualitySdacsiz[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[3], ct.QualitySdacsiz[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[4], ct.QualitySdacsiz[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[5], ct.QualitySdacsiz[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[6], ct.QualitySdacsiz[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[7], ct.QualitySdacsiz[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[26]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[8], ct.QualitySdacsiz[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[9], ct.QualitySdacsiz[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[10], ct.QualitySdacsiz[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[11], ct.QualitySdacsiz[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[12], ct.QualitySdacsiz[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[13], ct.QualitySdacsiz[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[14], ct.QualitySdacsiz[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[15], ct.QualitySdacsiz[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[27]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[16], ct.QualitySdacsiz[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[17], ct.QualitySdacsiz[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[18], ct.QualitySdacsiz[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[19], ct.QualitySdacsiz[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[20], ct.QualitySdacsiz[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[21], ct.QualitySdacsiz[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[22], ct.QualitySdacsiz[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[23], ct.QualitySdacsiz[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[28]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[24], ct.QualitySdacsiz[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.sdacsiz[25], ct.QualitySdacsiz[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[29]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[0], ct.QualityDacval0[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[1], ct.QualityDacval0[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[2], ct.QualityDacval0[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[3], ct.QualityDacval0[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[4], ct.QualityDacval0[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[5], ct.QualityDacval0[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[6], ct.QualityDacval0[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[7], ct.QualityDacval0[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[30]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[8], ct.QualityDacval0[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[9], ct.QualityDacval0[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[10], ct.QualityDacval0[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[11], ct.QualityDacval0[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[12], ct.QualityDacval0[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[13], ct.QualityDacval0[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[14], ct.QualityDacval0[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[15], ct.QualityDacval0[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[31]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[16], ct.QualityDacval0[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[17], ct.QualityDacval0[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[18], ct.QualityDacval0[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[19], ct.QualityDacval0[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[20], ct.QualityDacval0[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[21], ct.QualityDacval0[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[22], ct.QualityDacval0[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[23], ct.QualityDacval0[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[32]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[24], ct.QualityDacval0[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[25], ct.QualityDacval0[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[26], ct.QualityDacval0[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[27], ct.QualityDacval0[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[28], ct.QualityDacval0[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[29], ct.QualityDacval0[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[30], ct.QualityDacval0[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[31], ct.QualityDacval0[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[33]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[32], ct.QualityDacval0[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[33], ct.QualityDacval0[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[34], ct.QualityDacval0[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[35], ct.QualityDacval0[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[36], ct.QualityDacval0[36]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[37], ct.QualityDacval0[37]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[38], ct.QualityDacval0[38]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[39], ct.QualityDacval0[39]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[34]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[40], ct.QualityDacval0[40]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval0[41], ct.QualityDacval0[41]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[35]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[0], ct.QualityDacsiz0[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[1], ct.QualityDacsiz0[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[2], ct.QualityDacsiz0[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[3], ct.QualityDacsiz0[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[4], ct.QualityDacsiz0[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[5], ct.QualityDacsiz0[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[6], ct.QualityDacsiz0[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[7], ct.QualityDacsiz0[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[36]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[8], ct.QualityDacsiz0[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[9], ct.QualityDacsiz0[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[10], ct.QualityDacsiz0[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[11], ct.QualityDacsiz0[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[12], ct.QualityDacsiz0[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[13], ct.QualityDacsiz0[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[14], ct.QualityDacsiz0[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[15], ct.QualityDacsiz0[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[37]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[16], ct.QualityDacsiz0[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[17], ct.QualityDacsiz0[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[18], ct.QualityDacsiz0[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[19], ct.QualityDacsiz0[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[20], ct.QualityDacsiz0[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[21], ct.QualityDacsiz0[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[22], ct.QualityDacsiz0[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[23], ct.QualityDacsiz0[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[38]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[24], ct.QualityDacsiz0[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[25], ct.QualityDacsiz0[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[26], ct.QualityDacsiz0[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[27], ct.QualityDacsiz0[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[28], ct.QualityDacsiz0[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[29], ct.QualityDacsiz0[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[30], ct.QualityDacsiz0[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[31], ct.QualityDacsiz0[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[39]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[32], ct.QualityDacsiz0[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[33], ct.QualityDacsiz0[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[34], ct.QualityDacsiz0[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[35], ct.QualityDacsiz0[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[36], ct.QualityDacsiz0[36]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[37], ct.QualityDacsiz0[37]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[38], ct.QualityDacsiz0[38]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[39], ct.QualityDacsiz0[39]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[40]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[40], ct.QualityDacsiz0[40]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz0[41], ct.QualityDacsiz0[41]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[41]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[0], ct.QualityDacval1[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[1], ct.QualityDacval1[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[2], ct.QualityDacval1[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[3], ct.QualityDacval1[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[4], ct.QualityDacval1[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dacval1[5], ct.QualityDacval1[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[42]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[0], ct.QualityDacsiz1[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[1], ct.QualityDacsiz1[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[2], ct.QualityDacsiz1[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[3], ct.QualityDacsiz1[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[4], ct.QualityDacsiz1[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.dacsiz1[5], ct.QualityDacsiz1[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[43]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[0], ct.QualityHdisc2[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[1], ct.QualityHdisc2[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[2], ct.QualityHdisc2[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[3], ct.QualityHdisc2[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[4], ct.QualityHdisc2[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[5], ct.QualityHdisc2[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[6], ct.QualityHdisc2[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc2[7], ct.QualityHdisc2[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[44]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[0], ct.QualityHdisc0[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[1], ct.QualityHdisc0[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[2], ct.QualityHdisc0[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[3], ct.QualityHdisc0[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[4], ct.QualityHdisc0[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[5], ct.QualityHdisc0[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[6], ct.QualityHdisc0[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdisc0[7], ct.QualityHdisc0[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[45]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[0], ct.QualityMdisc2[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[1], ct.QualityMdisc2[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[2], ct.QualityMdisc2[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[3], ct.QualityMdisc2[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[4], ct.QualityMdisc2[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[5], ct.QualityMdisc2[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[6], ct.QualityMdisc2[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc2[7], ct.QualityMdisc2[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[46]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[0], ct.QualityMdisc0[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[1], ct.QualityMdisc0[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[2], ct.QualityMdisc0[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[3], ct.QualityMdisc0[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[4], ct.QualityMdisc0[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[5], ct.QualityMdisc0[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[6], ct.QualityMdisc0[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdisc0[7], ct.QualityMdisc0[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[47]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[0], ct.QualityAdcen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[1], ct.QualityAdcen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[2], ct.QualityAdcen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[3], ct.QualityAdcen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[4], ct.QualityAdcen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[5], ct.QualityAdcen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[6], ct.QualityAdcen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.adcen[7], ct.QualityAdcen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[48]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[0], ct.QualityGdiscen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[1], ct.QualityGdiscen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[2], ct.QualityGdiscen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[3], ct.QualityGdiscen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[4], ct.QualityGdiscen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[5], ct.QualityGdiscen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[6], ct.QualityGdiscen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.gdiscen[7], ct.QualityGdiscen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[49]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[0], ct.QualityMdiscen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[1], ct.QualityMdiscen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[2], ct.QualityMdiscen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[3], ct.QualityMdiscen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[4], ct.QualityMdiscen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[5], ct.QualityMdiscen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[6], ct.QualityMdiscen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.mdiscen[7], ct.QualityMdiscen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[50]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[0], ct.QualityHdiscen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[1], ct.QualityHdiscen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[2], ct.QualityHdiscen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[3], ct.QualityHdiscen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[4], ct.QualityHdiscen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[5], ct.QualityHdiscen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[6], ct.QualityHdiscen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.hdiscen[7], ct.QualityHdiscen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[51]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[0], ct.QualityDirbits[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[1], ct.QualityDirbits[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[2], ct.QualityDirbits[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[3], ct.QualityDirbits[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[4], ct.QualityDirbits[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[5], ct.QualityDirbits[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[6], ct.QualityDirbits[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[7], ct.QualityDirbits[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[52]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[8], ct.QualityDirbits[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[9], ct.QualityDirbits[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[10], ct.QualityDirbits[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[11], ct.QualityDirbits[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[12], ct.QualityDirbits[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[13], ct.QualityDirbits[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[14], ct.QualityDirbits[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[15], ct.QualityDirbits[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[53]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[16], ct.QualityDirbits[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[17], ct.QualityDirbits[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[18], ct.QualityDirbits[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[19], ct.QualityDirbits[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[20], ct.QualityDirbits[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[21], ct.QualityDirbits[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[22], ct.QualityDirbits[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[23], ct.QualityDirbits[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[54]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[24], ct.QualityDirbits[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[25], ct.QualityDirbits[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[26], ct.QualityDirbits[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[27], ct.QualityDirbits[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[28], ct.QualityDirbits[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[29], ct.QualityDirbits[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[30], ct.QualityDirbits[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.dirbits[31], ct.QualityDirbits[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[55]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[0], ct.QualityCalen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[1], ct.QualityCalen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[2], ct.QualityCalen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[3], ct.QualityCalen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[4], ct.QualityCalen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[5], ct.QualityCalen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[6], ct.QualityCalen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[7], ct.QualityCalen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[56]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[8], ct.QualityCalen[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[9], ct.QualityCalen[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[10], ct.QualityCalen[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[11], ct.QualityCalen[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[12], ct.QualityCalen[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[13], ct.QualityCalen[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[14], ct.QualityCalen[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[15], ct.QualityCalen[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[57]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[16], ct.QualityCalen[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[17], ct.QualityCalen[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[18], ct.QualityCalen[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[19], ct.QualityCalen[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[20], ct.QualityCalen[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[21], ct.QualityCalen[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[22], ct.QualityCalen[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[23], ct.QualityCalen[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[58]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[24], ct.QualityCalen[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[25], ct.QualityCalen[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[26], ct.QualityCalen[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[27], ct.QualityCalen[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[28], ct.QualityCalen[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[29], ct.QualityCalen[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[30], ct.QualityCalen[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[31], ct.QualityCalen[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[59]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[32], ct.QualityCalen[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[33], ct.QualityCalen[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[34], ct.QualityCalen[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[35], ct.QualityCalen[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[36], ct.QualityCalen[36]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[37], ct.QualityCalen[37]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[38], ct.QualityCalen[38]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[39], ct.QualityCalen[39]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[60]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[40], ct.QualityCalen[40]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[41], ct.QualityCalen[41]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[42], ct.QualityCalen[42]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[43], ct.QualityCalen[43]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[44], ct.QualityCalen[44]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[45], ct.QualityCalen[45]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[46], ct.QualityCalen[46]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[47], ct.QualityCalen[47]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[61]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[48], ct.QualityCalen[48]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[49], ct.QualityCalen[49]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[50], ct.QualityCalen[50]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[51], ct.QualityCalen[51]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[52], ct.QualityCalen[52]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[53], ct.QualityCalen[53]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[54], ct.QualityCalen[54]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[55], ct.QualityCalen[55]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[62]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[56], ct.QualityCalen[56]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[57], ct.QualityCalen[57]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[58], ct.QualityCalen[58]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[59], ct.QualityCalen[59]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[60], ct.QualityCalen[60]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[61], ct.QualityCalen[61]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[62], ct.QualityCalen[62]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.calen[63], ct.QualityCalen[63]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[63]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[0], ct.QualityCompen[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[1], ct.QualityCompen[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[2], ct.QualityCompen[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[3], ct.QualityCompen[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[4], ct.QualityCompen[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[5], ct.QualityCompen[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[6], ct.QualityCompen[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[7], ct.QualityCompen[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[64]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[8], ct.QualityCompen[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[9], ct.QualityCompen[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[10], ct.QualityCompen[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[11], ct.QualityCompen[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[12], ct.QualityCompen[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[13], ct.QualityCompen[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[14], ct.QualityCompen[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[15], ct.QualityCompen[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[65]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[16], ct.QualityCompen[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[17], ct.QualityCompen[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[18], ct.QualityCompen[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[19], ct.QualityCompen[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[20], ct.QualityCompen[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[21], ct.QualityCompen[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[22], ct.QualityCompen[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[23], ct.QualityCompen[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[66]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[24], ct.QualityCompen[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[25], ct.QualityCompen[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[26], ct.QualityCompen[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[27], ct.QualityCompen[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[28], ct.QualityCompen[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[29], ct.QualityCompen[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[30], ct.QualityCompen[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[31], ct.QualityCompen[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[67]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[32], ct.QualityCompen[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[33], ct.QualityCompen[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[34], ct.QualityCompen[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[35], ct.QualityCompen[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[36], ct.QualityCompen[36]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[37], ct.QualityCompen[37]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[38], ct.QualityCompen[38]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[39], ct.QualityCompen[39]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[68]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[40], ct.QualityCompen[40]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[41], ct.QualityCompen[41]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[42], ct.QualityCompen[42]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[43], ct.QualityCompen[43]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[44], ct.QualityCompen[44]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[45], ct.QualityCompen[45]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[46], ct.QualityCompen[46]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[47], ct.QualityCompen[47]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[69]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[48], ct.QualityCompen[48]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[49], ct.QualityCompen[49]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[50], ct.QualityCompen[50]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[51], ct.QualityCompen[51]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[52], ct.QualityCompen[52]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[53], ct.QualityCompen[53]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[54], ct.QualityCompen[54]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[55], ct.QualityCompen[55]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[70]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[56], ct.QualityCompen[56]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[57], ct.QualityCompen[57]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[58], ct.QualityCompen[58]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[59], ct.QualityCompen[59]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[60], ct.QualityCompen[60]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[61], ct.QualityCompen[61]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[62], ct.QualityCompen[62]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.compen[63], ct.QualityCompen[63]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[71]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[0], ct.QualityClasmap[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[1], ct.QualityClasmap[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[2], ct.QualityClasmap[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[3], ct.QualityClasmap[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[4], ct.QualityClasmap[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[5], ct.QualityClasmap[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[6], ct.QualityClasmap[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[7], ct.QualityClasmap[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[72]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[8], ct.QualityClasmap[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[9], ct.QualityClasmap[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[10], ct.QualityClasmap[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[11], ct.QualityClasmap[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[12], ct.QualityClasmap[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[13], ct.QualityClasmap[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[14], ct.QualityClasmap[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[15], ct.QualityClasmap[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[73]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[16], ct.QualityClasmap[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[17], ct.QualityClasmap[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[18], ct.QualityClasmap[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[19], ct.QualityClasmap[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[20], ct.QualityClasmap[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[21], ct.QualityClasmap[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[22], ct.QualityClasmap[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[23], ct.QualityClasmap[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[74]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[24], ct.QualityClasmap[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[25], ct.QualityClasmap[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[26], ct.QualityClasmap[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[27], ct.QualityClasmap[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[28], ct.QualityClasmap[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[29], ct.QualityClasmap[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[30], ct.QualityClasmap[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, "    %2.2x %2.2x", ct.clasmap[31], ct.QualityClasmap[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[75]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.imthresh[0]), ct.QualityImthresh[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.imthresh[1]), ct.QualityImthresh[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.imthresh[2]), ct.QualityImthresh[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.imthresh[3]), ct.QualityImthresh[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[76]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.imflag[0], ct.QualityImflag[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.imflag[1], ct.QualityImflag[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[77]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[0], ct.QualityIm0arr[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[1], ct.QualityIm0arr[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[2], ct.QualityIm0arr[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[3], ct.QualityIm0arr[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[4], ct.QualityIm0arr[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[5], ct.QualityIm0arr[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[6], ct.QualityIm0arr[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[7], ct.QualityIm0arr[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[78]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[8], ct.QualityIm0arr[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[9], ct.QualityIm0arr[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[10], ct.QualityIm0arr[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[11], ct.QualityIm0arr[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[12], ct.QualityIm0arr[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[13], ct.QualityIm0arr[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[14], ct.QualityIm0arr[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[15], ct.QualityIm0arr[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[79]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[16], ct.QualityIm0arr[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[17], ct.QualityIm0arr[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[18], ct.QualityIm0arr[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im0arr[19], ct.QualityIm0arr[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[80]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[0], ct.QualityIm1arr[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[1], ct.QualityIm1arr[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[2], ct.QualityIm1arr[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[3], ct.QualityIm1arr[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[4], ct.QualityIm1arr[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[5], ct.QualityIm1arr[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[6], ct.QualityIm1arr[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[7], ct.QualityIm1arr[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[81]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[8], ct.QualityIm1arr[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[9], ct.QualityIm1arr[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[10], ct.QualityIm1arr[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[11], ct.QualityIm1arr[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[12], ct.QualityIm1arr[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[13], ct.QualityIm1arr[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[14], ct.QualityIm1arr[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[15], ct.QualityIm1arr[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[82]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[16], ct.QualityIm1arr[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[17], ct.QualityIm1arr[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[18], ct.QualityIm1arr[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.im1arr[19], ct.QualityIm1arr[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[83]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.strplim[0], ct.QualityStrplim[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.strplim[1], ct.QualityStrplim[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.strplim[2], ct.QualityStrplim[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.strplim[3], ct.QualityStrplim[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[84]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mcntlim[0]), ct.QualityMcntlim[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mcntlim[1]), ct.QualityMcntlim[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mcntlim[2]), ct.QualityMcntlim[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.mcntlim[3]), ct.QualityMcntlim[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[85]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.anglim[0]), ct.QualityAnglim[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.anglim[1]), ct.QualityAnglim[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[86]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[0]), ct.QualityCnoc1[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[1]), ct.QualityCnoc1[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[2]), ct.QualityCnoc1[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[3]), ct.QualityCnoc1[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[4]), ct.QualityCnoc1[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[5]), ct.QualityCnoc1[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[6]), ct.QualityCnoc1[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc1[7]), ct.QualityCnoc1[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[87]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[0]), ct.QualityCnoc2[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[1]), ct.QualityCnoc2[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[2]), ct.QualityCnoc2[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[3]), ct.QualityCnoc2[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[4]), ct.QualityCnoc2[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[5]), ct.QualityCnoc2[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[6]), ct.QualityCnoc2[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.cnoc2[7]), ct.QualityCnoc2[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[88]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[0], ct.QualityEidmap[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[1], ct.QualityEidmap[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[2], ct.QualityEidmap[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[3], ct.QualityEidmap[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[4], ct.QualityEidmap[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[5], ct.QualityEidmap[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[6], ct.QualityEidmap[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[7], ct.QualityEidmap[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[89]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[8], ct.QualityEidmap[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[9], ct.QualityEidmap[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[10], ct.QualityEidmap[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[11], ct.QualityEidmap[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[12], ct.QualityEidmap[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[13], ct.QualityEidmap[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[14], ct.QualityEidmap[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[15], ct.QualityEidmap[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[90]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[16], ct.QualityEidmap[16]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[17], ct.QualityEidmap[17]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[18], ct.QualityEidmap[18]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[19], ct.QualityEidmap[19]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[20], ct.QualityEidmap[20]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[21], ct.QualityEidmap[21]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[22], ct.QualityEidmap[22]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[23], ct.QualityEidmap[23]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[91]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[24], ct.QualityEidmap[24]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[25], ct.QualityEidmap[25]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[26], ct.QualityEidmap[26]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[27], ct.QualityEidmap[27]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[28], ct.QualityEidmap[28]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[29], ct.QualityEidmap[29]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[30], ct.QualityEidmap[30]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[31], ct.QualityEidmap[31]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[92]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[32], ct.QualityEidmap[32]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[33], ct.QualityEidmap[33]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[34], ct.QualityEidmap[34]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[35], ct.QualityEidmap[35]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[36], ct.QualityEidmap[36]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[37], ct.QualityEidmap[37]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[38], ct.QualityEidmap[38]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[39], ct.QualityEidmap[39]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[93]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[40], ct.QualityEidmap[40]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[41], ct.QualityEidmap[41]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[42], ct.QualityEidmap[42]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[43], ct.QualityEidmap[43]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[44], ct.QualityEidmap[44]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[45], ct.QualityEidmap[45]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[46], ct.QualityEidmap[46]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[47], ct.QualityEidmap[47]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[94]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[48], ct.QualityEidmap[48]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[49], ct.QualityEidmap[49]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[50], ct.QualityEidmap[50]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[51], ct.QualityEidmap[51]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[52], ct.QualityEidmap[52]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[53], ct.QualityEidmap[53]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[54], ct.QualityEidmap[54]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[55], ct.QualityEidmap[55]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[95]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[56], ct.QualityEidmap[56]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[57], ct.QualityEidmap[57]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[58], ct.QualityEidmap[58]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[59], ct.QualityEidmap[59]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[60], ct.QualityEidmap[60]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[61], ct.QualityEidmap[61]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[62], ct.QualityEidmap[62]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[63], ct.QualityEidmap[63]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[96]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[64], ct.QualityEidmap[64]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[65], ct.QualityEidmap[65]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[66], ct.QualityEidmap[66]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[67], ct.QualityEidmap[67]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[68], ct.QualityEidmap[68]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[69], ct.QualityEidmap[69]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[70], ct.QualityEidmap[70]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[71], ct.QualityEidmap[71]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[97]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[72], ct.QualityEidmap[72]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[73], ct.QualityEidmap[73]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[74], ct.QualityEidmap[74]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[75], ct.QualityEidmap[75]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[76], ct.QualityEidmap[76]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[77], ct.QualityEidmap[77]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[78], ct.QualityEidmap[78]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[79], ct.QualityEidmap[79]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[98]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[80], ct.QualityEidmap[80]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[81], ct.QualityEidmap[81]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[82], ct.QualityEidmap[82]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[83], ct.QualityEidmap[83]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[84], ct.QualityEidmap[84]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[85], ct.QualityEidmap[85]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[86], ct.QualityEidmap[86]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[87], ct.QualityEidmap[87]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[99]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[88], ct.QualityEidmap[88]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[89], ct.QualityEidmap[89]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[90], ct.QualityEidmap[90]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[91], ct.QualityEidmap[91]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[92], ct.QualityEidmap[92]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[93], ct.QualityEidmap[93]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[94], ct.QualityEidmap[94]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[95], ct.QualityEidmap[95]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[100]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[96], ct.QualityEidmap[96]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[97], ct.QualityEidmap[97]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[98], ct.QualityEidmap[98]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[99], ct.QualityEidmap[99]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[100], ct.QualityEidmap[100]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[101], ct.QualityEidmap[101]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[102], ct.QualityEidmap[102]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[103], ct.QualityEidmap[103]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[101]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[104], ct.QualityEidmap[104]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[105], ct.QualityEidmap[105]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[106], ct.QualityEidmap[106]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[107], ct.QualityEidmap[107]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[108], ct.QualityEidmap[108]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[109], ct.QualityEidmap[109]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[110], ct.QualityEidmap[110]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[111], ct.QualityEidmap[111]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[102]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[112], ct.QualityEidmap[112]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[113], ct.QualityEidmap[113]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[114], ct.QualityEidmap[114]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[115], ct.QualityEidmap[115]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[116], ct.QualityEidmap[116]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[117], ct.QualityEidmap[117]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[118], ct.QualityEidmap[118]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[119], ct.QualityEidmap[119]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[103]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[120], ct.QualityEidmap[120]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[121], ct.QualityEidmap[121]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[122], ct.QualityEidmap[122]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[123], ct.QualityEidmap[123]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[124], ct.QualityEidmap[124]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[125], ct.QualityEidmap[125]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[126], ct.QualityEidmap[126]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[127], ct.QualityEidmap[127]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[104]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[128], ct.QualityEidmap[128]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[129], ct.QualityEidmap[129]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[130], ct.QualityEidmap[130]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[131], ct.QualityEidmap[131]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[132], ct.QualityEidmap[132]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[133], ct.QualityEidmap[133]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[134], ct.QualityEidmap[134]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[135], ct.QualityEidmap[135]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[105]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[136], ct.QualityEidmap[136]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[137], ct.QualityEidmap[137]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[138], ct.QualityEidmap[138]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[139], ct.QualityEidmap[139]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[140], ct.QualityEidmap[140]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[141], ct.QualityEidmap[141]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[142], ct.QualityEidmap[142]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[143], ct.QualityEidmap[143]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[106]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[144], ct.QualityEidmap[144]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[145], ct.QualityEidmap[145]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[146], ct.QualityEidmap[146]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[147], ct.QualityEidmap[147]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[148], ct.QualityEidmap[148]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[149], ct.QualityEidmap[149]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[150], ct.QualityEidmap[150]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[151], ct.QualityEidmap[151]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[107]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[152], ct.QualityEidmap[152]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[153], ct.QualityEidmap[153]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[154], ct.QualityEidmap[154]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[155], ct.QualityEidmap[155]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[156], ct.QualityEidmap[156]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[157], ct.QualityEidmap[157]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[158], ct.QualityEidmap[158]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[159], ct.QualityEidmap[159]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[108]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[160], ct.QualityEidmap[160]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[161], ct.QualityEidmap[161]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[162], ct.QualityEidmap[162]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[163], ct.QualityEidmap[163]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[164], ct.QualityEidmap[164]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[165], ct.QualityEidmap[165]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[166], ct.QualityEidmap[166]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[167], ct.QualityEidmap[167]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[109]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[168], ct.QualityEidmap[168]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[169], ct.QualityEidmap[169]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[170], ct.QualityEidmap[170]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[171], ct.QualityEidmap[171]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[172], ct.QualityEidmap[172]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[173], ct.QualityEidmap[173]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[174], ct.QualityEidmap[174]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[175], ct.QualityEidmap[175]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[110]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[176], ct.QualityEidmap[176]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[177], ct.QualityEidmap[177]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[178], ct.QualityEidmap[178]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[179], ct.QualityEidmap[179]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[180], ct.QualityEidmap[180]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[181], ct.QualityEidmap[181]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[182], ct.QualityEidmap[182]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[183], ct.QualityEidmap[183]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[111]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[184], ct.QualityEidmap[184]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[185], ct.QualityEidmap[185]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[186], ct.QualityEidmap[186]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[187], ct.QualityEidmap[187]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[188], ct.QualityEidmap[188]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[189], ct.QualityEidmap[189]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[190], ct.QualityEidmap[190]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[191], ct.QualityEidmap[191]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[112]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[192], ct.QualityEidmap[192]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[193], ct.QualityEidmap[193]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[194], ct.QualityEidmap[194]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[195], ct.QualityEidmap[195]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[196], ct.QualityEidmap[196]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[197], ct.QualityEidmap[197]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[198], ct.QualityEidmap[198]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[199], ct.QualityEidmap[199]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[113]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[200], ct.QualityEidmap[200]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[201], ct.QualityEidmap[201]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[202], ct.QualityEidmap[202]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[203], ct.QualityEidmap[203]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[204], ct.QualityEidmap[204]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[205], ct.QualityEidmap[205]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[206], ct.QualityEidmap[206]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[207], ct.QualityEidmap[207]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[114]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[208], ct.QualityEidmap[208]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[209], ct.QualityEidmap[209]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[210], ct.QualityEidmap[210]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[211], ct.QualityEidmap[211]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[212], ct.QualityEidmap[212]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[213], ct.QualityEidmap[213]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[214], ct.QualityEidmap[214]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[215], ct.QualityEidmap[215]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[115]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[216], ct.QualityEidmap[216]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[217], ct.QualityEidmap[217]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[218], ct.QualityEidmap[218]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[219], ct.QualityEidmap[219]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[220], ct.QualityEidmap[220]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[221], ct.QualityEidmap[221]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[222], ct.QualityEidmap[222]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[223], ct.QualityEidmap[223]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[116]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[224], ct.QualityEidmap[224]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[225], ct.QualityEidmap[225]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[226], ct.QualityEidmap[226]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[227], ct.QualityEidmap[227]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[228], ct.QualityEidmap[228]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[229], ct.QualityEidmap[229]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[230], ct.QualityEidmap[230]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[231], ct.QualityEidmap[231]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[117]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[232], ct.QualityEidmap[232]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[233], ct.QualityEidmap[233]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[234], ct.QualityEidmap[234]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[235], ct.QualityEidmap[235]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[236], ct.QualityEidmap[236]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[237], ct.QualityEidmap[237]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[238], ct.QualityEidmap[238]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[239], ct.QualityEidmap[239]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[118]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[240], ct.QualityEidmap[240]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[241], ct.QualityEidmap[241]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[242], ct.QualityEidmap[242]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[243], ct.QualityEidmap[243]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[244], ct.QualityEidmap[244]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[245], ct.QualityEidmap[245]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[246], ct.QualityEidmap[246]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[247], ct.QualityEidmap[247]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[119]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[248], ct.QualityEidmap[248]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[249], ct.QualityEidmap[249]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[250], ct.QualityEidmap[250]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[251], ct.QualityEidmap[251]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[252], ct.QualityEidmap[252]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[253], ct.QualityEidmap[253]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[254], ct.QualityEidmap[254]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[255], ct.QualityEidmap[255]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[120]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[256], ct.QualityEidmap[256]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[257], ct.QualityEidmap[257]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[258], ct.QualityEidmap[258]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[259], ct.QualityEidmap[259]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[260], ct.QualityEidmap[260]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[261], ct.QualityEidmap[261]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[262], ct.QualityEidmap[262]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[263], ct.QualityEidmap[263]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[121]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[264], ct.QualityEidmap[264]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[265], ct.QualityEidmap[265]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[266], ct.QualityEidmap[266]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[267], ct.QualityEidmap[267]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[268], ct.QualityEidmap[268]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[269], ct.QualityEidmap[269]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[270], ct.QualityEidmap[270]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[271], ct.QualityEidmap[271]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[122]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[272], ct.QualityEidmap[272]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[273], ct.QualityEidmap[273]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[274], ct.QualityEidmap[274]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[275], ct.QualityEidmap[275]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[276], ct.QualityEidmap[276]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[277], ct.QualityEidmap[277]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[278], ct.QualityEidmap[278]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[279], ct.QualityEidmap[279]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[123]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[280], ct.QualityEidmap[280]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[281], ct.QualityEidmap[281]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[282], ct.QualityEidmap[282]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[283], ct.QualityEidmap[283]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[284], ct.QualityEidmap[284]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[285], ct.QualityEidmap[285]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[286], ct.QualityEidmap[286]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[287], ct.QualityEidmap[287]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[124]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[288], ct.QualityEidmap[288]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[289], ct.QualityEidmap[289]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[290], ct.QualityEidmap[290]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[291], ct.QualityEidmap[291]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[292], ct.QualityEidmap[292]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[293], ct.QualityEidmap[293]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[294], ct.QualityEidmap[294]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[295], ct.QualityEidmap[295]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[125]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[296], ct.QualityEidmap[296]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[297], ct.QualityEidmap[297]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[298], ct.QualityEidmap[298]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[299], ct.QualityEidmap[299]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[300], ct.QualityEidmap[300]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[301], ct.QualityEidmap[301]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[302], ct.QualityEidmap[302]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[303], ct.QualityEidmap[303]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[126]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[304], ct.QualityEidmap[304]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[305], ct.QualityEidmap[305]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[306], ct.QualityEidmap[306]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[307], ct.QualityEidmap[307]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[308], ct.QualityEidmap[308]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[309], ct.QualityEidmap[309]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[310], ct.QualityEidmap[310]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[311], ct.QualityEidmap[311]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[127]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[312], ct.QualityEidmap[312]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[313], ct.QualityEidmap[313]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[314], ct.QualityEidmap[314]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[315], ct.QualityEidmap[315]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[316], ct.QualityEidmap[316]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[317], ct.QualityEidmap[317]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[318], ct.QualityEidmap[318]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[319], ct.QualityEidmap[319]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[128]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[320], ct.QualityEidmap[320]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[321], ct.QualityEidmap[321]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[322], ct.QualityEidmap[322]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[323], ct.QualityEidmap[323]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[324], ct.QualityEidmap[324]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[325], ct.QualityEidmap[325]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[326], ct.QualityEidmap[326]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[327], ct.QualityEidmap[327]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[129]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[328], ct.QualityEidmap[328]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[329], ct.QualityEidmap[329]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[330], ct.QualityEidmap[330]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[331], ct.QualityEidmap[331]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[332], ct.QualityEidmap[332]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[333], ct.QualityEidmap[333]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[334], ct.QualityEidmap[334]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[335], ct.QualityEidmap[335]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[130]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[336], ct.QualityEidmap[336]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[337], ct.QualityEidmap[337]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[338], ct.QualityEidmap[338]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[339], ct.QualityEidmap[339]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[340], ct.QualityEidmap[340]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[341], ct.QualityEidmap[341]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[342], ct.QualityEidmap[342]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[343], ct.QualityEidmap[343]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[131]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[344], ct.QualityEidmap[344]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[345], ct.QualityEidmap[345]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[346], ct.QualityEidmap[346]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[347], ct.QualityEidmap[347]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[348], ct.QualityEidmap[348]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[349], ct.QualityEidmap[349]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[350], ct.QualityEidmap[350]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[351], ct.QualityEidmap[351]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[132]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[352], ct.QualityEidmap[352]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[353], ct.QualityEidmap[353]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[354], ct.QualityEidmap[354]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[355], ct.QualityEidmap[355]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[356], ct.QualityEidmap[356]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[357], ct.QualityEidmap[357]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[358], ct.QualityEidmap[358]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[359], ct.QualityEidmap[359]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[133]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[360], ct.QualityEidmap[360]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[361], ct.QualityEidmap[361]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[362], ct.QualityEidmap[362]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[363], ct.QualityEidmap[363]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[364], ct.QualityEidmap[364]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[365], ct.QualityEidmap[365]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[366], ct.QualityEidmap[366]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[367], ct.QualityEidmap[367]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[134]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[368], ct.QualityEidmap[368]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[369], ct.QualityEidmap[369]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[370], ct.QualityEidmap[370]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[371], ct.QualityEidmap[371]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[372], ct.QualityEidmap[372]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[373], ct.QualityEidmap[373]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[374], ct.QualityEidmap[374]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[375], ct.QualityEidmap[375]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[135]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[376], ct.QualityEidmap[376]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[377], ct.QualityEidmap[377]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[378], ct.QualityEidmap[378]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[379], ct.QualityEidmap[379]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[380], ct.QualityEidmap[380]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[381], ct.QualityEidmap[381]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[382], ct.QualityEidmap[382]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[383], ct.QualityEidmap[383]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[136]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[384], ct.QualityEidmap[384]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[385], ct.QualityEidmap[385]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[386], ct.QualityEidmap[386]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[387], ct.QualityEidmap[387]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[388], ct.QualityEidmap[388]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[389], ct.QualityEidmap[389]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[390], ct.QualityEidmap[390]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[391], ct.QualityEidmap[391]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[137]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[392], ct.QualityEidmap[392]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[393], ct.QualityEidmap[393]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[394], ct.QualityEidmap[394]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[395], ct.QualityEidmap[395]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[396], ct.QualityEidmap[396]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[397], ct.QualityEidmap[397]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[398], ct.QualityEidmap[398]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[399], ct.QualityEidmap[399]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[138]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[400], ct.QualityEidmap[400]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[401], ct.QualityEidmap[401]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[402], ct.QualityEidmap[402]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[403], ct.QualityEidmap[403]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[404], ct.QualityEidmap[404]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[405], ct.QualityEidmap[405]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[406], ct.QualityEidmap[406]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[407], ct.QualityEidmap[407]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[139]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[408], ct.QualityEidmap[408]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[409], ct.QualityEidmap[409]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[410], ct.QualityEidmap[410]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[411], ct.QualityEidmap[411]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[412], ct.QualityEidmap[412]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[413], ct.QualityEidmap[413]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[414], ct.QualityEidmap[414]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[415], ct.QualityEidmap[415]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[140]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[416], ct.QualityEidmap[416]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[417], ct.QualityEidmap[417]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[418], ct.QualityEidmap[418]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[419], ct.QualityEidmap[419]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[420], ct.QualityEidmap[420]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[421], ct.QualityEidmap[421]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[422], ct.QualityEidmap[422]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[423], ct.QualityEidmap[423]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[141]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[424], ct.QualityEidmap[424]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[425], ct.QualityEidmap[425]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[426], ct.QualityEidmap[426]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[427], ct.QualityEidmap[427]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[428], ct.QualityEidmap[428]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[429], ct.QualityEidmap[429]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[430], ct.QualityEidmap[430]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[431], ct.QualityEidmap[431]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[142]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[432], ct.QualityEidmap[432]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[433], ct.QualityEidmap[433]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[434], ct.QualityEidmap[434]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[435], ct.QualityEidmap[435]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[436], ct.QualityEidmap[436]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[437], ct.QualityEidmap[437]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[438], ct.QualityEidmap[438]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[439], ct.QualityEidmap[439]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[143]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[440], ct.QualityEidmap[440]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[441], ct.QualityEidmap[441]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[442], ct.QualityEidmap[442]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[443], ct.QualityEidmap[443]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[444], ct.QualityEidmap[444]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[445], ct.QualityEidmap[445]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[446], ct.QualityEidmap[446]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[447], ct.QualityEidmap[447]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[144]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[448], ct.QualityEidmap[448]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[449], ct.QualityEidmap[449]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[450], ct.QualityEidmap[450]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[451], ct.QualityEidmap[451]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[452], ct.QualityEidmap[452]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[453], ct.QualityEidmap[453]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[454], ct.QualityEidmap[454]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[455], ct.QualityEidmap[455]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[145]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[456], ct.QualityEidmap[456]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[457], ct.QualityEidmap[457]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[458], ct.QualityEidmap[458]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[459], ct.QualityEidmap[459]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[460], ct.QualityEidmap[460]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[461], ct.QualityEidmap[461]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[462], ct.QualityEidmap[462]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[463], ct.QualityEidmap[463]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[146]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[464], ct.QualityEidmap[464]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[465], ct.QualityEidmap[465]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[466], ct.QualityEidmap[466]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[467], ct.QualityEidmap[467]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[468], ct.QualityEidmap[468]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[469], ct.QualityEidmap[469]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[470], ct.QualityEidmap[470]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[471], ct.QualityEidmap[471]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[147]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[472], ct.QualityEidmap[472]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[473], ct.QualityEidmap[473]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[474], ct.QualityEidmap[474]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[475], ct.QualityEidmap[475]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[476], ct.QualityEidmap[476]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[477], ct.QualityEidmap[477]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[478], ct.QualityEidmap[478]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[479], ct.QualityEidmap[479]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[148]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[480], ct.QualityEidmap[480]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[481], ct.QualityEidmap[481]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[482], ct.QualityEidmap[482]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[483], ct.QualityEidmap[483]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[484], ct.QualityEidmap[484]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[485], ct.QualityEidmap[485]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[486], ct.QualityEidmap[486]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[487], ct.QualityEidmap[487]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[149]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[488], ct.QualityEidmap[488]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[489], ct.QualityEidmap[489]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[490], ct.QualityEidmap[490]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[491], ct.QualityEidmap[491]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[492], ct.QualityEidmap[492]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[493], ct.QualityEidmap[493]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[494], ct.QualityEidmap[494]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[495], ct.QualityEidmap[495]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[150]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[496], ct.QualityEidmap[496]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[497], ct.QualityEidmap[497]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[498], ct.QualityEidmap[498]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[499], ct.QualityEidmap[499]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[500], ct.QualityEidmap[500]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[501], ct.QualityEidmap[501]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[502], ct.QualityEidmap[502]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[503], ct.QualityEidmap[503]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[151]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[504], ct.QualityEidmap[504]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[505], ct.QualityEidmap[505]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[506], ct.QualityEidmap[506]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[507], ct.QualityEidmap[507]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[508], ct.QualityEidmap[508]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[509], ct.QualityEidmap[509]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[510], ct.QualityEidmap[510]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5u %2.2x", ct.eidmap[511], ct.QualityEidmap[511]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[152]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[0]), ct.QualityBadstrp[0]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[1]), ct.QualityBadstrp[1]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[2]), ct.QualityBadstrp[2]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[3]), ct.QualityBadstrp[3]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[4]), ct.QualityBadstrp[4]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[5]), ct.QualityBadstrp[5]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[6]), ct.QualityBadstrp[6]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[7]), ct.QualityBadstrp[7]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
      strcpy(line, template[153]);
         memset(line + 8, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[8]), ct.QualityBadstrp[8]);
         memcpy(line + 8, segmentValue, strlen(segmentValue));
         memset(line + 17, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[9]), ct.QualityBadstrp[9]);
         memcpy(line + 17, segmentValue, strlen(segmentValue));
         memset(line + 26, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[10]), ct.QualityBadstrp[10]);
         memcpy(line + 26, segmentValue, strlen(segmentValue));
         memset(line + 35, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[11]), ct.QualityBadstrp[11]);
         memcpy(line + 35, segmentValue, strlen(segmentValue));
         memset(line + 44, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[12]), ct.QualityBadstrp[12]);
         memcpy(line + 44, segmentValue, strlen(segmentValue));
         memset(line + 53, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[13]), ct.QualityBadstrp[13]);
         memcpy(line + 53, segmentValue, strlen(segmentValue));
         memset(line + 62, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[14]), ct.QualityBadstrp[14]);
         memcpy(line + 62, segmentValue, strlen(segmentValue));
         memset(line + 71, (int) ' ', 9);
         sprintf(segmentValue, " %5ld %2.2x", expandUint16(ct.badstrp[15]), ct.QualityBadstrp[15]);
         memcpy(line + 71, segmentValue, strlen(segmentValue));
         printf("%s\n", line);
   }

#endif
